/**************************************************************************
*   Copyright (C) 2005 by Achal Dhir                                      *
*   achaldhir@gmail.com                                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
// dualserver.cpp ///
#include <string>
#include <math.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <limits.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <net/if.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <memory.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <syslog.h>
#include <pthread.h>
#include <map>
using namespace std;
#include "dualserverd.h"

//Global Variables
data1 network;
data1 newNetwork;
data2 cfig;
bool verbatim = false;
data9 dhcpr;
data9 token;
data5 dnsr;
MYBYTE currentInd = 0;
MYBYTE newInd = 0;
bool kRunning = true;
hostMap dnsCache[2];
expiryMap dnsAge[2];
dhcpMap dhcpCache;
//expiryMap dhcpAge;
char tempbuff[512] = "";
char extbuff[512];
char logBuff[256] = "";
char iniFile[256] = "";
char leaFile[256] = "";
char logFile[256] = "";
char filePATH[256] = "";
char arpa[] = ".in-addr.arpa";
char ip6arpa[] = ".ip6.arpa";
bool dhcpService = true;
bool dnsService = true;
time_t t = time(NULL);
timeval tv;
fd_set readfds;
fd_set writefds;
pthread_mutex_t mutStateFile = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t mutLogFile = PTHREAD_MUTEX_INITIALIZER;
struct ifconf Ifc;
struct ifreq IfcBuf[MAX_SERVERS];

//constants
const char NBSP = 32;
const char RANGESET[] = "RANGE_SET";
const char GLOBALOPTIONS[] = "GLOBAL_OPTIONS";
const char base64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
const char send200[] = "HTTP/1.1 200 OK\r\nDate: %s\r\nLast-Modified: %s\r\nContent-Type: text/html\r\nConnection: Close\r\nContent-Length:         \r\n\r\n";
//const char send200[] = "HTTP/1.1 200 OK\r\nDate: %s\r\nLast-Modified: %s\r\nContent-Type: text/html\r\nConnection: Close\r\nTransfer-Encoding: chunked\r\n";
//const char send403[] = "HTTP/1.1 403 Forbidden\r\nDate: %s\r\nLast-Modified: %s\r\nContent-Type: text/html\r\nConnection: Close\r\n\r\n";
const char send403[] = "HTTP/1.1 403 Forbidden\r\n\r\n<h1>403 Forbidden</h1>";
const char send404[] = "HTTP/1.1 404 Not Found\r\n\r\n<h1>404 Not Found</h1>";
const char td200[] = "<td>%s</td>";
const char sVersion[] = "Dual DHCP DNS Server Version 7.02 Linux Build 7019";
//const char toprow[] = "<body bgcolor=\"#cccccc\"><table width=\"800\"><tr><td align=\"center\"><font size=\"5\"><b>%s</b></font></b></b></td></tr><tr><td align=\"right\"><a target=\"_new\" href=\"http://dhcp-dns-server.sourceforge.net/\">http://dhcp-dns-server.sourceforge.net/</b></b></td></tr></table>";
const char toprow[] = "<body bgcolor=\"#cccccc\"><table width=640><tr><td align=\"center\"><font size=\"5\"><b>%s</b></font></td></tr><tr><td align=\"right\"><a target=\"_new\" href=\"http://dhcp-dns-server.sourceforge.net\">http://dhcp-dns-server.sourceforge.net</td></tr></table>";
const data4 opData[] =
    {
		{ "SubnetMask", 1, 3 , 1},
		{ "TimeOffset", 2, 4 , 1},
		{ "Router", 3, 3 , 1},
		{ "TimeServer", 4, 3 , 1},
		{ "NameServer", 5, 3 , 1},
		{ "DomainServer", 6, 3 , 1},
		{ "LogServer", 7, 3 , 1},
		{ "QuotesServer", 8, 3 , 1},
		{ "LPRServer", 9, 3 , 1},
		{ "ImpressServer", 10, 3 , 1},
		{ "RLPServer", 11, 3, 1},
		{ "Hostname", 12, 1, 1},
		{ "BootFileSize", 13, 5 , 1},
		{ "MeritDumpFile", 14, 1 , 1},
		{ "DomainName", 15, 1 , 1},
		{ "SwapServer", 16, 3 , 1},
		{ "RootPath", 17, 1 , 1},
		{ "ExtensionFile", 18, 1 , 1},
		{ "ForwardOn/Off", 19, 7 , 1},
		{ "SrcRteOn/Off", 20, 7 , 1},
		{ "PolicyFilter", 21, 8 , 1},
		{ "MaxDGAssembly", 22, 5 , 1},
		{ "DefaultIPTTL", 23, 6 , 1},
		{ "MTUTimeout", 24, 4 , 1},
		{ "MTUPlateau", 25, 2 , 1},
		{ "MTUInterface", 26, 5 , 1},
		{ "MTUSubnet", 27, 7 , 1},
		{ "BroadcastAddress", 28, 3 , 1},
		{ "MaskDiscovery", 29, 7 , 1},
		{ "MaskSupplier", 30, 7 , 1},
		{ "RouterDiscovery", 31, 7 , 1},
		{ "RouterRequest", 32, 3 , 1},
		{ "StaticRoute", 33, 8 , 1},
		{ "Trailers", 34, 7 , 1},
		{ "ARPTimeout", 35, 4 , 1},
		{ "Ethernet", 36, 7 , 1},
		{ "DefaultTCPTTL", 37, 6 , 1},
		{ "KeepaliveTime", 38, 4 , 1},
		{ "KeepaliveData", 39, 7 , 1},
		{ "NISDomain", 40, 1 , 1},
		{ "NISServers", 41, 3 , 1},
		{ "NTPServers", 42, 3 , 1},
		{ "VendorSpecificInf", 43, 2 , 0},
		{ "NETBIOSNameSrv", 44, 3 , 1},
		{ "NETBIOSDistSrv", 45, 3 , 1},
		{ "NETBIOSNodeType", 46, 6 , 1},
		{ "NETBIOSScope", 47, 1 , 1},
		{ "XWindowFont", 48, 1 , 1},
		{ "XWindowManager", 49, 3 , 1},
		{ "AddressRequest", 50, 3, 0},
		{ "AddressTime", 51, 4 , 1},
		{ "OverLoad", 52, 7, 0},
		{ "DHCPMsgType", 53, 6, 0},
		{ "DHCPServerId", 54, 3, 0},
		{ "ParameterList", 55, 2 , 0},
		{ "DHCPMessage", 56, 1, 0},
		{ "DHCPMaxMsgSize", 57, 5, 0},
		{ "RenewalTime", 58, 4 , 1},
		{ "RebindingTime", 59, 4 , 1},
		{ "ClassId", 60, 1, 0},
		{ "ClientId", 61, 2, 0},
		{ "NetWareIPDomain", 62, 1 , 1},
		{ "NetWareIPOption", 63, 2 , 1},
		{ "NISDomainName", 64, 1 , 1},
		{ "NISServerAddr", 65, 3 , 1},
		{ "TFTPServerName", 66, 1 , 1},
		{ "BootFileOption", 67, 1 , 1},
		{ "HomeAgentAddrs", 68, 3 , 1},
		{ "SMTPServer", 69, 3 , 1},
		{ "POP3Server", 70, 3 , 1},
		{ "NNTPServer", 71, 3 , 1},
		{ "WWWServer", 72, 3 , 1},
		{ "FingerServer", 73, 3 , 1},
		{ "IRCServer", 74, 3 , 1},
		{ "StreetTalkServer", 75, 3 , 1},
		{ "STDAServer", 76, 3 , 1},
		{ "UserClass", 77, 1, 0},
		{ "DirectoryAgent", 78, 1 , 1},
		{ "ServiceScope", 79, 1 , 1},
		{ "RapidCommit", 80, 2, 0},
		{ "ClientFQDN", 81, 2, 0},
		{ "RelayAgentInformation", 82, 2, 0},
		{ "iSNS", 83, 1 , 1},
		{ "NDSServers", 85, 3 , 1},
		{ "NDSTreeName", 86, 1 , 1},
		{ "NDSContext", 87, 1 , 1},
		{ "LDAP", 95, 1 , 1},
		{ "PCode", 100, 1 , 1},
		{ "TCode", 101, 1 , 1},
		{ "NetInfoAddress", 112, 3 , 1},
		{ "NetInfoTag", 113, 1 , 1},
		{ "URL", 114, 1 , 1},
		{ "AutoConfig", 116, 7 , 1},
		{ "NameServiceSearch", 117, 2 , 1},
		{ "SubnetSelectionOption", 118, 3 , 1},
		{ "DomainSearch", 119, 1 , 1},
		{ "SIPServersDHCPOption", 120, 1 , 1},
		{ "121", 121, 1 , 1},
		{ "CCC", 122, 1 , 1},
		{ "TFTPServerIPaddress", 128, 3 , 1},
		{ "CallServerIPaddress", 129, 3 , 1},
		{ "DiscriminationString", 130, 1 , 1},
		{ "RemoteStatisticsServerIPAddress", 131, 3 , 1},
		{ "HTTPProxyPhone", 135, 3 , 1},
		{ "OPTION_CAPWAP_AC_V4", 138, 1 , 1},
		{ "OPTIONIPv4_AddressMoS", 139, 1 , 1},
		{ "OPTIONIPv4_FQDNMoS", 140, 1 , 1},
		{ "SIPUAServiceDomains", 141, 1 , 1},
		{ "OPTIONIPv4_AddressANDSF", 142, 1 , 1},
		{ "IPTelephone", 176, 1 , 1},
		{ "ConfigurationFile", 209, 1 , 1},
		{ "PathPrefix", 210, 1 , 1},
		{ "RebootTime", 211, 4 , 1},
		{ "OPTION_6RD", 212, 1 , 1},
		{ "OPTION_V4_ACCESS_DOMAIN", 213, 1 , 1},
		{ "BootFileName", 253, 1 , 1},
        { "NextServer", 254, 3, 1},
    };

int main(int argc, char **argv)
{
    signal(SIGINT, catch_int);
    signal(SIGABRT, catch_int);
    signal(SIGTERM, catch_int);
    signal(SIGQUIT, catch_int);
    signal(SIGTSTP, catch_int);
    signal(SIGHUP, catch_int);

    //printf("%i\n", argc);

	logBuff[0] = 0;
/*
	char *ds = strrchr(argv[0], '/');

	if (ds)
		ds++;
	else
		ds = argv[0];

	sprintf(tempbuff, "ps -e | grep \" %s$\" | awk '{ print $1 }'", ds, ds);
	FILE *p = popen(tempbuff,"r");

	if (p)
	{
		while (fgets(tempbuff, sizeof(tempbuff), p))
		{
			if (atoi(tempbuff) != getpid())
			{
				sprintf(logBuff, "Error: %s is already running, Pid = %s", ds, tempbuff);
				break;
			}
		}
		pclose(p);
	}
*/
    for (int i = 1; i < argc; i++)
    {
        if (!strcasecmp(argv[i], "-v"))
            verbatim = true;
        else if (!strcmp(argv[i], "-i") && argc > i + 1 && argv[i + 1][0] != '-' )
        {
            myTrim(iniFile, argv[i + 1]);
            i++;
        }
        else if (!strcmp(argv[i], "-s") && argc > i + 1 && argv[i + 1][0] != '-' )
        {
            myTrim(leaFile, argv[i + 1]);
            i++;
        }
        else if (!strcmp(argv[i], "-l") && argc > i + 1 && argv[i + 1][0] != '-' )
        {
            myTrim(logFile, argv[i + 1]);
            i++;
        }
        else if (!strncasecmp(argv[i], "-i", 2))
            myTrim(iniFile, argv[i] + 2);
        else if (!strncasecmp(argv[i], "-s", 2))
            myTrim(leaFile, argv[i] + 2);
        else if (!strncasecmp(argv[i], "-l", 2))
            myTrim(logFile, argv[i] + 2);
        else
            sprintf(logBuff, "Error: Invalid Argument %s", argv[i]);
    }

    if (!leaFile[0])
        strcpy(leaFile, "/tmp/dualserver.state");

    if (!iniFile[0])
        strcpy(iniFile, "/etc/dualserver.ini");

    strcpy(filePATH, iniFile);

    if (strrchr(filePATH, '/'))
    {
		char *fileExt = strrchr(filePATH, '/');
		fileExt++;
		*fileExt = 0;
	}

    if (verbatim)
    {
		if (logBuff[0])
		{
			printf("%s\n", logBuff);
			exit(EXIT_FAILURE);
		}

        if (getuid())
        {
        	printf("Error: Only root should run this program\n");
			exit(EXIT_FAILURE);
        }

        //printf("%i\n",sizeof(data7));
	    memset(&cfig, 0, sizeof(cfig));
        cfig.ppid = getpid();
		pthread_t threadId;
		pthread_attr_t attr;
		pthread_attr_init(&attr);
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		int errcode = pthread_create(&threadId, &attr, init, NULL);
		pthread_attr_destroy(&attr);

		if(errcode)
		{
			printf("init thread Creation Failed");
			exit(EXIT_FAILURE);
		}

		while (true)
		{
			if (!network.dhcpConn[0].ready && !network.dnsUdpConn[0].ready)
			{
				sleep(1);
				continue;
			}

			if (!network.ready)
			{
				sleep(1);
				continue;
			}

			FD_ZERO(&readfds);
			tv.tv_sec = 20;
			tv.tv_usec = 0;

			if (dhcpService)
			{
				if (network.httpConn.ready)
					FD_SET(network.httpConn.sock, &readfds);

				for (int i = 0; i < MAX_SERVERS && network.dhcpConn[i].ready; i++)
					FD_SET(network.dhcpConn[i].sock, &readfds);

				if (network.dhcpListener.ready)
					FD_SET(network.dhcpListener.sock, &readfds);

				if (cfig.dhcpReplConn.ready)
					FD_SET(cfig.dhcpReplConn.sock, &readfds);
			}

			if (dnsService)
			{
				for (int i = 0; i < MAX_SERVERS && network.dnsUdpConn[i].ready; i++)
					FD_SET(network.dnsUdpConn[i].sock, &readfds);

				if (network.forwConn.ready)
					FD_SET(network.forwConn.sock, &readfds);

				for (int i = 0; i < MAX_SERVERS && network.dnsTcpConn[i].ready; i++)
					FD_SET(network.dnsTcpConn[i].sock, &readfds);
			}

			//printf("%i\n",select(network.maxFD, &readfds, NULL, NULL, &tv));
			if (select(network.maxFD, &readfds, NULL, NULL, &tv))
			{
				t = time(NULL);

				if (dhcpService)
				{
					if (network.httpConn.ready && FD_ISSET(network.httpConn.sock, &readfds))
					{
						data19 *req = (data19*)calloc(1, sizeof(data19));

						if (req)
						{
							req->sockLen = sizeof(req->remote);
							errno = 0;
							req->sock = accept(network.httpConn.sock, (sockaddr*)&req->remote, &req->sockLen);

							if (req->sock == INVALID_SOCKET)
							{
								sprintf(logBuff, "Accept Failed, Error: %s", strerror(errno));
								logMess(logBuff, 1);
								free(req);
							}
							else
								procHTTP(req);
						}
						else
						{
							sprintf(logBuff, "Memory Error");
							logMess(logBuff, 0);
						}
					}

					if (cfig.dhcpReplConn.ready && FD_ISSET(cfig.dhcpReplConn.sock, &readfds))
					{
						//printf("Repl\n");
						dhcpr.sockLen = sizeof(dhcpr.remote);

						dhcpr.bytes = recvfrom(cfig.dhcpReplConn.sock,
											   dhcpr.raw,
											   sizeof(dhcpr.raw),
											   0,
											   (sockaddr*)&dhcpr.remote,
											   &dhcpr.sockLen);

						if (errno || dhcpr.bytes <= 0)
							cfig.dhcpRepl = 0;
					}

					for (int i = 0; i < MAX_SERVERS && network.dhcpConn[i].ready; i++)
					{
						if (FD_ISSET(network.dhcpConn[i].sock, &readfds) && gdmess(&dhcpr, i) && sdmess(&dhcpr))
							alad(&dhcpr);
					}

					if (network.dhcpListener.ready && FD_ISSET(network.dhcpListener.sock, &readfds) && gdmess(&dhcpr, 255) && sdmess(&dhcpr))
						alad(&dhcpr);
				}

				if (dnsService)
				{
					for (int i = 0; i < MAX_SERVERS && network.dnsUdpConn[i].ready; i++)
					{
						if (FD_ISSET(network.dnsUdpConn[i].sock, &readfds) && gdnmess(&dnsr, i))
						{
							if (dnsr.dnsp->header.rcode == RCODE_NOTIMPL || dnsr.dnsp->header.rcode == RCODE_REFUSED)
							{
								sdnmess(&dnsr);
							}
							else if (scanloc(&dnsr))
							{
								if (htons(dnsr.dnsp->header.ancount))
								{
									if (dnsr.qtype == DNS_TYPE_SOA)
										printf("SOA Sent for zone %s\n", dnsr.query);
									else if (dnsr.qtype == DNS_TYPE_NS)
										printf("NS Sent for zone %s\n", dnsr.query);
									else if (dnsr.cache.dataType == CACHED)
										printf("%s resolved from Cache to %s\n", dnsr.query, getResult(&dnsr));
									else
										printf("%s resolved Locally to %s\n", dnsr.query, getResult(&dnsr));
								}
								else if (dnsr.dnsp->header.rcode == RCODE_NAMEERROR || dnsr.dnsp->header.rcode == RCODE_NOERROR)
								{
									dnsr.dnsp->header.rcode = RCODE_NAMEERROR;
									printf("%s not found\n", dnsr.query);
								}
								sdnmess(&dnsr);
							}
							else if (!fdnmess(&dnsr))
							{
								sdnmess(&dnsr);
							}
						}
					}

					for (int i = 0; i < MAX_SERVERS && network.dnsTcpConn[i].ready; i++)
					{
						if (FD_ISSET(network.dnsTcpConn[i].sock, &readfds))
						{
							dnsr.sockInd = i;
							dnsr.sockLen = sizeof(dnsr.remote);
							errno = 0;
							dnsr.sock = accept(network.dnsTcpConn[i].sock, (sockaddr*)&dnsr.remote, &dnsr.sockLen);

							if (dnsr.sock == INVALID_SOCKET)
								printf("Accept Failed, Error: %s", strerror(errno));
							else
								procTCP(&dnsr);
						}
					}

					if (network.forwConn.ready && FD_ISSET(network.forwConn.sock, &readfds))
					{
						if (frdnmess(&dnsr))
						{
							sdnmess(&dnsr);

							if (dnsr.cache.dnsIndex < MAX_SERVERS)
							{
								if (dnsr.dnsp->header.ancount)
								{
									if (getResult(&dnsr))
										printf("%s resolved from Forwarding server as %s\n", dnsr.query, tempbuff);
									else
										printf("%s resolved from Forwarding server\n", dnsr.query);
								}
								else
									printf("%s not found by Forwarding Server\n", dnsr.query);
							}
							else
							{
								if (dnsr.dnsp->header.ancount)
								{
									if (getResult(&dnsr))
										printf("%s resolved from Conditional Forwarder as %s\n", dnsr.query, tempbuff);
									else
										printf("%s resolved from Conditional Forwarder\n", dnsr.query);
								}
								else
									printf("%s not found by Conditional Forwarder\n", dnsr.query);
							}
						}
					}
				}
			}
			else
				t = time(NULL);

			currentInd = newInd;
			checkSize(currentInd);
		}
        //printf("Here\n");
    }
    else
    {
		if(logBuff[0])
		{
			syslog(LOG_MAKEPRI(LOG_LOCAL1, LOG_CRIT), "%s", logBuff);
			exit(EXIT_FAILURE);
		}

        if(getuid())
        {
            syslog(LOG_MAKEPRI(LOG_LOCAL1, LOG_CRIT), "%s", "Only root should run this program");
			exit(EXIT_FAILURE);
        }

        /* Our process ID and Session ID */
        pid_t pid, sid;

        /* Fork off the parent process */
        pid = fork();

        if (pid < 0)
        {
            exit(EXIT_FAILURE);
        }
        /* If we got a good PID, then
        we can exit the parent process. */
        if (pid > 0)
        {
            exit(EXIT_SUCCESS);
        }

        /* Change the file mode mask */
        umask(0);

        /* Open any logs here */

        /* Create a new SID for the child process */
        sid = setsid();
        if (sid < 0)
        {
            /* Log the failure */
            exit(EXIT_FAILURE);
        }

        /* Change the current working directory */
        if ((chdir("/")) < 0)
        {
            /* Log the failure */
            exit(EXIT_FAILURE);
        }

        /* Close out the standard file descriptors */
        close(STDIN_FILENO);
        close(STDOUT_FILENO);
        close(STDERR_FILENO);

        /* Daemon-specific initialization goes here */
        //printf("%i\n",sizeof(data7));
	    memset(&cfig, 0, sizeof(cfig));
        cfig.ppid = getpid();
		pthread_t threadId;
		pthread_attr_t attr;
		pthread_attr_init(&attr);
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		int errcode = pthread_create(&threadId, &attr, init, NULL);
		pthread_attr_destroy(&attr);

		if(errcode)
		{
			syslog(LOG_MAKEPRI(LOG_LOCAL1, LOG_CRIT), "%s", "init thread Creation Failed");
			exit(EXIT_FAILURE);
		}

		//listDSNCache(0);
		/* The Big Loop */
		while (true)
		{
			if (!network.dhcpConn[0].ready && !network.dnsUdpConn[0].ready)
			{
				sleep(1);
				continue;
			}

			if (!network.ready)
			{
				sleep(1);
				continue;
			}

			FD_ZERO(&readfds);
			tv.tv_sec = 20;
			tv.tv_usec = 0;

			if (dhcpService)
			{
				if (network.httpConn.ready)
					FD_SET(network.httpConn.sock, &readfds);

				for (int i = 0; i < MAX_SERVERS && network.dhcpConn[i].ready; i++)
					FD_SET(network.dhcpConn[i].sock, &readfds);

				if (network.dhcpListener.ready)
					FD_SET(network.dhcpListener.sock, &readfds);

				if (cfig.dhcpReplConn.ready)
					FD_SET(cfig.dhcpReplConn.sock, &readfds);
			}

			if (dnsService)
			{
				for (int i = 0; i < MAX_SERVERS && network.dnsUdpConn[i].ready; i++)
					FD_SET(network.dnsUdpConn[i].sock, &readfds);

				if (network.forwConn.ready)
					FD_SET(network.forwConn.sock, &readfds);

				for (int i = 0; i < MAX_SERVERS && network.dnsTcpConn[i].ready; i++)
					FD_SET(network.dnsTcpConn[i].sock, &readfds);
			}

			//printf("%i\n",select(USHRT_MAX, &readfds, NULL, NULL, &tv));
			if (select(network.maxFD, &readfds, NULL, NULL, &tv))
			{
				t = time(NULL);

				if (dhcpService)
				{
					if (network.httpConn.ready && FD_ISSET(network.httpConn.sock, &readfds))
					{
						data19 *req = (data19*)calloc(1, sizeof(data19));

						if (req)
						{
							req->sockLen = sizeof(req->remote);
							errno = 0;
							req->sock = accept(network.httpConn.sock, (sockaddr*)&req->remote, &req->sockLen);

							if (req->sock == INVALID_SOCKET)
							{
								sprintf(logBuff, "Accept Failed, Error: %s", strerror(errno));
								logMess(logBuff, 1);
								free(req);
							}
							else
								procHTTP(req);
						}
						else
						{
							sprintf(logBuff, "Memory Error");
							logMess(logBuff, 1);
						}
					}

					if (cfig.dhcpReplConn.ready && FD_ISSET(cfig.dhcpReplConn.sock, &readfds))
					{
						//printf("Repl\n");
						dhcpr.sockLen = sizeof(dhcpr.remote);

						dhcpr.bytes = recvfrom(cfig.dhcpReplConn.sock,
											   dhcpr.raw,
											   sizeof(dhcpr.raw),
											   0,
											   (sockaddr*)&dhcpr.remote,
											   &dhcpr.sockLen);

						if (errno || dhcpr.bytes <= 0)
							cfig.dhcpRepl = 0;
					}

					for (int i = 0; i < MAX_SERVERS && network.dhcpConn[i].ready; i++)
					{
						if (FD_ISSET(network.dhcpConn[i].sock, &readfds) && gdmess(&dhcpr, i) && sdmess(&dhcpr))
							alad(&dhcpr);
					}

					if (network.dhcpListener.ready && FD_ISSET(network.dhcpListener.sock, &readfds) && gdmess(&dhcpr, 255) && sdmess(&dhcpr))
						alad(&dhcpr);
				}

				if (dnsService)
				{
					for (int i = 0; i < MAX_SERVERS && network.dnsUdpConn[i].ready; i++)
					{
						if (FD_ISSET(network.dnsUdpConn[i].sock, &readfds) && gdnmess(&dnsr, i))
						{
							if (dnsr.dnsp->header.rcode == RCODE_NOTIMPL || dnsr.dnsp->header.rcode == RCODE_REFUSED)
							{
								sdnmess(&dnsr);
							}
							else if (scanloc(&dnsr))
							{
								if (htons(dnsr.dnsp->header.ancount))
								{
									if (verbatim || cfig.dnsLogLevel >= 2)
									{
										if (dnsr.qtype == DNS_TYPE_SOA)
											sprintf(logBuff, "SOA Sent for zone %s", dnsr.query);
										else if (dnsr.qtype == DNS_TYPE_NS)
											sprintf(logBuff, "NS Sent for zone %s", dnsr.query);
										else if (dnsr.cache.dataType == CACHED)
											sprintf(logBuff, "%s resolved from Cache to %s", dnsr.query, getResult(&dnsr));
										else
											sprintf(logBuff, "%s resolved Locally to %s", dnsr.query, getResult(&dnsr));

										logDNSMess(&dnsr, logBuff, 2);
									}
								}
								else if (dnsr.dnsp->header.rcode == RCODE_NAMEERROR || dnsr.dnsp->header.rcode == RCODE_NOERROR)
								{
									dnsr.dnsp->header.rcode = RCODE_NAMEERROR;
									if (verbatim || cfig.dnsLogLevel >= 2)
									{
										sprintf(logBuff, "%s not found", dnsr.query);
										logDNSMess(&dnsr, logBuff, 2);
									}
								}
								sdnmess(&dnsr);
							}
							else if (!fdnmess(&dnsr))
							{
								sdnmess(&dnsr);
							}
						}
					}

					for (int i = 0; i < MAX_SERVERS && network.dnsTcpConn[i].ready; i++)
					{
						if (FD_ISSET(network.dnsTcpConn[i].sock, &readfds))
						{
							dnsr.sockInd = i;
							dnsr.sockLen = sizeof(dnsr.remote);
							errno = 0;
							dnsr.sock = accept(network.dnsTcpConn[i].sock, (sockaddr*)&dnsr.remote, &dnsr.sockLen);

							if (dnsr.sock == INVALID_SOCKET)
							{
								if (verbatim || cfig.dhcpLogLevel >= 1)
								{
									sprintf(logBuff, "Accept Failed, Error: %s", strerror(errno));
									logDNSMess(logBuff, 1);
								}
							}
							else
								procTCP(&dnsr);
						}
					}

					if (network.forwConn.ready && FD_ISSET(network.forwConn.sock, &readfds))
					{
						if (frdnmess(&dnsr))
						{
							sdnmess(&dnsr);

							if (verbatim || cfig.dnsLogLevel >= 2)
							{
								if (dnsr.cache.dnsIndex < MAX_SERVERS)
								{
									if (dnsr.dnsp->header.ancount)
									{
										if (getResult(&dnsr))
											sprintf(logBuff, "%s resolved from Forwarding server as %s", dnsr.query, tempbuff);
										else
											sprintf(logBuff, "%s resolved from Forwarding server", dnsr.query);
									}
									else
										sprintf(logBuff, "%s not found by Forwarding Server", dnsr.query);
								}
								else
								{
									if (dnsr.dnsp->header.ancount)
									{
										if (getResult(&dnsr))
											sprintf(logBuff, "%s resolved from Conditional Forwarder as %s", dnsr.query, tempbuff);
										else
											sprintf(logBuff, "%s resolved from Conditional Forwarder", dnsr.query);
									}
									else
										sprintf(logBuff, "%s not found by Conditional Forwarder", dnsr.query);
								}

								logDNSMess(&dnsr, logBuff, 2);
							}
						}
					}
				}
			}
			else
				t = time(NULL);

			currentInd = newInd;
			checkSize(currentInd);
		}
    }

    closeConn();

	if (cfig.dhcpReplConn.ready)
		close(cfig.dhcpReplConn.sock);
}

void closeConn()
{
    if (dhcpService)
    {
        for (int i = 0; i < MAX_SERVERS && network.dhcpConn[i].loaded; i++)
        	if (network.dhcpConn[i].ready)
            	close(network.dhcpConn[i].sock);

		if (network.dhcpListener.ready)
        	close(network.dhcpListener.sock);

        if (network.httpConn.ready)
            close(network.httpConn.sock);
    }

    if (dnsService)
    {
        for (int i = 0; i < MAX_SERVERS && network.dnsUdpConn[i].loaded; i++)
        	if (network.dnsUdpConn[i].ready)
           		close(network.dnsUdpConn[i].sock);

        for (int i = 0; i < MAX_SERVERS && network.dnsTcpConn[i].loaded; i++)
        	if (network.dnsTcpConn[i].ready)
	            close(network.dnsTcpConn[i].sock);

       	if (network.forwConn.ready)
        	close(network.forwConn.sock);
    }
}

void catch_int(int sig_num)
{
    if (cfig.ppid == getpid())
    {
		network.ready = false;
		sprintf(logBuff, "Closing Network Connections...");
		logMess(logBuff, 1);

	    sleep(1);
		closeConn();

        if (cfig.dhcpReplConn.ready)
            close(cfig.dhcpReplConn.sock);

		sprintf(logBuff, "Dual Server Stopped !\n");
		logMess(logBuff, 1);

	    close(cfig.fixedSocket);

	    sleep(1);

		exit(EXIT_SUCCESS);
	}
}

bool chkQu(char *query)
{
	if (strlen(query) >= UCHAR_MAX)
		return 0;

	while (true)
	{
		char *dp = strchr(query, '.');

		if (dp)
		{
			MYWORD size = dp - query;

			if (size >= 64)
				return 0;

			query += (size + 1);
		}
		else if (strlen(query) >= 64)
			return 0;
		else
			return 1;
	}
}

MYWORD fQu(char *query, dnsPacket *mess, char *raw)
{
	MYBYTE *xname = (MYBYTE*)query;
	MYBYTE *xraw = (MYBYTE*)raw;
	MYWORD retvalue = 0;
	bool goneout = false;

	while (true)
	{
		MYWORD size = *xraw;
		xraw++;

		if (!size)
			break;
		else if (size <= 63)
		{
			if (!goneout)
				retvalue += (size + 1);

			memcpy(xname, xraw, size);
			xname += size;
			xraw += size;

			if (!*xraw)
				break;

			*xname = '.';
			xname++;
		}
		else
		{
			if (!goneout)
				retvalue += 2;

			goneout = true;
			size %= 128;
			size %= 64;
			size *= 256;
			size += *xraw;
			xraw = (MYBYTE*)mess + size;
		}
	}
	*xname = 0;

	if (!goneout)
		retvalue++;

	return retvalue;
}

MYWORD qLen(char *query)
{
	MYWORD fullsize = 1;
	while (true)
	{
		char *dp = strchr(query, '.');
		if (dp != NULL)
		{
			int size = dp - query;
			query += (size + 1);
			fullsize += (size + 1);
		}
		else
		{
			int size = strlen(query);
			if (size)
				fullsize += (size + 1);
			break;
		}
	}
	//printf("%i\n",fullsize);
	return fullsize;
}

MYWORD pQu(char *raw, char *query)
{
	MYWORD fullsize = 1;
	while (true)
	{
		char *i = strchr(query, '.');
		if (i != NULL)
		{
			int size = i - query;
			*raw = size;
			raw++;
			memcpy(raw, query, size);
			raw += size;
			query += (size + 1);
			fullsize += (size + 1);
		}
		else
		{
			int size = strlen(query);
			if (size)
			{
				*raw = size;
				raw++;
				strcpy(raw, query);
				fullsize += (size + 1);
			}
			break;
		}
	}
	//printf("%i\n",fullsize);
	return fullsize;
}

MYWORD fUShort(void *raw)
{
	return ntohs(*((MYWORD*)raw));
}

MYDWORD fULong(void *raw)
{
	return ntohl(*((MYDWORD*)raw));
}

MYDWORD fIP(void *raw)
{
	return(*((MYDWORD*)raw));
}

MYBYTE pUShort(void *raw, MYWORD data)
{
	*((MYWORD*)raw) = htons(data);
	return sizeof(MYWORD);
}

MYBYTE pULong(void *raw, MYDWORD data)
{
	*((MYDWORD*)raw) = htonl(data);
	return sizeof(MYDWORD);
}

MYBYTE pIP(void *raw, MYDWORD data)
{
	*((MYDWORD*)raw) = data;
	return sizeof(MYDWORD);
}

void addRRBlank(data5 *req)
{
	req->dnsp->header.ra = 0;
	req->dnsp->header.at = 0;
	req->dnsp->header.aa = 0;
	req->dnsp->header.qr = 1;
	req->dp = &req->dnsp->data;
	req->dnsp->header.qdcount = 0;
	req->dnsp->header.ancount = 0;
	req->dnsp->header.nscount = 0;
	req->dnsp->header.adcount = 0;
}

void addRRNone(data5 *req)
{
	if (network.dns[0])
		req->dnsp->header.ra = 1;
	else
		req->dnsp->header.ra = 0;

	req->dnsp->header.at = 0;
	req->dnsp->header.aa = 0;

	req->dnsp->header.qr = 1;
	req->dnsp->header.ancount = 0;
	req->dnsp->header.nscount = 0;
	req->dnsp->header.adcount = 0;
}

void addRRExt(data5 *req)
{
	MYWORD xid = req->dnsp->header.xid;

	//printf("%s=%s\n", req->cname, req->query);

	if (strcasecmp(req->cname, req->query))
	{
		dnsPacket *packet;

		if (req->cache.dataType == CACHED && req->cache.response)
			packet = (dnsPacket*)req->cache.response;
		else
		{
			memcpy(req->temp, req->dnsp, req->bytes);
			packet = (dnsPacket*)req->temp;
		}

		req->dnsp->header.aa = 0;
		req->dnsp->header.at = 0;
		req->dnsp->header.qdcount = htons(1);
		req->dnsp->header.ancount = htons(1);

		//manuplate the response
		req->dp = &req->dnsp->data;
		req->dp += pQu(req->dp, req->query);
		req->dp += pUShort(req->dp, DNS_TYPE_A);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pQu(req->dp, req->query);
		req->dp += pUShort(req->dp, DNS_TYPE_CNAME);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pULong(req->dp, cfig.lease);
		req->dp += pUShort(req->dp, qLen(req->cname));
		req->dp += pQu(req->dp, req->cname);

		char *dp = &packet->data;

		for (int i = 1; i <= ntohs(packet->header.qdcount); i++)
		{
			dp += fQu(req->cname, packet, dp);
			dp += 4;
		}

		MYWORD dl = 0;
		for (int i = 1; i <= ntohs(packet->header.ancount); i++)
		{
			dp += fQu(req->cname, packet, dp);
			req->dp += pQu(req->dp, req->cname);
			memcpy(req->dp, dp, 8);
			req->dp += 8;
			int type = fUShort(dp);
			dp += 2; //type
			dp += 2; //class
			dp += 4; //ttl
			MYWORD zLen = fUShort(dp);
			dp += 2; //datalength

			switch (type)
			{
				case DNS_TYPE_A:
					req->dp += pUShort(req->dp, zLen);
					req->dp += pULong(req->dp, fULong(dp));
					break;
				case DNS_TYPE_CNAME:
					fQu(req->cname, packet, dp);
					dl = pQu(req->dp + 2, req->cname);
					req->dp += pUShort(req->dp, dl);
					req->dp += dl;
					break;
			}
			dp += zLen;
			req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
		}

		//req->bytes = req->dp - req->raw;
	}
	else if (req->cache.dataType == CACHED && req->cache.response)
	{
		memcpy(req->dnsp, req->cache.response, req->cache.bytes);
		req->dnsp->header.xid = xid;
		req->dp = req->raw + req->cache.bytes;
	}
	else
		req->dp = req->raw + req->bytes;
}

void addRRA(data5 *req)
{
	if (strcasecmp(req->query, req->cname))
	{
		req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
		req->dp += pQu(req->dp, req->query);
		req->dp += pUShort(req->dp, DNS_TYPE_CNAME);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pULong(req->dp, cfig.lease);
		req->dp += pUShort(req->dp, qLen(req->cname));
		req->dp += pQu(req->dp, req->cname);
	}

	for (; req->iterBegin != dnsCache[currentInd].end(); req->iterBegin++)
	{
		data7 *cache = req->iterBegin->second;

		if (strcasecmp(cache->mapname, req->mapname))
			break;

		if (cache->ip)
		{
			req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
			req->dp += pQu(req->dp, req->cname);
			req->dp += pUShort(req->dp, DNS_TYPE_A);
			req->dp += pUShort(req->dp, DNS_CLASS_IN);
			req->dp += pULong(req->dp, cfig.lease);
			req->dp += pUShort(req->dp, 4);
			req->dp += pIP(req->dp, cache->ip);
		}
	}
	//req->bytes = req->dp - req->raw;
}

void addRRPtr(data5 *req)
{
	for (; req->iterBegin != dnsCache[currentInd].end(); req->iterBegin++)
	{
		if (data7 *cache = req->iterBegin->second)
		{
			if (strcasecmp(cache->mapname, req->mapname))
				break;

			req->dp += pQu(req->dp, req->query);
			req->dp += pUShort(req->dp, DNS_TYPE_PTR);
			req->dp += pUShort(req->dp, DNS_CLASS_IN);
			req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
			req->dp += pULong(req->dp, cfig.lease);

			if (!cache->hostname[0])
				strcpy(req->cname, cfig.zone);
			else if (!strchr(cache->hostname, '.'))
				sprintf(req->cname, "%s.%s", cache->hostname, cfig.zone);
			else
				strcpy(req->cname, cache->hostname);

			req->dp += pUShort(req->dp, qLen(req->cname));
			req->dp += pQu(req->dp, req->cname);
		}
	}
	//req->bytes = req->dp - req->raw;
}

void addRRServerA(data5 *req)
{
	if (strcasecmp(req->query, req->cname))
	{
		req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
		req->dp += pQu(req->dp, req->query);
		req->dp += pUShort(req->dp, DNS_TYPE_CNAME);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pULong(req->dp, cfig.lease);
		req->dp += pUShort(req->dp, qLen(req->cname));
		req->dp += pQu(req->dp, req->cname);
	}

	req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
	req->dp += pQu(req->dp, req->cname);
	req->dp += pUShort(req->dp, DNS_TYPE_A);
	req->dp += pUShort(req->dp, DNS_CLASS_IN);
	req->dp += pULong(req->dp, cfig.lease);
	req->dp += pUShort(req->dp, 4);
	req->dp += pIP(req->dp, network.dnsUdpConn[req->sockInd].server);

	for (;req->iterBegin != dnsCache[currentInd].end(); req->iterBegin++)
	{
		if (data7 *cache = req->iterBegin->second)
		{
			if (strcasecmp(cache->mapname, req->mapname))
				break;

			if (cache->ip && cache->ip != network.dnsUdpConn[req->sockInd].server)
			{
				req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
				req->dp += pQu(req->dp, req->cname);
				req->dp += pUShort(req->dp, DNS_TYPE_A);
				req->dp += pUShort(req->dp, DNS_CLASS_IN);
				req->dp += pULong(req->dp, cfig.lease);
				req->dp += pUShort(req->dp, 4);
				req->dp += pIP(req->dp, cache->ip);
			}
		}
	}
	//req->bytes = req->dp - req->raw;
}

void addRRAny(data5 *req, bool adFlag)
{
	while (req->iterBegin != dnsCache[currentInd].end())
	{
		if (data7 *cache = req->iterBegin->second)
		{
			if (strcasecmp(cache->mapname, req->mapname))
				break;

			if (adFlag)
				req->dnsp->header.adcount = htons(htons(req->dnsp->header.adcount) + 1);
			else
				req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);

			switch (cache->dataType)
			{
				case LOCAL_A:
				case SERVER_A_AUTH:
				case STATIC_A_AUTH:
					req->dp += pQu(req->dp, req->cname);
					req->dp += pUShort(req->dp, DNS_TYPE_A);
					req->dp += pUShort(req->dp, DNS_CLASS_IN);
					req->dp += pULong(req->dp, cfig.lease);
					req->dp += pUShort(req->dp, 4);
					req->dp += pIP(req->dp, cache->ip);
					break;

				case LOCAL_PTR_AUTH:
				case LOCAL_PTR_NAUTH:
				case STATIC_PTR_AUTH:
				case STATIC_PTR_NAUTH:
				case SERVER_PTR_AUTH:
				case SERVER_PTR_NAUTH:
					req->dp += pQu(req->dp, req->cname);
					req->dp += pUShort(req->dp, DNS_TYPE_PTR);
					req->dp += pUShort(req->dp, DNS_CLASS_IN);
					req->dp += pULong(req->dp, cfig.lease);

					if (!cache->hostname[0])
						strcpy(req->temp, cfig.zone);
					else if (!strchr(cache->hostname, '.'))
						strcpy(req->temp, cache->hostname);
					else
						sprintf(req->temp, "%s.%s", cache->hostname, cfig.zone);

					req->dp += pUShort(req->dp, qLen(req->temp));
					req->dp += pQu(req->dp, req->temp);
					break;

				case EXT_CNAME:
					req->dp += pQu(req->dp, req->cname);
					req->dp += pUShort(req->dp, DNS_TYPE_CNAME);
					req->dp += pUShort(req->dp, DNS_CLASS_IN);
					req->dp += pULong(req->dp, cfig.lease);
					req->dp += pUShort(req->dp, qLen(cache->hostname));
					req->dp += pQu(req->dp, cache->hostname);
					return;
					break;

				case LOCAL_CNAME:
					req->dp += pQu(req->dp, req->cname);
					req->dp += pUShort(req->dp, DNS_TYPE_CNAME);
					req->dp += pUShort(req->dp, DNS_CLASS_IN);
					req->dp += pULong(req->dp, cfig.lease);
					sprintf(req->cname, "%s.%s", cache->hostname, cfig.zone);
					req->dp += pUShort(req->dp, qLen(req->cname));
					req->dp += pQu(req->dp, req->cname);
					strcpy(req->mapname, cache->hostname);
					myLower(req->mapname);
					req->iterBegin = dnsCache[currentInd].find(req->mapname);
					adFlag = true;
					continue;
			}
			req->iterBegin++;
		}
	}
}

void addRRWildA(data5 *req, MYDWORD ip)
{
	req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
	req->dp += pQu(req->dp, req->query);
	req->dp += pUShort(req->dp, DNS_TYPE_A);
	req->dp += pUShort(req->dp, DNS_CLASS_IN);
	req->dp += pULong(req->dp, cfig.lease);
	req->dp += pUShort(req->dp, 4);
	req->dp += pIP(req->dp, ip);
	//req->bytes = req->dp - req->raw;
}

void addRRLocalhostA(data5 *req)
{
	if (strcasecmp(req->query, req->mapname))
	{
		req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
		req->dp += pQu(req->dp, req->query);
		req->dp += pUShort(req->dp, DNS_TYPE_CNAME);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pULong(req->dp, cfig.lease);
		req->dp += pUShort(req->dp, qLen(req->mapname));
		req->dp += pQu(req->dp, req->mapname);
	}

	req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
	req->dp += pQu(req->dp, req->mapname);
	req->dp += pUShort(req->dp, DNS_TYPE_A);
	req->dp += pUShort(req->dp, DNS_CLASS_IN);
	req->dp += pULong(req->dp, cfig.lease);
	req->dp += pUShort(req->dp, 4);
	req->dp += pIP(req->dp, req->cache.ip);
	//req->bytes = req->dp - req->raw;
}

void addRRLocalhostPtr(data5 *req)
{
	req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
	req->dp += pQu(req->dp, req->query);
	req->dp += pUShort(req->dp, DNS_TYPE_PTR);
	req->dp += pUShort(req->dp, DNS_CLASS_IN);
	req->dp += pULong(req->dp, cfig.lease);
	req->dp += pUShort(req->dp, qLen(req->cache.hostname));
	req->dp += pQu(req->dp, req->cache.hostname);
	//req->bytes = req->dp - req->raw;
}

void addRRMX(data5 *req)
{
	if (cfig.mxCount[currentInd])
	{
		for (int m = 0; m < cfig.mxCount[currentInd]; m++)
		{
			addRRMXOne(req, m);
		}
	}

	//req->bytes = req->dp - req->raw;
}

void addRRNS(data5 *req)
{
	//printf("%s=%u\n", cfig.ns, cfig.expireTime);
	if (cfig.authorized && cfig.expireTime > t)
	{
		req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
		req->dnsp->header.at = 1;
		req->dnsp->header.aa = 1;

		if (req->dnType == DNTYPE_P_LOCAL || req->dnType == DNTYPE_P_EXT || req->dnType == DNTYPE_P_ZONE)
			req->dp += pQu(req->dp, cfig.authority);
		else
			req->dp += pQu(req->dp, cfig.zone);

		req->dp += pUShort(req->dp, DNS_TYPE_NS);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);

		req->dp += pULong(req->dp, cfig.expire);

		if (req->dnType == DNTYPE_P_LOCAL || req->dnType == DNTYPE_P_EXT || req->dnType == DNTYPE_P_ZONE)
		{
			req->dp += pUShort(req->dp, qLen(cfig.nsP));
			req->dp += pQu(req->dp, cfig.nsP);
		}
		else
		{
			req->dp += pUShort(req->dp, qLen(cfig.nsA));
			req->dp += pQu(req->dp, cfig.nsA);
		}
	}
	//req->bytes = req->dp - req->raw;
}

void addRRSOA(data5 *req)
{
	if (cfig.authorized)
	{
		req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
		req->dnsp->header.at = 1;
		req->dnsp->header.aa = 1;

		if (req->dnType == DNTYPE_P_LOCAL || req->dnType == DNTYPE_P_EXT || req->dnType == DNTYPE_P_ZONE)
			req->dp += pQu(req->dp, cfig.authority);
		else
			req->dp += pQu(req->dp, cfig.zone);

		req->dp += pUShort(req->dp, DNS_TYPE_SOA);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pULong(req->dp, cfig.lease);
		char *data = req->dp;
		req->dp += 2;

		if (req->dnType == DNTYPE_P_LOCAL || req->dnType == DNTYPE_P_EXT || req->dnType == DNTYPE_P_ZONE)
			req->dp += pQu(req->dp, cfig.nsP);
		else
			req->dp += pQu(req->dp, cfig.nsA);

		sprintf(req->temp, "hostmaster.%s", cfig.zone);
		req->dp += pQu(req->dp, req->temp);

		if (req->dnType == DNTYPE_P_LOCAL || req->dnType == DNTYPE_P_EXT || req->dnType == DNTYPE_P_ZONE)
			req->dp += pULong(req->dp, cfig.serial2);
		else
			req->dp += pULong(req->dp, cfig.serial1);

		req->dp += pULong(req->dp, cfig.refresh);
		req->dp += pULong(req->dp, cfig.retry);
		req->dp += pULong(req->dp, cfig.expire);
		req->dp += pULong(req->dp, cfig.minimum);
		pUShort(data, (req->dp - data) - 2);
	}
	//req->bytes = req->dp - req->raw;
}

void addRRSOAuth(data5 *req)
{
	if (cfig.authorized)
	{
		req->dnsp->header.nscount = htons(htons(req->dnsp->header.nscount) + 1);
		req->dnsp->header.at = 1;
		req->dnsp->header.aa = 1;

		if (req->dnType == DNTYPE_P_LOCAL || req->dnType == DNTYPE_P_EXT || req->dnType == DNTYPE_P_ZONE)
			req->dp += pQu(req->dp, cfig.authority);
		else
			req->dp += pQu(req->dp, cfig.zone);

		req->dp += pUShort(req->dp, DNS_TYPE_SOA);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pULong(req->dp, cfig.lease);
		char *data = req->dp;
		req->dp += 2;

		if (req->dnType == DNTYPE_P_LOCAL || req->dnType == DNTYPE_P_EXT || req->dnType == DNTYPE_P_ZONE)
			req->dp += pQu(req->dp, cfig.nsP);
		else
			req->dp += pQu(req->dp, cfig.nsA);

		sprintf(req->temp, "hostmaster.%s", cfig.zone);
		req->dp += pQu(req->dp, req->temp);

		if (req->dnType == DNTYPE_P_LOCAL || req->dnType == DNTYPE_P_EXT || req->dnType == DNTYPE_P_ZONE)
			req->dp += pULong(req->dp, cfig.serial2);
		else
			req->dp += pULong(req->dp, cfig.serial1);

		req->dp += pULong(req->dp, cfig.refresh);
		req->dp += pULong(req->dp, cfig.retry);
		req->dp += pULong(req->dp, cfig.expire);
		req->dp += pULong(req->dp, cfig.minimum);
		pUShort(data, (req->dp - data) - 2);
	}
	//req->bytes = req->dp - req->raw;
}

void addNS(data5 *req)
{
	if (cfig.authorized && cfig.expireTime > t)
	{
		req->dnsp->header.at = 1;
		req->dnsp->header.aa = 1;

		req->dnsp->header.nscount = htons(1);

		if (req->dnType == DNTYPE_P_LOCAL || req->dnType == DNTYPE_P_EXT || req->dnType == DNTYPE_P_ZONE)
			req->dp += pQu(req->dp, cfig.authority);
		else
			req->dp += pQu(req->dp, cfig.zone);

		req->dp += pUShort(req->dp, DNS_TYPE_NS);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);

		if (cfig.expire >= INT_MAX)
			req->dp += pULong(req->dp, UINT_MAX);
		else
			req->dp += pULong(req->dp, cfig.expire);

		if (req->dnType == DNTYPE_P_LOCAL || req->dnType == DNTYPE_P_EXT || req->dnType == DNTYPE_P_ZONE)
		{
			req->dp += pUShort(req->dp, qLen(cfig.nsP));
			req->dp += pQu(req->dp, cfig.nsP);
		}
		else
		{
			req->dp += pUShort(req->dp, qLen(cfig.nsA));
			req->dp += pQu(req->dp, cfig.nsA);
		}

		addRRAd(req);
	}
	//req->bytes = req->dp - req->raw;
}

void addRRAd(data5 *req)
{
	if (cfig.authorized && cfig.expireTime > t)
	{
		req->dnsp->header.adcount = htons(htons(req->dnsp->header.adcount) + 1);

		if (req->dnType == DNTYPE_P_LOCAL || req->dnType == DNTYPE_P_EXT || req->dnType == DNTYPE_P_ZONE)
			req->dp += pQu(req->dp, cfig.nsP);
		else
			req->dp += pQu(req->dp, cfig.nsA);

		req->dp += pUShort(req->dp, DNS_TYPE_A);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pULong(req->dp, cfig.lease);
		req->dp += pUShort(req->dp, 4);

		if (cfig.replication)
			req->dp += pIP(req->dp, cfig.zoneServers[0]);
		else
			req->dp += pIP(req->dp, network.listenServers[req->sockInd]);
	}
	//req->bytes = req->dp - req->raw;
}

void addRRAOne(data5 *req)
{
	if (data7 *cache = req->iterBegin->second)
	{
		req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);

		if (!cache->mapname[0])
			strcpy(req->cname, cfig.zone);
		else if (!strchr(cache->mapname, '.'))
			sprintf(req->cname, "%s.%s", cache->mapname, cfig.zone);
		else
			strcpy(req->cname, cache->mapname);

		req->dp += pQu(req->dp, req->cname);
		req->dp += pUShort(req->dp, DNS_TYPE_A);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pULong(req->dp, cfig.lease);
		req->dp += pUShort(req->dp, 4);
		req->dp += pIP(req->dp, cache->ip);
		//req->bytes = req->dp - req->raw;
	}
}

void addRRPtrOne(data5 *req)
{
	if (data7 *cache = req->iterBegin->second)
	{
		req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
		sprintf(req->cname, "%s%s", cache->mapname, arpa);
		req->dp += pQu(req->dp, req->cname);
		req->dp += pUShort(req->dp, DNS_TYPE_PTR);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pULong(req->dp, cfig.lease);

		if (!cache->hostname[0])
			strcpy(req->cname, cfig.zone);
		else if (!strchr(cache->hostname, '.'))
			sprintf(req->cname, "%s.%s", cache->hostname, cfig.zone);
		else
			strcpy(req->cname, cache->hostname);

		req->dp += pUShort(req->dp, qLen(req->cname));
		req->dp += pQu(req->dp, req->cname);
	}

	//req->bytes = req->dp - req->raw;
}

void addRRSTAOne(data5 *req)
{
	if (data7 *cache = req->iterBegin->second)
	{
		req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);

		if (!cache->mapname[0])
			strcpy(req->cname, cfig.zone);
		else if (!strchr(cache->mapname, '.'))
			sprintf(req->cname, "%s.%s", cache->mapname, cfig.zone);
		else
			strcpy(req->cname, cache->mapname);

		req->dp += pQu(req->dp, req->cname);
		req->dp += pUShort(req->dp, DNS_TYPE_A);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pULong(req->dp, cfig.lease);
		req->dp += pUShort(req->dp, 4);
		req->dp += pIP(req->dp, cache->ip);
	}
	//req->bytes = req->dp - req->raw;
}

void addRRCNOne(data5 *req)
{
	if (data7 *cache = req->iterBegin->second)
	{
		req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);

		if (!cache->mapname[0])
			strcpy(req->cname, cfig.zone);
		else if (strchr(cache->mapname, '.'))
			strcpy(req->cname, cache->mapname);
		else
			sprintf(req->cname, "%s.%s", cache->mapname, cfig.zone);

		req->dp += pQu(req->dp, req->cname);
		req->dp += pUShort(req->dp, DNS_TYPE_CNAME);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->dp += pULong(req->dp, cfig.lease);

		if (!cache->hostname[0])
			strcpy(req->cname, cfig.zone);
		else if (strchr(cache->hostname, '.'))
			strcpy(req->cname, cache->hostname);
		else
			sprintf(req->cname, "%s.%s", cache->hostname, cfig.zone);

		req->dp += pUShort(req->dp, qLen(req->cname));
		req->dp += pQu(req->dp, req->cname);
	}
	//req->bytes = req->dp - req->raw;
}

void addRRMXOne(data5 *req, MYBYTE m)
{
	//req->dp += pQu(req->dp, req->query);
	req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
	req->dp += pQu(req->dp, cfig.zone);
	req->dp += pUShort(req->dp, DNS_TYPE_MX);
	req->dp += pUShort(req->dp, DNS_CLASS_IN);
	req->dp += pULong(req->dp, cfig.lease);
	req->dp += pUShort(req->dp, strlen(cfig.mxServers[currentInd][m].hostname) + 4);
	req->dp += pUShort(req->dp, cfig.mxServers[currentInd][m].pref);
	req->dp += pQu(req->dp, cfig.mxServers[currentInd][m].hostname);
	//req->bytes = req->dp - req->raw;
}

void procHTTP(data19 *req)
{
	req->ling.l_onoff = 1; 		//0 = off (l_linger ignored), nonzero = on
	req->ling.l_linger = 30; 	//0 = discard data, nonzero = wait for data sent
	setsockopt(req->sock, SOL_SOCKET, SO_LINGER, (const char*)&req->ling, sizeof(req->ling));

	timeval tv1;
	fd_set readfds1;
	FD_ZERO(&readfds1);
	tv1.tv_sec = 1;
	tv1.tv_usec = 0;
	FD_SET(req->sock, &readfds1);

	if (!select((req->sock + 1), &readfds1, NULL, NULL, &tv1))
	{
		sprintf(logBuff, "Client %s, HTTP Message Receive failed", IP2String(tempbuff, req->remote.sin_addr.s_addr));
		logMess(logBuff, 1);
		closesocket(req->sock);
		free(req);
		return;
	}

	errno = 0;
	char buffer[1024];
	req->bytes = recv(req->sock, buffer, sizeof(buffer), 0);
	//errno = WSAGetLastError();

	if (errno || req->bytes <= 0)
	{
		sprintf(logBuff, "Client %s, HTTP Message Receive failed, Error: %s", IP2String(tempbuff, req->remote.sin_addr.s_addr), strerror(errno));
		logMess(logBuff, 1);
		closesocket(req->sock);
		free(req);
		return;
	}
	else if (verbatim || cfig.dhcpLogLevel >= 2)
	{
		sprintf(logBuff, "Client %s, HTTP Request Received", IP2String(tempbuff, req->remote.sin_addr.s_addr));
		logMess(logBuff, 2);
		//printf("%s\n", buffer);
	}

	if (cfig.httpClients[0] && !findServer(cfig.httpClients, 8, req->remote.sin_addr.s_addr))
	{
		if (verbatim || cfig.dhcpLogLevel >= 2)
		{
			sprintf(logBuff, "Client %s, HTTP Access Denied", IP2String(tempbuff, req->remote.sin_addr.s_addr));
			logMess(logBuff, 2);
		}

		req->dp = (char*)calloc(1, sizeof(send403));
		req->memSize = sizeof(send403);
		req->bytes = sprintf(req->dp, send403);
		pthread_t threadId;
		pthread_attr_t attr;
		pthread_attr_init(&attr);
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		int errcode = pthread_create(&threadId, &attr, sendHTTP, (void*)req);
		pthread_attr_destroy(&attr);

		return;
	}

	buffer[sizeof(buffer) - 1] = 0;
	char *fp = NULL;
	char *end = strchr(buffer, '\n');

	if (end && end > buffer && (*(end - 1) == '\r'))
	{
		*(end - 1) = 0;

		if (myTokenize(buffer, buffer, " ", true) > 1)
			fp = myGetToken(buffer, 1);
	}

	if (fp && !strcasecmp(fp, "/"))
		sendStatus(req);
//	else if (fp && !strcasecmp(fp, "/scopestatus"))
//		sendScopeStatus(req);
	else
	{
		if (fp && (verbatim || cfig.dhcpLogLevel >= 2))
		{
			sprintf(logBuff, "Client %s, %s not found", IP2String(tempbuff, req->remote.sin_addr.s_addr), fp);
			logMess(logBuff, 2);
		}
		else if (verbatim || cfig.dhcpLogLevel >= 2)
		{
			sprintf(logBuff, "Client %s, Invalid http request", IP2String(tempbuff, req->remote.sin_addr.s_addr));
			logMess(logBuff, 2);
		}

		req->dp = (char*)calloc(1, sizeof(send404));
		req->bytes = sprintf(req->dp, send404);
		req->memSize = sizeof(send404);

		pthread_t threadId;
		pthread_attr_t attr;
		pthread_attr_init(&attr);
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		int errcode = pthread_create(&threadId, &attr, sendHTTP, (void*)req);
		pthread_attr_destroy(&attr);

		return;
	}
}

void sendStatus(data19 *req)
{
	dhcpMap::iterator p;
	MYDWORD iip = 0;
	data7 *dhcpEntry = NULL;
	//data7 *cache = NULL;
	//printf("%d=%d\n", dhcpCache.size(), cfig.dhcpSize);
	req->memSize = 2048 + (135 * dhcpCache.size()) + (cfig.dhcpSize * 26);
	req->dp = (char*)calloc(1, req->memSize);

	if (!req->dp)
	{
		sprintf(logBuff, "Memory Error");
		logMess(logBuff, 1);
		closesocket(req->sock);
		free(req);
		return;
	}

	char *fp = req->dp;
	char *maxData = req->dp + (req->memSize - 512);
	tm *ttm = gmtime(&t);
	strftime(tempbuff, sizeof(tempbuff), "%a, %d %b %Y %H:%M:%S GMT", ttm);
	fp += sprintf(fp, send200, tempbuff, tempbuff);
	char *contentStart = fp;
	fp += sprintf(fp, "<html>\n<head>\n<meta http-equiv=\"refresh\" content=\"60\">\n<meta http-equiv=\"cache-control\" content=\"no-cache\">\n</head>\n");
	fp += sprintf(fp, toprow, sVersion);
	//fp += sprintf(fp, "<body bgcolor=\"#cccccc\">\n<h2>Host: %s</h2>\n", cfig.servername);
	fp += sprintf(fp, "<table border=\"1\" cellpadding=\"1\" width=\"640\" bgcolor=\"#b8b8b8\">\n");

	if (cfig.dhcpRepl > t)
	{
		fp += sprintf(fp, "<tr><th colspan=\"5\"><font size=\"5\"><i>Active Leases</i></font></th></tr>\n");
		fp += sprintf(fp, "<tr><th>Mac Address</th><th>IP</th><th>Lease Expiry</th><th>Hostname (first 20 chars)</th><th>Server</th></tr>\n");
	}
	else
	{
		fp += sprintf(fp, "<tr><th colspan=\"4\"><font size=\"5\"><i>Active Leases</i></font></th></tr>\n");
		fp += sprintf(fp, "<tr><th>Mac Address</th><th>IP</th><th>Lease Expiry</th><th>Hostname (first 20 chars)</th></tr>\n");
	}

	for (p = dhcpCache.begin(); kRunning && p != dhcpCache.end() && fp < maxData; p++)
	{
		if ((dhcpEntry = p->second) && dhcpEntry->display && dhcpEntry->expiry >= t)
		{
			fp += sprintf(fp, "<tr>");
			fp += sprintf(fp, td200, dhcpEntry->mapname);
			fp += sprintf(fp, td200, IP2String(tempbuff, dhcpEntry->ip));

			if (dhcpEntry->expiry >= INT_MAX)
				fp += sprintf(fp, td200, "Infinity");
			else
			{
				tm *ttm = localtime(&dhcpEntry->expiry);
				strftime(tempbuff, sizeof(tempbuff), "%d-%b-%y %X", ttm);
				fp += sprintf(fp, td200, tempbuff);
			}

			if (dhcpEntry->hostname)
			{
				if (strlen(dhcpEntry->hostname) <= 20)
					fp += sprintf(fp, td200, dhcpEntry->hostname);
				else
				{
					memcpy(tempbuff, dhcpEntry->hostname, 20);
					tempbuff[20] = 0;
					fp += sprintf(fp, td200, tempbuff);
				}
			}
			else
				fp += sprintf(fp, td200, "&nbsp;");

			if (cfig.dhcpRepl > t)
			{
				if (dhcpEntry->local && cfig.replication == 1)
					fp += sprintf(fp, td200, "Primary");
				else if (dhcpEntry->local && cfig.replication == 2)
					fp += sprintf(fp, td200, "Secondary");
				else if (cfig.replication == 1)
					fp += sprintf(fp, td200, "Secondary");
				else
					fp += sprintf(fp, td200, "Primary");
			}

			fp += sprintf(fp, "</tr>\n");
		}
	}

	fp += sprintf(fp, "</table>\n<br>\n<table border=\"1\" width=\"640\" cellpadding=\"1\" bgcolor=\"#b8b8b8\">\n");
	fp += sprintf(fp, "<tr><th colspan=\"5\"><font size=\"5\"><i>Free Dynamic Leases</i></font></th></tr>\n");
	MYBYTE colNum = 0;

	for (char rangeInd = 0; kRunning && rangeInd < cfig.rangeCount && fp < maxData; rangeInd++)
	{
		for (MYDWORD ind = 0, iip = cfig.dhcpRanges[rangeInd].rangeStart; kRunning && iip <= cfig.dhcpRanges[rangeInd].rangeEnd; iip++, ind++)
		{
			if (cfig.dhcpRanges[rangeInd].expiry[ind] < t)
			{
				if (!colNum)
				{
					fp += sprintf(fp, "<tr>");
					colNum = 1;
				}
				else if (colNum < 5)
					colNum++;
				else
				{
					fp += sprintf(fp, "</tr>\n<tr>");
					colNum = 1;
				}

				fp += sprintf(fp, td200, IP2String(tempbuff, htonl(iip)));
			}
		}
	}

	if (colNum)
		fp += sprintf(fp, "</tr>\n");

	fp += sprintf(fp, "</table>\n<br>\n<table border=\"1\" width=\"640\" cellpadding=\"1\" bgcolor=\"#b8b8b8\">\n");
	fp += sprintf(fp, "<tr><th colspan=\"4\"><font size=\"5\"><i>Free Static Leases</i></font></th></tr>\n");
	fp += sprintf(fp, "<tr><th>Mac Address</th><th>IP</th><th>Mac Address</th><th>IP</th></tr>\n");
	colNum = 0;

	for (p = dhcpCache.begin(); kRunning && p != dhcpCache.end() && fp < maxData; p++)
	{
		if ((dhcpEntry = p->second) && dhcpEntry->fixed && dhcpEntry->expiry < t)
		{
			if (!colNum)
			{
				fp += sprintf(fp, "<tr>");
				colNum = 1;
			}
			else if (colNum == 1)
			{
				colNum = 2;
			}
			else if (colNum == 2)
			{
				fp += sprintf(fp, "</tr>\n<tr>");
				colNum = 1;
			}

			fp += sprintf(fp, td200, dhcpEntry->mapname);
			fp += sprintf(fp, td200, IP2String(tempbuff, dhcpEntry->ip));
		}
	}

	if (colNum)
		fp += sprintf(fp, "</tr>\n");

	fp += sprintf(fp, "</table>\n</body>\n</html>");
	MYBYTE x = sprintf(tempbuff, "%u", (fp - contentStart));
	memcpy((contentStart - 12), tempbuff, x);
	req->bytes = fp - req->dp;

	pthread_t threadId;
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	int errcode = pthread_create(&threadId, &attr, sendHTTP, (void*)req);
	pthread_attr_destroy(&attr);

	return;
}

void sendScopeStatus(data19 *req)
{
	MYBYTE rangeCount = 0;
	req->memSize = 1536 + (150 * cfig.rangeCount);
	req->dp = (char*)calloc(1, req->memSize);

	if (!req->dp)
	{
		sprintf(logBuff, "Memory Error");
		logMess(logBuff, 1);
		closesocket(req->sock);
		free(req);
		return;
	}

	char *fp = req->dp;
	char *maxData = req->dp + (req->memSize - 512);
	tm *ttm = gmtime(&t);
	strftime(tempbuff, sizeof(tempbuff), "%a, %d %b %Y %H:%M:%S GMT", ttm);
	fp += sprintf(fp, send200, tempbuff, tempbuff);
	char *contentStart = fp;
	fp += sprintf(fp, "<html>\n<head>\n<meta http-equiv=\"refresh\" content=\"60\">\n<meta http-equiv=\"cache-control\" content=\"no-cache\">\n</head>\n");
	fp += sprintf(fp, toprow, sVersion);
	fp += sprintf(fp, "<table border=\"1\" cellpadding=\"1\" width=\"640\" bgcolor=\"#b8b8b8\">\n");
	fp += sprintf(fp, "<tr><th colspan=\"4\"><font size=\"5\"><i>Scope Status</i></font></th></tr>\n");
	fp += sprintf(fp, "<tr><td><b>DHCP Range</b></td><td align=\"right\"><b>IPs Used</b></td><td align=\"right\"><b>IPs Free</b></td><td align=\"right\"><b>%% Free</b></td></tr>\n");
	MYBYTE colNum = 0;

	for (char rangeInd = 0; kRunning && rangeInd < cfig.rangeCount && fp < maxData; rangeInd++)
	{
		float ipused = 0;
		float ipfree = 0;
		int ind = 0;

		for (MYDWORD iip = cfig.dhcpRanges[rangeInd].rangeStart; iip <= cfig.dhcpRanges[rangeInd].rangeEnd; iip++, ind++)
		{
			if (cfig.dhcpRanges[rangeInd].expiry[ind] > t)
				ipused++;
			else
				ipfree++;
		}

		IP2String(tempbuff, ntohl(cfig.dhcpRanges[rangeInd].rangeStart));
		IP2String(extbuff, ntohl(cfig.dhcpRanges[rangeInd].rangeEnd));
		fp += sprintf(fp, "<tr><td>%s - %s</td><td align=\"right\">%5.0f</td><td align=\"right\">%5.0f</td><td align=\"right\">%2.2f</td></tr>\n", tempbuff, extbuff, ipused, ipfree, ((ipfree * 100)/(ipused + ipfree)));
	}

	fp += sprintf(fp, "</table>\n</body>\n</html>");
	memcpy((contentStart - 12), tempbuff, sprintf(tempbuff, "%u", (fp - contentStart)));
	req->bytes = fp - req->dp;

	pthread_t threadId;
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	int errcode = pthread_create(&threadId, &attr, sendHTTP, (void*)req);
	pthread_attr_destroy(&attr);

	return;
}

void *sendHTTP(void *lpParam)
{
	data19 *req = (data19*)lpParam;

//	sprintf(logBuff, "sendHTTP memsize=%d bytes=%d", req->memSize, req->bytes);
//	debug(logBuff);

	char *dp = req->dp;
	timeval tv1;
	fd_set writefds1;
	tv1.tv_sec = 5;
	tv1.tv_usec = 0;
	int sent = 0;

	while (kRunning && req->bytes > 0)
	{
		FD_ZERO(&writefds1);
		FD_SET(req->sock, &writefds1);

		if (select((req->sock + 1), NULL, &writefds1, NULL, &tv1))
		{
			if (req->bytes > 1024)
				sent  = send(req->sock, dp, 1024, 0);
			else
				sent  = send(req->sock, dp, req->bytes, 0);

			//errno = WSAGetLastError();

			if (errno || sent < 0)
				break;

			dp += sent;
			req->bytes -= sent;
		}
		else
			break;
	}

	closesocket(req->sock);
	free(req->dp);
	free(req);

	pthread_exit(NULL);
}

void procTCP(data5 *req)
{
	req->ling.l_onoff = 1; //0 = off (l_linger ignored), nonzero = on
	req->ling.l_linger = 10; //0 = discard data, nonzero = wait for data sent
	setsockopt(req->sock, SOL_SOCKET, SO_LINGER, (const char*)&req->ling, sizeof(req->ling));

	errno = 0;
	req->bytes = recvTcpDnsMess(req->sock, req->raw, true);
	//printf("%u\n",req->bytes);

	if (req->bytes < 2)
	{
		sprintf(logBuff, "Error Getting TCP DNS Message");
		logDNSMess(logBuff, 1);
		closesocket(req->sock);
		return;
	}

	MYWORD pktSize = fUShort(req->raw);
	req->dp = req->raw + 2;
	req->dnsp = (dnsPacket*)(req->dp);
	req->dp = &req->dnsp->data;

	if (req->dnsp->header.qr != 0 || ntohs(req->dnsp->header.qdcount) != 1 || ntohs(req->dnsp->header.ancount))
	{
		sprintf(logBuff, "DNS Query Format Error");
		logTCPMess(req, logBuff, 1);
		addRRNone(req);
		req->dnsp->header.rcode = RCODE_FORMATERROR;
		req->dnsp->header.qdcount = 0;
		sendTCPmess(req);
		closesocket(req->sock);
		return;
	}

	for (int i = 1; i <= ntohs(req->dnsp->header.qdcount); i++)
	{
		req->dp += fQu(req->query, req->dnsp, req->dp);
		req->qtype = fUShort(req->dp);
		req->dp += 2;
		req->qclass = fUShort(req->dp);
		req->dp += 2;
	}

	MYDWORD clientIP = req->remote.sin_addr.s_addr;

	if (!findServer(network.allServers, MAX_SERVERS, clientIP) && !findServer(cfig.zoneServers, MAX_TCP_CLIENTS, clientIP) && !findServer(&cfig.zoneServers[2], MAX_TCP_CLIENTS - 2, clientIP))
	{
		sprintf(logBuff, "DNS TCP Query, Access Denied");
		logTCPMess(req, logBuff, 1);
		addRRNone(req);
		req->dnsp->header.rcode = RCODE_REFUSED;
		sendTCPmess(req);
		closesocket(req->sock);
		return;
	}

	if (req->dnsp->header.opcode != OPCODE_STANDARD_QUERY)
	{
		switch (req->dnsp->header.opcode)
		{
			case OPCODE_INVERSE_QUERY:
				sprintf(logBuff, "Inverse query not supported");
				break;

			case OPCODE_SRVR_STAT_REQ:
				sprintf(logBuff, "Server Status Request not supported");
				break;

			case OPCODE_NOTIFY:
				sprintf(logBuff, "Notify not supported");
				break;

			case OPCODE_DYNAMIC_UPDATE:
				sprintf(logBuff, "Dynamic Update not needed/supported by Dual Server");
				break;

			default:
				sprintf(logBuff, "OpCode %u not supported", req->dnsp->header.opcode);
		}

		logTCPMess(req, logBuff, 1);

		addRRNone(req);
		req->dnsp->header.rcode = RCODE_NOTIMPL;
		sendTCPmess(req);
		closesocket(req->sock);
		return;
	}

	if (req->qclass != DNS_CLASS_IN)
	{
		sprintf(logBuff, "DNS Class %u not supported", req->qclass);
		logTCPMess(req, logBuff, 1);
		addRRNone(req);
		req->dnsp->header.rcode = RCODE_NOTIMPL;
		sendTCPmess(req);
		closesocket(req->sock);
		return;
	}

	if (!req->qtype)
	{
		sprintf(logBuff, "missing query type");
		logTCPMess(req, logBuff, 1);
		addRRNone(req);
		req->dnsp->header.rcode = RCODE_FORMATERROR;
		sendTCPmess(req);
		closesocket(req->sock);
		return;
	}

	strcpy(req->cname, req->query);
	strcpy(req->mapname, req->query);
	myLower(req->mapname);
	req->qLen = strlen(req->cname);
	req->dnType = makeLocal(req->mapname);
	bool AXFRError = false;

	if (req->dnType == DNTYPE_A_EXT && req->qLen > cfig.zLen)
	{
		char *dp = req->cname + (req->qLen - cfig.zLen);

		if (!strcasecmp(dp, cfig.zone))
			req->dnType = DNTYPE_A_SUBZONE;
	}

	if (req->qtype != DNS_TYPE_NS && req->qtype != DNS_TYPE_SOA && req->qtype != DNS_TYPE_AXFR && req->qtype != DNS_TYPE_IXFR)
	{
		addRRNone(req);
		req->dnsp->header.rcode = RCODE_NOTIMPL;
		sendTCPmess(req);
		sprintf(logBuff, "DNS TCP Query Type %s not supported", strqtype(tempbuff, req->qtype));
		logTCPMess(req, logBuff, 1);
	}
	else if (!cfig.authorized || (req->dnType != DNTYPE_A_ZONE && req->dnType != DNTYPE_A_SUBZONE && req->dnType != DNTYPE_P_ZONE && req->dnType != DNTYPE_P_LOCAL))
	{
		addRRNone(req);
		req->dnsp->header.rcode = RCODE_NOTAUTH;
		sendTCPmess(req);
		sprintf(logBuff, "Server is not authority for zone %s", req->query);
		logTCPMess(req, logBuff, 1);
	}
	else if (cfig.expireTime < t)
	{
		addRRNone(req);
		req->dnsp->header.rcode = RCODE_NOTZONE;
		sendTCPmess(req);
		sprintf(logBuff, "Zone %s expired", req->query);
		logTCPMess(req, logBuff, 1);
	}
	else
	{
		switch (req->qtype)
		{
			case DNS_TYPE_SOA:
				if (req->dnType == DNTYPE_A_ZONE || req->dnType == DNTYPE_P_ZONE)
				{
					addRRNone(req);
					addRRSOA(req);
					req->dnsp->header.aa = 0;
					req->dnsp->header.at = 0;
					req->dnsp->header.rcode = RCODE_NOERROR;
					sendTCPmess(req);
					sprintf(logBuff, "SOA Sent for zone %s", req->query);
					logTCPMess(req, logBuff, 2);
				}
				else
				{
					addRRNone(req);
					addRRSOAuth(req);
					req->dnsp->header.aa = 0;
					req->dnsp->header.at = 0;
					req->dnsp->header.rcode = RCODE_NOERROR;
					sendTCPmess(req);
					sprintf(logBuff, "%s not found", req->query);
					logDNSMess(req, logBuff, 2);
				}
				break;

			case DNS_TYPE_NS:
				if (req->dnType == DNTYPE_A_ZONE || req->dnType == DNTYPE_P_ZONE)
				{
					addRRNone(req);
					addRRNS(req);
					addRRAd(req);
					req->dnsp->header.aa = 0;
					req->dnsp->header.at = 0;
					req->dnsp->header.rcode = RCODE_NOERROR;
					sendTCPmess(req);
					sprintf(logBuff, "NS Sent for Zone %s", req->query);
					logTCPMess(req, logBuff, 2);
				}
				else
				{
					addRRNone(req);
					addNS(req);
					req->dnsp->header.aa = 0;
					req->dnsp->header.at = 0;
					req->dnsp->header.rcode = RCODE_NOERROR;
					sendTCPmess(req);
					sprintf(logBuff, "%s not found", req->query);
					logDNSMess(req, logBuff, 2);
				}
				break;

			case DNS_TYPE_AXFR:
			case DNS_TYPE_IXFR:

				if (req->dnType == DNTYPE_A_ZONE)
				{
					MYDWORD tempserial = cfig.serial1;
					MYWORD records = 0;

					addRRBlank(req);
					addRRSOA(req);

					if (!sendTCPmess(req))
					{
						AXFRError = true;
						break;
					}
					else
						records++;

					addRRBlank(req);
					addRRNS(req);

					if (!sendTCPmess(req))
					{
						AXFRError = true;
						break;
					}
					else
						records++;

					req->iterBegin = dnsCache[currentInd].begin();

					while (!AXFRError && req->iterBegin != dnsCache[currentInd].end())
					{
						addRRBlank(req);

						if (req->iterBegin->second->expiry > t)
						{
							//printf("%s=%d=%d\n",req->iterBegin->second->mapname, req->iterBegin->second->dataType, req->iterBegin->second->expiry);

							switch (req->iterBegin->second->dataType)
							{
								case LOCAL_A:
									addRRAOne(req);
									break;

								case SERVER_A_AUTH:
								case STATIC_A_AUTH:
									addRRSTAOne(req);
									break;

								case LOCAL_CNAME:
								case EXT_CNAME:
									addRRCNOne(req);
									break;

								default:
									req->iterBegin++;
									continue;
							}

							if (tempserial != cfig.serial1)
							{
								AXFRError = true;
								break;
							}

							if (!sendTCPmess(req))
							{
								AXFRError = true;
								break;
							}
							else
								records++;
						}
						req->iterBegin++;
					}

					for (int m = 0; m < cfig.mxCount[currentInd]; m++)
					{
						addRRBlank(req);
						addRRMXOne(req, m);

						if (tempserial != cfig.serial1)
						{
							AXFRError = true;
							break;
						}

						if (!sendTCPmess(req))
						{
							AXFRError = true;
							break;
						}
						else
							records++;
					}

					addRRBlank(req);
					addRRSOA(req);

					if (!AXFRError && tempserial == cfig.serial1)
					{
						if (sendTCPmess(req))
						{
							records++;
							sprintf(logBuff, "Zone %s with %d RRs Sent", req->query, records);
							logTCPMess(req, logBuff, 2);

//							if (cfig.replication && clientIP == cfig.zoneServers[1] && cfig.qc == 2)
//								cfig.qc = 3;
						}
					}
				}
				else if (req->dnType == DNTYPE_P_ZONE)
				{
/*
					if (clientIP == cfig.zoneServers[0])
					{
						addRRNone(req);
						req->dnsp->header.rcode = RCODE_REFUSED;
						sendTCPmess(req);
						closesocket(req->sock);
						return;
					}
*/
					MYDWORD tempserial = cfig.serial2;
					MYWORD records = 0;

					addRRBlank(req);
					addRRSOA(req);

					if (!sendTCPmess(req))
					{
						AXFRError = true;
						break;
					}
					else
						records++;

					addRRBlank(req);
					addRRNS(req);

					if (!sendTCPmess(req))
					{
						AXFRError = true;
						break;
					}
					else
						records++;

					req->iterBegin = dnsCache[currentInd].begin();

					while (!AXFRError && req->iterBegin != dnsCache[currentInd].end())
					{
						addRRBlank(req);

						if (req->iterBegin->second->expiry > t)
						{
							switch (req->iterBegin->second->dataType)
							{
								case LOCAL_PTR_AUTH:
								case STATIC_PTR_AUTH:
								case SERVER_PTR_AUTH:
									addRRPtrOne(req);
									break;

								default:
									req->iterBegin++;
									continue;
							}

							if (tempserial != cfig.serial2)
							{
								AXFRError = true;
								break;
							}

							if (!sendTCPmess(req))
							{
								AXFRError = true;
								break;
							}
							else
								records++;

						}
						req->iterBegin++;
					}

					addRRBlank(req);
					addRRSOA(req);

					if (!AXFRError && tempserial == cfig.serial2)
					{
						if (sendTCPmess(req))
						{
							records++;
							sprintf(logBuff, "Zone %s with %d RRs Sent", req->query, records);
							logTCPMess(req, logBuff, 2);

//							if (cfig.replication && clientIP == cfig.zoneServers[1] && cfig.qc == 3)
//								cfig.dnsRepl = t + cfig.refresh;
						}
					}
				}
				else
				{
					addRRNone(req);
					req->dnsp->header.rcode = RCODE_NOTAUTH;
					sendTCPmess(req);
					sprintf(logBuff, "Server is not authority for zone %s", req->query);
					logTCPMess(req, logBuff, 1);
				}
				break;
		}
	}
}

MYWORD sendTCPmess(data5 *req)
{
	errno = 0;
	req->dnsp->header.ra = 0;
	req->bytes = req->dp - req->raw;
	pUShort(req->raw, req->bytes - 2);

	if (req->bytes != send(req->sock, req->raw, req->bytes, 0) || errno)
		return 0;

	return req->bytes;
}

MYWORD gdnmess(data5 *req, MYBYTE sockInd)
{
	memset(req, 0, sizeof(data5));
	req->sockLen = sizeof(req->remote);
	errno = 0;

	req->bytes = recvfrom(network.dnsUdpConn[sockInd].sock,
	                      req->raw,
	                      sizeof(req->raw),
	                      0,
	                      (sockaddr*)&req->remote,
	                      &req->sockLen);

	//errno = WSAGetLastError();

	if (errno || req->bytes <= 0)
		return 0;

	req->sockInd = sockInd;
	req->dnsp = (dnsPacket*)req->raw;

	if (req->dnsp->header.qr != 0)
		return 0;

	if (req->dnsp->header.opcode != OPCODE_STANDARD_QUERY)
	{
		if (verbatim || cfig.dnsLogLevel >= 1)
		{
			switch (req->dnsp->header.opcode)
			{
				case OPCODE_INVERSE_QUERY:
					sprintf(logBuff, "Inverse query not supported");
					break;

				case OPCODE_SRVR_STAT_REQ:
					sprintf(logBuff, "Server Status Request not supported");
					break;

				case OPCODE_NOTIFY:
					sprintf(logBuff, "Notify not supported");
					break;

				case OPCODE_DYNAMIC_UPDATE:
					sprintf(logBuff, "Dynamic Update not needed/supported by Dual Server");
					break;

				default:
					sprintf(logBuff, "OpCode %d not supported", req->dnsp->header.opcode);
			}
			logDNSMess(req, logBuff, 1);
		}

		addRRBlank(req);
		req->dnsp->header.rcode = RCODE_NOTIMPL;
		return req->bytes;
	}

	if (ntohs(req->dnsp->header.qdcount) != 1 || ntohs(req->dnsp->header.ancount))
	{
		if (verbatim || cfig.dnsLogLevel >= 1)
		{
			sprintf(logBuff, "DNS Query Format Error");
			logDNSMess(req, logBuff, 1);
		}

		addRRBlank(req);
		req->dnsp->header.rcode = RCODE_FORMATERROR;
		return req->bytes;
	}

	req->dp = &req->dnsp->data;

	for (int i = 1; i <= ntohs(req->dnsp->header.qdcount); i++)
	{
		req->dp += fQu(req->query, req->dnsp, req->dp);
		req->qtype = fUShort(req->dp);
		req->dp += 2;
		req->qclass = fUShort(req->dp);
		req->dp += 2;
	}

	if (req->qclass != DNS_CLASS_IN)
	{
		if (verbatim || cfig.dnsLogLevel >= 1)
		{
			sprintf(logBuff, "DNS Class %d not supported", req->qclass);
			logDNSMess(req, logBuff, 1);
		}
		addRRNone(req);
		req->dnsp->header.rcode = RCODE_NOTIMPL;
		return req->bytes;
	}

	if (!req->qtype)
	{
		if (verbatim || cfig.dnsLogLevel >= 1)
		{
			sprintf(logBuff, "missing query type");
			logDNSMess(req, logBuff, 1);
		}

		addRRNone(req);
		req->dnsp->header.rcode = RCODE_FORMATERROR;
		return req->bytes;
	}

	MYDWORD ip = req->remote.sin_addr.s_addr;
	MYDWORD iip = ntohl(ip);

	for (int i = 0; i < MAX_DNS_RANGES && cfig.dnsRanges[i].rangeStart; i++)
	{
		if (iip >= cfig.dnsRanges[i].rangeStart && iip <= cfig.dnsRanges[i].rangeEnd)
			return req->bytes;
	}

	if (isLocal(ip))
		return req->bytes;

	if (findEntry(currentInd, IP2String(req->cname, iip)))
		return req->bytes;

	if (findServer(network.allServers, MAX_SERVERS, ip))
		return req->bytes;

	addRRNone(req);
	req->dnsp->header.rcode = RCODE_REFUSED;

	if (verbatim || cfig.dnsLogLevel >= 1)
	{
		sprintf(logBuff, "DNS UDP Query, Access Denied");
		logDNSMess(req, logBuff, 1);
	}
	return req->bytes;
}

MYWORD sdnmess(data5 *req)
{
	errno = 0;
	req->bytes = req->dp - req->raw;

	req->bytes = sendto(network.dnsUdpConn[req->sockInd].sock,
	                    req->raw,
	                    req->bytes,
	                    0,
	                    (sockaddr*)&req->remote,
	                    sizeof(req->remote));

	//errno = WSAGetLastError();

	if (errno || req->bytes <= 0)
		return 0;

	return req->bytes;
}

MYWORD scanloc(data5 *req)
{
	if (!req->query[0])
		return 0;

	strcpy(req->cname, req->query);
	strcpy(req->mapname, req->query);
	myLower(req->mapname);
	req->dnType = makeLocal(req->mapname);
	//printf("LocalCode=%u query=%s mapname=%s\n", req->dnType, req->query, req->mapname);

	switch (req->qtype)
	{
		case DNS_TYPE_PTR:
			break;

		case DNS_TYPE_A:
			if (req->dnType == DNTYPE_A_BARE)
			{
				sprintf(req->cname, "%s.%s", req->query, cfig.zone);
			}
			break;

		case DNS_TYPE_MX:
			if (!strcasecmp(req->query, cfig.zone) && (cfig.authorized || cfig.mxServers[currentInd][0].hostname[0]))
			{
				addRRNone(req);
				addRRMX(req);
				addNS(req);
				return 1;
			}
			else
				return 0;

			break;

		case DNS_TYPE_NS:
			if (cfig.authorized)
			{
				if (req->dnType == DNTYPE_P_ZONE)
				{
					addRRNone(req);
					addRRNS(req);
					addRRAd(req);
					return 1;
				}
				else if (req->dnType == DNTYPE_A_ZONE)
				{
					addRRNone(req);
					addRRNS(req);
					addRRAd(req);
					return 1;
				}
			}
			return 0;
			break;

		case DNS_TYPE_SOA:
			if (cfig.authorized)
			{
				if (req->dnType == DNTYPE_P_ZONE)
				{
					addRRNone(req);
					addRRSOA(req);

					if (cfig.replication == 1 && req->remote.sin_addr.s_addr == cfig.zoneServers[1] && cfig.qc == 1)
					{
						cfig.dnsRepl = t + cfig.refresh;
						cfig.qc = 0;
					}

					return 1;
				}
				else if (req->dnType == DNTYPE_A_ZONE)
				{
					addRRNone(req);
					addRRSOA(req);

					if (cfig.replication == 1 && req->remote.sin_addr.s_addr == cfig.zoneServers[1])
						cfig.qc = 1;

					return 1;
				}
			}
			return 0;
			break;

		case DNS_TYPE_ANY:
			req->iterBegin = dnsCache[currentInd].find(req->mapname);

			if (req->iterBegin != dnsCache[currentInd].end() && req->iterBegin->second->dataType != CACHED)
			{
				switch (req->dnType)
				{
					case DNTYPE_A_BARE:
						addRRNone(req);
						sprintf(req->cname, "%s.%s", req->mapname, cfig.zone);
						req->dnsp->header.ancount = htons(htons(req->dnsp->header.ancount) + 1);
						req->dp += pQu(req->dp, req->mapname);
						req->dp += pUShort(req->dp, DNS_TYPE_CNAME);
						req->dp += pUShort(req->dp, DNS_CLASS_IN);
						req->dp += pULong(req->dp, cfig.lease);
						req->dp += pUShort(req->dp, qLen(req->cname));
						req->dp += pQu(req->dp, req->cname);
						req->dnsp->header.ancount = htons(1);
						addRRAny(req, true);
						return 1;
						break;

					case DNTYPE_A_ZONE:
						addRRNone(req);
						if (cfig.authorized)
						{
							addRRSOA(req);
							addRRNS(req);
							req->dnsp->header.ancount = htons(2);
						}

						for (int m = 0; m < cfig.mxCount[currentInd]; m++)
							addRRMXOne(req, m);

						addRRAny(req, false);

						//if (cfig.authorized)
						//	addRRAd(req);

						return 1;
						break;


					case DNTYPE_P_ZONE:
						addRRNone(req);
						if (cfig.authorized)
						{
							addRRSOA(req);
							addRRNS(req);
							req->dnsp->header.ancount = htons(2);
						}

						//if (cfig.authorized)
						//	addRRAd(req);

						return 1;
						break;
					default:
						addRRNone(req);
						addRRAny(req, false);
						return 1;
						break;
				}
			}
			else
			{
				switch (req->dnType)
				{
					case DNTYPE_A_ZONE:
						addRRNone(req);
						if (cfig.authorized)
						{
							addRRSOA(req);
							addRRNS(req);
							req->dnsp->header.ancount = htons(2);
						}

						for (int m = 0; m < cfig.mxCount[currentInd]; m++)
							addRRMXOne(req, m);

//						if (cfig.authorized)
//							addRRAd(req);

						return 1;
						break;


					case DNTYPE_P_ZONE:
						addRRNone(req);
						if (cfig.authorized)
						{
							addRRSOA(req);
							addRRNS(req);
							req->dnsp->header.ancount = htons(2);
						}

//						if (cfig.authorized)
//							addRRAd(req);

						return 1;
						break;

					case DNTYPE_A_LOCAL:
					case DNTYPE_P_LOCAL:
					case DNTYPE_A_EXT:
					case DNTYPE_P_EXT:
						return 0;
						break;

					default:
						addRRNone(req);
						return 1;
						break;
				}
			}

			break;

		default:

			if (cfig.authorized && req->dnType != DNTYPE_A_EXT && req->dnType != DNTYPE_P_EXT)
			{
				if (verbatim || cfig.dnsLogLevel)
				{
					sprintf(logBuff, "%s, DNS Query Type %s not supported", req->query, strqtype(tempbuff, req->qtype));
					logDNSMess(req, logBuff, 1);
				}
				addRRNone(req);
				req->dnsp->header.rcode = RCODE_NOTIMPL;
				addNS(req);
				return 1;
			}
			else
				return 0;

			break;
	}

	for (int m = 0; m < 3; m++)
	{
		//printf("%s has %u Entries\n", req->mapname, dnsCache[currentInd].count(req->mapname));
		req->iterBegin = dnsCache[currentInd].find(req->mapname);
		//if (req->iterBegin != dnsCache[currentInd].end() && req->iterBegin->second->expiry >= t)
		if (req->iterBegin != dnsCache[currentInd].end())
		{
			memcpy(&req->cache, req->iterBegin->second, sizeof(data7));
			//printf("mapname=%s, datatype=%i exp=%u\n",req->cache.mapname, req->cache.dataType,req->cache.expiry);

			switch (req->cache.dataType)
			{
				case LOCAL_A:
				case STATIC_A_AUTH:
					addRRNone(req);
					addRRA(req);
					addNS(req);
					return 1;

				case LOCAL_PTR_AUTH:
				case STATIC_PTR_AUTH:
				case SERVER_PTR_AUTH:
					addRRNone(req);
					addRRPtr(req);
					addNS(req);
					return 1;

				case LOCALHOST_A:
					addRRNone(req);
					addRRLocalhostA(req);
					addNS(req);
					return 1;

				case LOCALHOST_PTR:
					addRRNone(req);
					addRRLocalhostPtr(req);
					addNS(req);
					return 1;

				case STATIC_A_NAUTH:
					addRRNone(req);
					addRRA(req);
					return 1;

				case LOCAL_PTR_NAUTH:
				case SERVER_PTR_NAUTH:
				case STATIC_PTR_NAUTH:
					addRRNone(req);
					addRRPtr(req);
					return 1;

				case SERVER_A_AUTH:
					addRRNone(req);
					addRRServerA(req);
					addNS(req);
					return 1;

				case CACHED:
					addRRNone(req);
					addRRExt(req);
					return 1;

				case LOCAL_CNAME:
				case EXT_CNAME:

					//printf("mapname=%s, hostname=%s datatype=%i exp=%u\n",req->cache.mapname, req->cache.hostname, req->cache.dataType,req->cache.expiry);

					if (!req->cache.hostname[0])
						strcpy(req->cname, cfig.zone);
					else if (strchr(req->cache.hostname, '.'))
						strcpy(req->cname, req->cache.hostname);
					else
						sprintf(req->cname, "%s.%s", req->cache.hostname, cfig.zone);

					strcpy(req->mapname, req->cache.hostname);
					myLower(req->mapname);
					continue;

				default:
					break;
			}
		}

		break;
	}

	if (req->qtype == DNS_TYPE_A && cfig.wildHosts[0].wildcard[0])
	{
		for (MYBYTE i = 0; i < MAX_WILD_HOSTS && cfig.wildHosts[i].wildcard[0]; i++)
		{
			if (wildcmp(req->mapname, cfig.wildHosts[i].wildcard))
			{
				addRRNone(req);

				if (cfig.wildHosts[i].ip)
					addRRWildA(req, cfig.wildHosts[i].ip);

				return 1;
			}
		}
	}

	if (req->cache.dataType == LOCAL_CNAME)
	{
		addRRNone(req);
		addRRA(req);
		addNS(req);
		return 1;
	}
	else if (req->cache.dataType == NONE && (req->dnType == DNTYPE_A_BARE || req->dnType == DNTYPE_A_ZONE || req->dnType == DNTYPE_P_ZONE))
	{
		addRRNone(req);
		addNS(req);
		return 1;
	}
	else if (req->cache.dataType == EXT_CNAME)
	{
		//printf("mapname=%s, hostname=%s datatype=%i exp=%u\n",req->cache.mapname, req->cache.hostname, req->cache.dataType,req->cache.expiry);
		req->dnType = makeLocal(req->mapname);
		req->dp = &req->dnsp->data;
		req->dp += pQu(req->dp, req->cname);
		req->dp += pUShort(req->dp, DNS_TYPE_A);
		req->dp += pUShort(req->dp, DNS_CLASS_IN);
		req->bytes = req->dp - req->raw;
	}

	return 0;
}

MYWORD fdnmess(data5 *req)
{
	//printf("before dnType=%d %d\n", req->dnType, DNTYPE_A_SUBZONE);
	req->qLen = strlen(req->cname);
	MYBYTE zoneDNS;
	int nRet = -1;

	char mapname[8];
	sprintf(mapname, "%u", req->dnsp->header.xid);
	data7 *queue = findEntry(currentInd, mapname, QUEUE);

	for (zoneDNS = 0; zoneDNS < MAX_COND_FORW && cfig.dnsRoutes[zoneDNS].zLen; zoneDNS++)
	{
		if (req->qLen == cfig.dnsRoutes[zoneDNS].zLen && !strcasecmp(req->cname, cfig.dnsRoutes[zoneDNS].zone))
			req->dnType = DNTYPE_CHILDZONE;
		else if (req->qLen > cfig.dnsRoutes[zoneDNS].zLen)
		{
			char *dp = req->cname + (req->qLen - cfig.dnsRoutes[zoneDNS].zLen - 1);

			if (*dp == '.' && !strcasecmp(dp + 1, cfig.dnsRoutes[zoneDNS].zone))
				req->dnType = DNTYPE_CHILDZONE;
		}

		if (req->dnType == DNTYPE_CHILDZONE)
		{
			if (queue && cfig.dnsRoutes[zoneDNS].dns[1])
				cfig.dnsRoutes[zoneDNS].currentDNS = 1 - cfig.dnsRoutes[zoneDNS].currentDNS;

			if (req->remote.sin_addr.s_addr != cfig.dnsRoutes[zoneDNS].dns[cfig.dnsRoutes[zoneDNS].currentDNS])
			{
				req->addr.sin_family = AF_INET;
				req->addr.sin_addr.s_addr = cfig.dnsRoutes[zoneDNS].dns[cfig.dnsRoutes[zoneDNS].currentDNS];
				req->addr.sin_port = htons(IPPORT_DNS);
				errno = 0;

				nRet = sendto(network.forwConn.sock,
							  req->raw,
							  req->bytes,
							  0,
							  (sockaddr*)&req->addr,
							  sizeof(req->addr));

				//errno = WSAGetLastError();

				if (errno || nRet <= 0)
				{
					if (verbatim || cfig.dnsLogLevel)
					{
						sprintf(logBuff, "Error Forwarding UDP DNS Message to Conditional Forwarder %s", IP2String(tempbuff, req->addr.sin_addr.s_addr));
						logDNSMess(req, logBuff, 1);
						addRRNone(req);
						req->dnsp->header.rcode = RCODE_SERVERFAIL;
					}

					if (cfig.dnsRoutes[zoneDNS].dns[1])
						cfig.dnsRoutes[zoneDNS].currentDNS = 1 - cfig.dnsRoutes[zoneDNS].currentDNS;

					return 0;
				}
				else
				{
					if (verbatim || cfig.dnsLogLevel >= 2)
					{
						sprintf(logBuff, "%s forwarded to Conditional Forwarder %s", req->cname, IP2String(tempbuff, cfig.dnsRoutes[zoneDNS].dns[cfig.dnsRoutes[zoneDNS].currentDNS]));
						logDNSMess(req, logBuff, 2);
					}
				}
			}

			break;
		}
	}

	if (req->dnType != DNTYPE_CHILDZONE)
	{
		char *dp = 0;

		if (req->dnType == DNTYPE_A_EXT && req->qLen > cfig.zLen)
		{
			dp = req->cname + (req->qLen - cfig.zLen);

			if (!strcasecmp(dp, cfig.zone))
				req->dnType = DNTYPE_A_SUBZONE;
		}

		//printf("after dnType=%d %d\n", req->dnType, DNTYPE_A_SUBZONE);

		if (cfig.authorized && (req->dnType == DNTYPE_A_LOCAL || req->dnType == DNTYPE_A_SUBZONE || req->dnType == DNTYPE_P_LOCAL))
		{
			if (verbatim || cfig.dnsLogLevel >= 2)
			{
				sprintf(logBuff, "%s not found", req->query);
				logDNSMess(req, logBuff, 2);
			}

			switch (req->qtype)
			{
				case DNS_TYPE_NS:
					addRRNone(req);
					addNS(req);
					req->dnsp->header.rcode = RCODE_NOERROR;
					return 0;

				case DNS_TYPE_SOA:
					addRRNone(req);
					addRRSOAuth(req);
					req->dnsp->header.rcode = RCODE_NOERROR;
					return 0;

				default:
					addRRNone(req);
					addNS(req);
					req->dnsp->header.rcode = RCODE_NAMEERROR;
					return 0;
			}
		}

		if (!req->dnsp->header.rd)
		{
			addRRNone(req);
			req->dnsp->header.rcode = RCODE_NAMEERROR;

			if (verbatim || cfig.dnsLogLevel)
			{
				sprintf(logBuff, "%s is not found (recursion not desired)", req->query);
				logDNSMess(req, logBuff, 2);
			}
			return 0;
		}

		if (!network.dns[0])
		{
			addRRNone(req);
			req->dnsp->header.rcode = RCODE_NAMEERROR;
			req->dnsp->header.ra = 0;

			if (verbatim || cfig.dnsLogLevel)
			{
				sprintf(logBuff, "%s not found (recursion not available)", req->query);
				logDNSMess(req, logBuff, 2);
			}
			return 0;
		}

		if (queue && network.dns[1] && queue->dnsIndex < MAX_SERVERS && network.currentDNS == queue->dnsIndex)
		{
			network.currentDNS++;

			if (network.currentDNS >= MAX_SERVERS || !network.dns[network.currentDNS])
				network.currentDNS = 0;
		}

		if (req->remote.sin_addr.s_addr != network.dns[network.currentDNS])
		{
			req->addr.sin_family = AF_INET;
			req->addr.sin_addr.s_addr = network.dns[network.currentDNS];
			req->addr.sin_port = htons(IPPORT_DNS);
			errno = 0;

			nRet = sendto(network.forwConn.sock,
						  req->raw,
						  req->bytes,
						  0,
						  (sockaddr*)&req->addr,
						  sizeof(req->addr));

			//errno = WSAGetLastError();

			if (errno || nRet <= 0)
			{
				if (verbatim || cfig.dnsLogLevel)
				{
					sprintf(logBuff, "Error forwarding UDP DNS Message to Forwarding Server %s", IP2String(tempbuff, network.dns[network.currentDNS]));
					logDNSMess(req, logBuff, 1);
					addRRNone(req);
					req->dnsp->header.rcode = RCODE_SERVERFAIL;
				}

				if (network.dns[1])
				{
					network.currentDNS++;

					if (network.currentDNS >= MAX_SERVERS || !network.dns[network.currentDNS])
						network.currentDNS = 0;
				}

				return 0;
			}
			else
			{
				if (verbatim || cfig.dnsLogLevel >= 2)
				{
					sprintf(logBuff, "%s forwarded to Forwarding Server %s", req->cname, IP2String(tempbuff, network.dns[network.currentDNS]));
					logDNSMess(req, logBuff, 2);
				}
			}
		}
	}

	//printf("LocalCode=%u query=%s cname=%s mapname=%s\n", req->dnType, req->query, req->cname, req->mapname);

	if (!queue)
	{
		queue = (data7*)calloc(1, sizeof(data7));

		if (queue)
		{
			queue->mapname = cloneString(mapname);
			queue->addr = (SOCKADDR_IN*)calloc(1, sizeof(req->remote));
			queue->query = cloneString(req->query);

			if (!queue->mapname || !queue->addr || !queue->query)
			{
				if (queue->mapname)
					free(queue->mapname);

				if (queue->addr)
					free(queue->addr);

				if (queue->query)
					free(queue->query);

				free(queue);
				sprintf(logBuff, "Memory Allocation Error");
				logDNSMess(logBuff, 1);
				return 0;
			}

			memcpy(queue->addr, &req->remote, sizeof(req->remote));
			queue->expiry = 2 + t;
			queue->dataType = QUEUE;
			addEntry(currentInd, queue);
		}
		else
		{
			sprintf(logBuff, "Memory Allocation Error");
			logDNSMess(logBuff, 1);
			return 0;
		}
	}
	else
	{
		queue->expiry = 2 + t;
		memcpy(queue->addr, &req->remote, sizeof(req->remote));

		if (strcasecmp(queue->query, req->query))
		{
			char *query = cloneString(req->query);

			if (query)
			{
				free(queue->query);
				queue->query = query;
			}
			else
			{
				sprintf(logBuff, "Memory Allocation Error");
				logDNSMess(logBuff, 1);
				return 0;
			}
		}
	}

	queue->sockInd = req->sockInd;

	if (req->dnType == DNTYPE_CHILDZONE)
		queue->dnsIndex = 128 + (2 * zoneDNS) + cfig.dnsRoutes[zoneDNS].currentDNS;
	else
		queue->dnsIndex = network.currentDNS;

	//printf("%u %u\n", zoneDNS, queue->dnsIndex);

	return (nRet);
}

MYWORD frdnmess(data5 *req)
{
	memset(req, 0, sizeof(data5));
	req->sockLen = sizeof(req->remote);
	errno = 0;

	req->bytes = recvfrom(network.forwConn.sock,
	                      req->raw,
	                      sizeof(req->raw),
	                      0,
	                      (sockaddr*)&req->remote,
	                      &req->sockLen);

	//printf("%u\n", req->bytes);
	//errno = WSAGetLastError();

	if (errno || req->bytes <= 0)
		return 0;

	req->dnsp = (dnsPacket*)req->raw;

	char mapname[8];
	MYWORD type = 0;
	sprintf(mapname, "%u", req->dnsp->header.xid);
	data7 *queue = findEntry(currentInd, mapname);

	if (queue && queue->expiry)
	{
		queue->expiry = 0;

		if (queue->dnsIndex < MAX_SERVERS)
		{
			if (req->remote.sin_addr.s_addr != network.dns[network.currentDNS])
			{
				for (MYBYTE i = 0; i < MAX_SERVERS && network.dns[i]; i++)
				{
					if (network.dns[i] == req->remote.sin_addr.s_addr)
					{
						network.currentDNS = i;
						break;
					}
				}
			}
		}
		else if (queue->dnsIndex >= 128 && queue->dnsIndex < 192)
		{
			data6 *dnsRoute = &cfig.dnsRoutes[(queue->dnsIndex - 128) / 2];

			if (dnsRoute->dns[0] == req->remote.sin_addr.s_addr)
				dnsRoute->currentDNS = 0;
			else if (dnsRoute->dns[1] == req->remote.sin_addr.s_addr)
				dnsRoute->currentDNS = 1;
		}

		if (queue->dataType == DNS_CHECK)
		{
			if (verbatim || cfig.dnsLogLevel >= 1)
			{
				if (queue->dnsIndex < MAX_SERVERS)
				{
					sprintf(logBuff, "Forwarding DNS Server %s responded", IP2String(tempbuff, req->remote.sin_addr.s_addr));
					logDNSMess(logBuff, 1);
				}
				else if (queue->dnsIndex >= 128 && queue->dnsIndex < 192)
				{
					sprintf(logBuff, "Child DNS Server %s responded", IP2String(tempbuff, req->remote.sin_addr.s_addr));
					logDNSMess(logBuff, 1);
				}
			}

			return 0;
		}
		else if (queue->dataType == QUEUE)
		{
			memcpy(&req->remote, queue->addr, sizeof(req->remote));
			strcpy(req->query, queue->query);
			req->sockInd = queue->sockInd;
			req->cache.dnsIndex = queue->dnsIndex;

			req->dp = &req->dnsp->data;

			for (int i = 1; i <= ntohs(req->dnsp->header.qdcount); i++)
			{
				req->dp += fQu(req->cname, req->dnsp, req->dp);
				type = fUShort(req->dp);
				req->dp += 4; //type and class
			}

			if ((type == DNS_TYPE_A || type == DNS_TYPE_PTR) && !req->dnsp->header.rcode && !req->dnsp->header.tc && req->dnsp->header.ancount)
			{
				time_t expiry = 0;
				bool resultFound = false;

				for (int i = 1; i <= ntohs(req->dnsp->header.ancount); i++)
				{
					req->dp += fQu(tempbuff, req->dnsp, req->dp);
					type = fUShort(req->dp);

					//printf("%s %u=%u\n", tempbuff, type, DNS_TYPE_A);

					if (type == DNS_TYPE_A)
					{
						resultFound = true;
						strcpy(req->mapname, req->cname);
						myLower(req->mapname);
						makeLocal(req->mapname);
					}
					else if (type == DNS_TYPE_PTR)
					{
						strcpy(req->mapname, req->cname);
						myLower(req->mapname);
						char *dp = strstr(req->mapname, arpa);

						if (dp && !strcasecmp(dp, arpa))
						{
							*dp = 0;
							resultFound = true;
						}
					}

					req->dp += 4; //type and class

					if (!expiry || fULong(req->dp) < (MYDWORD)expiry)
						expiry = fULong(req->dp);

					req->dp += 4; //ttl
					int zLen = fUShort(req->dp);
					req->dp += 2; //datalength
					req->dp += zLen;
				}

				if (resultFound)
				{
					MYWORD cacheSize = req->dp - req->raw;

					if (cfig.minCache && expiry < cfig.minCache)
						expiry = cfig.minCache;

					if (cfig.maxCache && expiry > cfig.maxCache)
						expiry = cfig.maxCache;

					if (expiry < INT_MAX - t)
						expiry += t;
					else
						expiry = INT_MAX;

					data7 *cache = findEntry(currentInd, req->mapname, CACHED);

					if (cache)
					{
						if (cache->bytes < cacheSize)
						{
							MYBYTE *response = (MYBYTE*)calloc(1, cacheSize);

							if (response)
							{
								if (cache->response)
									free(cache->response);

								cache->response = response;
							}
							else
							{
								sprintf(logBuff, "Memory Allocation Error");
								logDNSMess(logBuff, 1);
								return 0;
							}
						}
						cache->expiry = expiry;
					}
					else
					{
						cache = (data7*)calloc(1, sizeof(data7));

						if (!cache)
						{
							sprintf(logBuff, "Memory Allocation Error");
							logDNSMess(logBuff, 1);
							return 0;
						}

						cache->mapname = cloneString(req->mapname);
						cache->response = (MYBYTE*)calloc(1, cacheSize);

						if (!cache->mapname || !cache->response)
						{
							if (cache->mapname)
								free(cache->mapname);

							if (cache->response)
								free(cache->response);

							free(cache);

							sprintf(logBuff, "Memory Allocation Error");
							logDNSMess(logBuff, 1);
							return 0;
						}

						cache->expiry = expiry;
						cache->dataType = CACHED;
						addEntry(currentInd, cache);

					}

					memcpy(cache->response, req->dnsp, cacheSize);
					((dnsPacket*)cache->response)->header.nscount = 0;
					((dnsPacket*)cache->response)->header.adcount = 0;
					cache->bytes = cacheSize;
				}
			}

			req->cache.dataType = NON_CACHED;
			addRRExt(req);
			return 1;
		}
	}
	return 0;
}

void add2Cache(MYBYTE ind, char *hostname, MYDWORD ip, time_t expiry, MYBYTE aType, MYBYTE pType)
{
	//printf("Adding to %u, %s=%s exp=%u\n",ind, hostname,IP2String(tempbuff, ip),expiry);
	char tempbuff[256];
	char logBuff[256];

	if (!hostname || !ip)
		return;

	data7 *cache = NULL;
	hostMap::iterator p;

	if (pType)
	{
		IP2String(tempbuff, htonl(ip));
		p = dnsCache[ind].find(tempbuff);

		for (;p != dnsCache[ind].end(); p++)
		{
			if (strcasecmp(p->second->mapname, tempbuff))
				break;

			if (!strcasecmp(p->second->hostname, hostname))
			{
				cache = p->second;
				break;
			}
		}

		if (!cache)
		{
			cache = (data7*)calloc(1, sizeof(data7));

			if (cache)
			{
				cache->mapname = cloneString(tempbuff);
				cache->hostname = cloneString(hostname);

				if (!cache->mapname || !cache->hostname)
				{
					if (cache->mapname)
						free(cache->mapname);

					if (cache->hostname)
						free(cache->hostname);

					free(cache);

					sprintf(logBuff, "Memory Allocation Error");
					logDNSMess(logBuff, 1);
					return;
				}

				cache->dataType = pType;
				cache->expiry = expiry;
				addEntry(ind, cache);

				if (cfig.replication != 2 && pType == LOCAL_PTR_AUTH)
					cfig.serial2 = t;
			}
			else
			{
				sprintf(logBuff, "Memory Allocation Error");
				logDNSMess(logBuff, 1);
				return;
			}
		}
		else if (cache->expiry < expiry)
		{
			cache->dataType = pType;
			cache->expiry = expiry;
		}
	}

	if (aType)
	{
		cache = NULL;
		strcpy(tempbuff, hostname);
		makeLocal(tempbuff);
		myLower(tempbuff);

		p = dnsCache[ind].find(tempbuff);

		for (; p != dnsCache[ind].end(); p++)
		{
			if (strcasecmp(p->second->mapname, tempbuff))
				break;

			if (p->second->ip == ip)
			{
				cache = p->second;
				break;
			}
		}

		if (!cache)
		{
			cache = (data7*)calloc(1, sizeof(data7));

			if (cache)
			{
				cache->mapname = cloneString(tempbuff);

				if (!cache->mapname)
				{
					sprintf(logBuff, "Memory Allocation Error");
					logDNSMess(logBuff, 1);
					free(cache);
					return;
				}

				cache->ip = ip;
				cache->dataType = aType;
				cache->expiry = expiry;
				addEntry(ind, cache);
			}
			else
			{
				sprintf(logBuff, "Memory Allocation Error");
				logDNSMess(logBuff, 1);
				return;
			}

			if (cfig.replication != 2 && aType == LOCAL_A)
				cfig.serial1 = t;
		}
		else if (cache->expiry < expiry)
		{
			cache->dataType = aType;
			cache->expiry = expiry;
		}
	}
}

void addHostNotFound(MYBYTE ind, char *hostname)
{
	data7 *cache = (data7*)calloc(1, sizeof(data7));

	if (cache)
	{
		cache->mapname = myLower(cloneString(hostname));

		if (!cache->mapname)
		{
			sprintf(logBuff, "Memory Allocation Error");
			free(cache);
			logDNSMess(logBuff, 1);
			return;
		}

		cache->ip = 0;
		cache->dataType = STATIC_A_NAUTH;
		cache->expiry = INT_MAX;
		addEntry(ind, cache);
	}
	else
	{
		sprintf(logBuff, "Memory Allocation Error");
		logDNSMess(logBuff, 1);
		return;
	}
}

char* getResult(data5 *req)
{
	try
	{
		tempbuff[0] = 0;
		extbuff[0] = 0;
		char *raw = &req->dnsp->data;
		MYWORD queueIndex;

		for (int i = 1; i <= ntohs(req->dnsp->header.qdcount); i++)
		{
			raw += fQu(extbuff, req->dnsp, raw);
			raw += 4;
		}

		for (int i = 1; i <= ntohs(req->dnsp->header.ancount); i++)
		{
			raw += fQu(extbuff, req->dnsp, raw);
			int type = fUShort(raw);
			raw += 2; //type
			raw += 2; //class
			raw += 4; //ttl
			int zLen = fUShort(raw);
			raw += 2; //datalength

			if (type == DNS_TYPE_A)
				return IP2String(tempbuff, fIP(raw));
			else if (type == DNS_TYPE_AAAA)
				return IP62String(tempbuff, (MYBYTE*)raw);
			else if (type == DNS_TYPE_PTR)
			{
				fQu(tempbuff, req->dnsp, raw);
				return tempbuff;
			}
			else if (type == DNS_TYPE_MX)
				fQu(tempbuff, req->dnsp, (raw + 2));
			else if (type == DNS_TYPE_CNAME)
				fQu(tempbuff, req->dnsp, raw);
			else if (type == DNS_TYPE_NS)
				fQu(tempbuff, req->dnsp, raw);

			raw += zLen;
		}

		if (tempbuff[0])
			return tempbuff;
		else
			return NULL;
	}
	catch(...)
	{
		return NULL;
	}
}

bool checkRange(data17 *rangeData, char rangeInd)
{
	//debug("checkRange");

	if (!cfig.hasFilter)
		return true;

	MYBYTE rangeSetInd = cfig.dhcpRanges[rangeInd].rangeSetInd;
	data14 *rangeSet = &cfig.rangeSet[rangeSetInd];
	//printf("checkRange entering, rangeInd=%i rangeSetInd=%i\n", rangeInd, rangeSetInd);
	//printf("checkRange entered, macFound=%i vendFound=%i userFound=%i\n", macFound, vendFound, userFound);

	if((!rangeData->macFound && !rangeSet->macSize[0]) || (rangeData->macFound && rangeData->macArray[rangeSetInd]))
		if((!rangeData->vendFound && !rangeSet->vendClassSize[0]) || (rangeData->vendFound && rangeData->vendArray[rangeSetInd]))
			if((!rangeData->userFound && !rangeSet->userClassSize[0]) || (rangeData->userFound && rangeData->userArray[rangeSetInd]))
				if((!rangeData->subnetFound && !rangeSet->subnetIP[0]) || (rangeData->subnetFound && rangeData->subnetArray[rangeSetInd]))
					return true;

	//printf("checkRange, returning false rangeInd=%i rangeSetInd=%i\n", rangeInd, rangeSetInd);
	return false;
}

MYDWORD resad(data9 *req)
{
	MYDWORD minRange = 0;
	MYDWORD maxRange = 0;

	if (req->dhcpp.header.bp_giaddr)
	{
		lockIP(req->dhcpp.header.bp_giaddr);
		lockIP(req->remote.sin_addr.s_addr);
	}

	req->dhcpEntry = findDHCPEntry(req->chaddr);

	if (req->dhcpEntry && req->dhcpEntry->fixed)
	{
		if (req->dhcpEntry->ip)
		{
			setTempLease(req->dhcpEntry);
			return req->dhcpEntry->ip;
		}
		else
		{
			if (verbatim || cfig.dhcpLogLevel)
			{
				sprintf(logBuff, "Static DHCP Host %s (%s) has No IP, DHCPDISCOVER ignored", req->chaddr, req->hostname);
				logMess(logBuff, 1);
			}
			return 0;
		}
	}

	MYDWORD iipNew = 0;
	MYDWORD iipExp = 0;
	MYDWORD rangeStart = 0;
	MYDWORD rangeEnd = 0;
	char rangeInd = -1;
	bool rangeFound = false;
	data17 rangeData;
	memset(&rangeData, 0, sizeof(data17));

	if (cfig.hasFilter)
	{
		for (MYBYTE rangeSetInd = 0; rangeSetInd < MAX_RANGE_SETS && cfig.rangeSet[rangeSetInd].active; rangeSetInd++)
		{
			data14 *rangeSet = &cfig.rangeSet[rangeSetInd];

			for (MYBYTE i = 0; i < MAX_RANGE_FILTERS && rangeSet->macSize[i]; i++)
			{
				//printf("%s\n", hex2String(tempbuff, rangeSet->macStart[i], rangeSet->macSize[i]));
				//printf("%s\n", hex2String(tempbuff, rangeSet->macEnd[i], rangeSet->macSize[i]));

				if(memcmp(req->dhcpp.header.bp_chaddr, rangeSet->macStart[i], rangeSet->macSize[i]) >= 0 && memcmp(req->dhcpp.header.bp_chaddr, rangeSet->macEnd[i], rangeSet->macSize[i]) <= 0)
				{
					rangeData.macArray[rangeSetInd] = 1;
					rangeData.macFound = true;
					//printf("mac Found, rangeSetInd=%i\n", rangeSetInd);
					break;
				}
			}

			for (MYBYTE i = 0; i < MAX_RANGE_FILTERS && req->vendClass.size && rangeSet->vendClassSize[i]; i++)
			{
				if(rangeSet->vendClassSize[i] == req->vendClass.size && !memcmp(req->vendClass.value, rangeSet->vendClass[i], rangeSet->vendClassSize[i]))
				{
					rangeData.vendArray[rangeSetInd] = 1;
					rangeData.vendFound = true;
					//printf("vend Found, rangeSetInd=%i\n", rangeSetInd);
					break;
				}
			}

			for (MYBYTE i = 0; i < MAX_RANGE_FILTERS && req->userClass.size && rangeSet->userClassSize[i]; i++)
			{
				if(rangeSet->userClassSize[i] == req->userClass.size && !memcmp(req->userClass.value, rangeSet->userClass[i], rangeSet->userClassSize[i]))
				{
					rangeData.userArray[rangeSetInd] = 1;
					rangeData.userFound = true;
					//printf("user Found, rangeSetInd=%i\n", rangeSetInd);
					break;
				}
			}

			for (MYBYTE i = 0; i < MAX_RANGE_FILTERS && req->subnetIP && rangeSet->subnetIP[i]; i++)
			{
				if(req->subnetIP == rangeSet->subnetIP[i])
				{
					rangeData.subnetArray[rangeSetInd] = 1;
					rangeData.subnetFound = true;
					//printf("subnet Found, rangeSetInd=%i\n", rangeSetInd);
					break;
				}
			}
		}

	}

//	printArray("macArray", (char*)cfig.macArray);
//	printArray("vendArray", (char*)cfig.vendArray);
//	printArray("userArray", (char*)cfig.userArray);

	if (req->dhcpEntry)
	{
		req->dhcpEntry->rangeInd = getRangeInd(req->dhcpEntry->ip);

		if (req->dhcpEntry->rangeInd >= 0)
		{
			int ind = getIndex(req->dhcpEntry->rangeInd, req->dhcpEntry->ip);

			if (cfig.dhcpRanges[req->dhcpEntry->rangeInd].dhcpEntry[ind] == req->dhcpEntry && checkRange(&rangeData, req->dhcpEntry->rangeInd))
			{
				MYBYTE rangeSetInd = cfig.dhcpRanges[req->dhcpEntry->rangeInd].rangeSetInd;

				if (!cfig.rangeSet[rangeSetInd].subnetIP[0])
				{
					MYDWORD mask = cfig.dhcpRanges[req->dhcpEntry->rangeInd].mask;
					calcRangeLimits(req->subnetIP, mask, &minRange, &maxRange);

					if (htonl(req->dhcpEntry->ip) >= minRange && htonl(req->dhcpEntry->ip) <= maxRange)
					{
						setTempLease(req->dhcpEntry);
						return req->dhcpEntry->ip;
					}
				}
				else
				{
					setTempLease(req->dhcpEntry);
					return req->dhcpEntry->ip;
				}
			}
		}
	}

	if (dnsService && req->hostname[0])
	{
		char hostname[256];
		strcpy(hostname, req->hostname);
		myLower(hostname);
		hostMap::iterator it = dnsCache[currentInd].find(hostname);

		for (; it != dnsCache[currentInd].end(); it++)
		{
			data7 *cache = it->second;

			//printf("%u\n", cache->mapname);

			if (strcasecmp(cache->mapname, hostname))
				break;

			if (cache && cache->ip)
			{
				char k = getRangeInd(cache->ip);

				if (k >= 0)
				{
					if (checkRange(&rangeData, k))
					{
						data13 *range = &cfig.dhcpRanges[k];
						int ind = getIndex(k, cache->ip);

						if (ind >= 0 && range->expiry[ind] <= t)
						{
							MYDWORD iip = htonl(cache->ip);

							if (!cfig.rangeSet[range->rangeSetInd].subnetIP[0])
							{
								calcRangeLimits(req->subnetIP, range->mask, &minRange, &maxRange);

								if (iip >= minRange && iip <= maxRange)
								{
									iipNew = iip;
									rangeInd = k;
									break;
								}
							}
							else
							{
								iipNew = iip;
								rangeInd = k;
								break;
							}
						}
					}
				}
			}
		}
	}

	if (!iipNew && req->reqIP)
	{
		char k = getRangeInd(req->reqIP);

		if (k >= 0)
		{
			if (checkRange(&rangeData, k))
			{
				data13 *range = &cfig.dhcpRanges[k];
				int ind = getIndex(k, req->reqIP);

				if (range->expiry[ind] <= t)
				{
					if (!cfig.rangeSet[range->rangeSetInd].subnetIP[0])
					{
						calcRangeLimits(req->subnetIP, range->mask, &minRange, &maxRange);
						MYDWORD iip = htonl(req->reqIP);

						if (iip >= minRange && iip <= maxRange)
						{
							iipNew = iip;
							rangeInd = k;
						}
					}
					else
					{
						MYDWORD iip = htonl(req->reqIP);
						iipNew = iip;
						rangeInd = k;
					}
				}
			}
		}
	}


	for (char k = 0; !iipNew && k < cfig.rangeCount; k++)
	{
		if (checkRange(&rangeData, k))
		{
			data13 *range = &cfig.dhcpRanges[k];
			rangeStart = range->rangeStart;
			rangeEnd = range->rangeEnd;

			if (!cfig.rangeSet[range->rangeSetInd].subnetIP[0])
			{
				calcRangeLimits(req->subnetIP, range->mask, &minRange, &maxRange);

				if (rangeStart < minRange)
					rangeStart = minRange;

				if (rangeEnd > maxRange)
					rangeEnd = maxRange;
			}

			if (rangeStart <= rangeEnd)
			{
				rangeFound = true;

				if (cfig.replication == 2)
				{
					for (MYDWORD m = rangeEnd; m >= rangeStart; m--)
					{
						int ind = m - range->rangeStart;

						if (!range->expiry[ind])
						{
							iipNew = m;
							rangeInd = k;
							break;
						}
						else if (!iipExp && range->expiry[ind] < t)
						{
							iipExp = m;
							rangeInd = k;
						}
					}
				}
				else
				{
					for (MYDWORD m = rangeStart; m <= rangeEnd; m++)
					{
						int ind = m - range->rangeStart;

						if (!range->expiry[ind])
						{
							iipNew = m;
							rangeInd = k;
							break;
						}
						else if (!iipExp && range->expiry[ind] < t)
						{
							iipExp = m;
							rangeInd = k;
						}
					}
				}
			}
		}
	}


	if (!iipNew && iipExp)
			iipNew = iipExp;

	if (iipNew)
	{
		if (!req->dhcpEntry)
		{
			req->dhcpEntry = (data7*)calloc(1, sizeof(data7));

			if (!req->dhcpEntry)
			{
				sprintf(logBuff, "Memory Allocation Error");
				logMess(logBuff, 1);
				return 0;
			}

			req->dhcpEntry->mapname = cloneString(req->chaddr);

			if (!req->dhcpEntry->mapname)
			{
				sprintf(logBuff, "Memory Allocation Error");
				logMess(logBuff, 1);
				return 0;
			}

			dhcpCache[req->dhcpEntry->mapname] = req->dhcpEntry;
		}

		req->dhcpEntry->ip = htonl(iipNew);
		req->dhcpEntry->rangeInd = rangeInd;
		setTempLease(req->dhcpEntry);
		//req->dhcpEntry->source = network.dhcpConn[req->sockInd].server;

		return req->dhcpEntry->ip;
	}

	if (verbatim || cfig.dhcpLogLevel)
	{
		if (rangeFound)
		{
			if (req->dhcpp.header.bp_giaddr)
				sprintf(logBuff, "No free leases for DHCPDISCOVER for %s (%s) from RelayAgent %s", req->chaddr, req->hostname, IP2String(tempbuff, req->dhcpp.header.bp_giaddr));
			else
				sprintf(logBuff, "No free leases for DHCPDISCOVER for %s (%s) from interface %s", req->chaddr, req->hostname, IP2String(tempbuff, network.dhcpConn[req->sockInd].server));
		}
		else
		{
			if (req->dhcpp.header.bp_giaddr)
				sprintf(logBuff, "No Matching DHCP Range for DHCPDISCOVER for %s (%s) from RelayAgent %s", req->chaddr, req->hostname, IP2String(tempbuff, req->dhcpp.header.bp_giaddr));
			else
				sprintf(logBuff, "No Matching DHCP Range for DHCPDISCOVER for %s (%s) from interface %s", req->chaddr, req->hostname, IP2String(tempbuff, network.dhcpConn[req->sockInd].server));
		}
		logMess(logBuff, 1);
	}
	return 0;
}

MYDWORD chad(data9 *req)
{
	req->dhcpEntry = findDHCPEntry(req->chaddr);
	//printf("dhcpEntry=%d\n", req->dhcpEntry);

	if (req->dhcpEntry && req->dhcpEntry->ip)
		return req->dhcpEntry->ip;
	else
		return 0;
}

MYDWORD sdmess(data9 *req)
{
	if (req->req_type == DHCP_MESS_NONE)
	{
		req->dhcpp.header.bp_yiaddr = chad(req);

		if (!req->dhcpp.header.bp_yiaddr)
		{
			if (verbatim || cfig.dhcpLogLevel)
			{
				sprintf(logBuff, "No Static Entry found for BOOTPREQUEST from Host %s", req->chaddr);
				logMess(logBuff, 1);
			}

			return 0;
		}
	}
	else if (req->req_type == DHCP_MESS_DECLINE)
	{
		if (req->dhcpp.header.bp_ciaddr && chad(req) == req->dhcpp.header.bp_ciaddr)
		{
			lockIP(req->dhcpp.header.bp_ciaddr);

			req->dhcpEntry->ip = 0;
			req->dhcpEntry->expiry = INT_MAX;
			req->dhcpEntry->display = false;
			req->dhcpEntry->local = false;

			if (verbatim || cfig.dhcpLogLevel)
			{
				sprintf(logBuff, "IP Address %s declined by Host %s (%s), locked", IP2String(tempbuff, req->dhcpp.header.bp_ciaddr), req->chaddr, req->hostname);
				logMess(logBuff, 1);
			}
		}

		return 0;
	}
	else if (req->req_type == DHCP_MESS_RELEASE)
	{
		if (req->dhcpp.header.bp_ciaddr && chad(req) == req->dhcpp.header.bp_ciaddr)
		{
			req->lease = 0;
			updateDHCP(req);

			if (verbatim || cfig.dhcpLogLevel)
			{
				sprintf(logBuff, "IP Address %s released by Host %s (%s)", IP2String(tempbuff, req->dhcpp.header.bp_ciaddr), req->chaddr, req->hostname);
				logMess(logBuff, 1);
			}
		}

		return 0;
	}
	else if (req->req_type == DHCP_MESS_INFORM)
	{
		//printf("repl0=%s\n", IP2String(tempbuff, cfig.zoneServers[0]));
		//printf("repl1=%s\n", IP2String(tempbuff, cfig.zoneServers[1]));
		//printf("IP=%s bytes=%u replication=%i\n", IP2String(tempbuff, req->remote.sin_addr.s_addr), req->bytes, cfig.replication);

		if ((cfig.replication == 1 && req->remote.sin_addr.s_addr == cfig.zoneServers[1]) || (cfig.replication == 2 && req->remote.sin_addr.s_addr == cfig.zoneServers[0]))
			recvRepl(req);

		return 0;
	}
	else if (req->req_type == DHCP_MESS_DISCOVER && strcasecmp(req->hostname, cfig.servername))
	{
		req->dhcpp.header.bp_yiaddr = resad(req);

		if (!req->dhcpp.header.bp_yiaddr)
			return 0;

		req->resp_type = DHCP_MESS_OFFER;
	}
	else if (req->req_type == DHCP_MESS_REQUEST)
	{
		//printf("%s\n", IP2String(tempbuff, req->dhcpp.header.bp_ciaddr));

		if (req->server)
		{
			if (req->server == network.dhcpConn[req->sockInd].server)
			{
				if (req->reqIP && req->reqIP == chad(req) && req->dhcpEntry->expiry > t)
				{
					req->resp_type = DHCP_MESS_ACK;
					req->dhcpp.header.bp_yiaddr = req->reqIP;
				}
				else if (req->dhcpp.header.bp_ciaddr && req->dhcpp.header.bp_ciaddr == chad(req) && req->dhcpEntry->expiry > t)
				{
					req->resp_type = DHCP_MESS_ACK;
					req->dhcpp.header.bp_yiaddr = req->dhcpp.header.bp_ciaddr;
				}
				else
				{
					req->resp_type = DHCP_MESS_NAK;
					req->dhcpp.header.bp_yiaddr = 0;

					if (verbatim || cfig.dhcpLogLevel)
					{
						sprintf(logBuff, "DHCPREQUEST from Host %s (%s) without Discover, NAKed", req->chaddr, req->hostname);
						logMess(logBuff, 1);
					}
				}
			}
			else
				return 0;
		}
		else if (req->dhcpp.header.bp_ciaddr && req->dhcpp.header.bp_ciaddr == chad(req) && req->dhcpEntry->expiry > t)
		{
			req->resp_type = DHCP_MESS_ACK;
			req->dhcpp.header.bp_yiaddr = req->dhcpp.header.bp_ciaddr;
		}
		else if (req->reqIP && req->reqIP == chad(req) && req->dhcpEntry->expiry > t)
		{
			req->resp_type = DHCP_MESS_ACK;
			req->dhcpp.header.bp_yiaddr = req->reqIP;
		}
		else
		{
			req->resp_type = DHCP_MESS_NAK;
			req->dhcpp.header.bp_yiaddr = 0;

			if (verbatim || cfig.dhcpLogLevel)
			{
				sprintf(logBuff, "DHCPREQUEST from Host %s (%s) without Discover, NAKed", req->chaddr, req->hostname);
				logMess(logBuff, 1);
			}
		}
	}
	else
		return 0;

	addOptions(req);
	int packSize = req->vp - (MYBYTE*)&req->dhcpp;
	packSize++;

	if (req->req_type == DHCP_MESS_NONE)
		packSize = req->messsize;

	if ((req->dhcpp.header.bp_giaddr || !req->remote.sin_addr.s_addr) && req->dhcpEntry && req->dhcpEntry->rangeInd >= 0)
	{
		MYBYTE rangeSetInd = cfig.dhcpRanges[req->dhcpEntry->rangeInd].rangeSetInd;
		req->targetIP = cfig.rangeSet[rangeSetInd].targetIP;
	}

	if (req->targetIP)
	{
		req->remote.sin_port = htons(IPPORT_DHCPS);
		req->remote.sin_addr.s_addr = req->targetIP;
	}
	else if (req->dhcpp.header.bp_giaddr)
	{
		req->remote.sin_port = htons(IPPORT_DHCPS);
		req->remote.sin_addr.s_addr = req->dhcpp.header.bp_giaddr;
	}
	else if (req->dhcpp.header.bp_broadcast || !req->remote.sin_addr.s_addr || req->reqIP)
	{
		req->remote.sin_port = htons(IPPORT_DHCPC);
		req->remote.sin_addr.s_addr = INADDR_BROADCAST;
	}
	else
	{
		req->remote.sin_port = htons(IPPORT_DHCPC);
	}

	req->dhcpp.header.bp_op = BOOTP_REPLY;
	errno = 0;

	if (req->req_type == DHCP_MESS_DISCOVER && !req->dhcpp.header.bp_giaddr)
	{
		req->bytes = sendto(network.dhcpConn[req->sockInd].sock,
							req->raw,
							packSize,
							MSG_DONTROUTE,
							(sockaddr*)&req->remote,
							sizeof(req->remote));
	}
	else
	{
		req->bytes = sendto(network.dhcpConn[req->sockInd].sock,
							req->raw,
							packSize,
							0,
							(sockaddr*)&req->remote,
							sizeof(req->remote));
	}

	if (errno || req->bytes <= 0)
		return 0;

	//printf("goes=%s %i\n",IP2String(tempbuff, req->dhcpp.header.bp_yiaddr),req->sockInd);
	return req->dhcpp.header.bp_yiaddr;
}

MYDWORD alad(data9 *req)
{
	//debug("alad");
	//printf("in alad hostname=%s\n", req->hostname);

	if (req->dhcpEntry && (req->req_type == DHCP_MESS_NONE || req->resp_type == DHCP_MESS_ACK))
	{
		MYDWORD retVal = updateDHCP(req);

		if (retVal)
		{
			if (dnsService && cfig.replication != 2)
				updateDNS(req);

			if (verbatim || cfig.dhcpLogLevel >= 1)
			{
				if (req->lease && req->reqIP)
				{
					sprintf(logBuff, "Host %s (%s) allotted %s for %u seconds", req->chaddr, req->hostname, IP2String(tempbuff, req->dhcpp.header.bp_yiaddr), req->lease);
				}
				else if (req->req_type)
				{
					sprintf(logBuff, "Host %s (%s) renewed %s for %u seconds", req->chaddr, req->hostname, IP2String(tempbuff, req->dhcpp.header.bp_yiaddr), req->lease);
				}
				else
				{
					sprintf(logBuff, "BOOTP Host %s (%s) allotted %s", req->chaddr, req->hostname, IP2String(tempbuff, req->dhcpp.header.bp_yiaddr));
				}
				logMess(logBuff, 1);
			}

			if (cfig.replication && cfig.dhcpRepl > t)
				sendRepl(req);

			return retVal;
		}
	}
	else if ((verbatim || cfig.dhcpLogLevel >= 2) && req->resp_type == DHCP_MESS_OFFER)
	{
		sprintf(logBuff, "Host %s (%s) offered %s", req->chaddr, req->hostname, IP2String(tempbuff, req->dhcpp.header.bp_yiaddr));
		logMess(logBuff, 2);
	}
	//printf("%u=out\n", req->resp_type);
	return 0;
}

void addOptions(data9 *req)
{
	//debug("addOptions");

	data3 op;
	int i;

	if (req->req_type && req->resp_type)
	{
		op.opt_code = DHCP_OPTION_MESSAGETYPE;
		op.size = 1;
		op.value[0] = req->resp_type;
		pvdata(req, &op);
	}

	if (req->dhcpEntry && req->resp_type != DHCP_MESS_DECLINE && req->resp_type != DHCP_MESS_NAK)
	{
		strcpy(req->dhcpp.header.bp_sname, cfig.servername);

		if (req->dhcpEntry->fixed)
		{
			//printf("%u,%u\n", req->dhcpEntry->options, *req->dhcpEntry->options);
			MYBYTE *opPointer = req->dhcpEntry->options;

			if (opPointer)
			{
				MYBYTE requestedOnly = *opPointer;
				opPointer++;

				while (*opPointer && *opPointer != DHCP_OPTION_END)
				{
					op.opt_code = *opPointer;
					opPointer++;
					op.size = *opPointer;
					opPointer++;

					if (!requestedOnly || req->paramreqlist[*opPointer])
					{
						memcpy(op.value, opPointer, op.size);
						pvdata(req, &op);
					}
					opPointer += op.size;
				}
			}
		}

		if (req->req_type && req->resp_type)
		{
			if (req->dhcpEntry->rangeInd >= 0)
			{
				MYBYTE *opPointer = cfig.dhcpRanges[req->dhcpEntry->rangeInd].options;
				//printf("Range=%i Pointer=%u\n", req->dhcpEntry->rangeInd,opPointer);

				if (opPointer)
				{
					MYBYTE requestedOnly = *opPointer;
					opPointer++;

					while (*opPointer && *opPointer != DHCP_OPTION_END)
					{
						op.opt_code = *opPointer;
						opPointer++;
						op.size = *opPointer;
						opPointer++;

						if (!requestedOnly || req->paramreqlist[*opPointer])
						{
							memcpy(op.value, opPointer, op.size);
							pvdata(req, &op);
						}
						opPointer += op.size;
					}
				}
			}

			MYBYTE *opPointer = cfig.options;

			if (opPointer)
			{
				MYBYTE requestedOnly = *opPointer;

				opPointer++;
				while (*opPointer && *opPointer != DHCP_OPTION_END)
				{
					op.opt_code = *opPointer;
					opPointer++;
					op.size = *opPointer;
					opPointer++;

					if (!requestedOnly || req->paramreqlist[*opPointer])
					{
						memcpy(op.value, opPointer, op.size);
						pvdata(req, &op);
					}
					opPointer += op.size;
				}
			}

			op.opt_code = DHCP_OPTION_SERVERID;
			op.size = 4;
			pIP(op.value, network.dhcpConn[req->sockInd].server);
			pvdata(req, &op);

			op.opt_code = DHCP_OPTION_DOMAINNAME;
			op.size = strlen(cfig.zone) + 1;
			memcpy(op.value, cfig.zone, op.size);
			pvdata(req, &op);

			if (!req->opAdded[DHCP_OPTION_IPADDRLEASE])
			{
				op.opt_code = DHCP_OPTION_IPADDRLEASE;
				op.size = 4;
				pULong(op.value, cfig.lease);
				pvdata(req, &op);
			}

			if (!req->opAdded[DHCP_OPTION_NETMASK])
			{
				op.opt_code = DHCP_OPTION_NETMASK;
				op.size = 4;

				if (req->dhcpEntry->rangeInd >= 0)
					pIP(op.value, cfig.dhcpRanges[req->dhcpEntry->rangeInd].mask);
				else
					pIP(op.value, cfig.mask);

				pvdata(req, &op);
			}

			if (!req->hostname[0])
				genHostName(req->hostname, req->dhcpp.header.bp_chaddr, req->dhcpp.header.bp_hlen);

			if (!req->dhcpEntry->hostname)
					req->dhcpEntry->hostname = cloneString(req->hostname);
			else if (req->hostname[0] && strcasecmp(req->dhcpEntry->hostname, req->hostname))
			{
				free(req->dhcpEntry->hostname);
				req->dhcpEntry->hostname = cloneString(req->hostname);
			}

/*
			if (!req->opAdded[DHCP_OPTION_ROUTER])
			{
				op.opt_code = DHCP_OPTION_ROUTER;
				op.size = 4;
				pIP(op.value, network.dhcpConn[req->sockInd].server);
				pvdata(req, &op);
			}
*/
			if (!req->opAdded[DHCP_OPTION_DNS])
			{
				if (dnsService)
				{
					op.opt_code = DHCP_OPTION_DNS;

					if (cfig.dhcpRepl > t && cfig.dnsRepl > t)
					{
						if (cfig.replication == 1)
						{
							op.size = 8;
							pIP(op.value, cfig.zoneServers[0]);
							pIP(op.value + 4, cfig.zoneServers[1]);
							pvdata(req, &op);
						}
						else
						{
							op.size = 8;
							pIP(op.value, cfig.zoneServers[1]);
							pIP(op.value + 4, cfig.zoneServers[0]);
							pvdata(req, &op);
						}
					}
					else if (cfig.dnsRepl > t)
					{
						op.size = 8;
						pIP(op.value, cfig.zoneServers[1]);
						pIP(op.value + 4, cfig.zoneServers[0]);
						pvdata(req, &op);
					}
					else
					{
						op.size = 4;
						pIP(op.value, network.dhcpConn[req->sockInd].server);
						pvdata(req, &op);
					}
				}
				else if (cfig.dnsRepl > t && cfig.replication == 2)
				{
					op.opt_code = DHCP_OPTION_DNS;
					op.size = 4;
					pIP(op.value, cfig.zoneServers[0]);
					pvdata(req, &op);
				}
			}
/*
			if (!req->opAdded[DHCP_OPTION_HOSTNAME])
			{
				op.opt_code = DHCP_OPTION_HOSTNAME;
				op.size = strlen(req->hostname);
				memcpy(op.value, req->hostname, op.size);
				pvdata(req, &op);
			}

			if (req->clientId.opt_code == DHCP_OPTION_CLIENTID)
				pvdata(req, &req->clientId);
*/
			if (req->subnet.opt_code == DHCP_OPTION_SUBNETSELECTION)
				pvdata(req, &req->subnet);

			if (req->agentOption.opt_code == DHCP_OPTION_RELAYAGENTINFO)
				pvdata(req, &req->agentOption);
		}
	}

	*(req->vp) = DHCP_OPTION_END;
}

void pvdata(data9 *req, data3 *op)
{
	//debug("pvdata");

	if (!req->opAdded[op->opt_code] && ((req->vp - (MYBYTE*)&req->dhcpp) + op->size < req->messsize))
	{
		if (op->opt_code == DHCP_OPTION_NEXTSERVER)
			req->dhcpp.header.bp_siaddr = fIP(op->value);
		else if (op->opt_code == DHCP_OPTION_BP_FILE)
		{
			if (op->size <= 128)
				memcpy(req->dhcpp.header.bp_file, op->value, op->size);
		}
		else if(op->size)
		{
			if (op->opt_code == DHCP_OPTION_IPADDRLEASE)
			{
				if (!req->lease || req->lease > fULong(op->value))
					req->lease = fULong(op->value);

				if (req->lease >= INT_MAX)
					req->lease = UINT_MAX;

				pULong(op->value, req->lease);
			}
			else if (op->opt_code == DHCP_OPTION_REBINDINGTIME)
				req->rebind = fULong(op->value);
			else if (op->opt_code == DHCP_OPTION_HOSTNAME)
			{
				memcpy(req->hostname, op->value, op->size);
				req->hostname[op->size] = 0;
			}

			memcpy(req->vp, op, (op->size + 2));
			(req->vp) += 2;
			(req->vp) += op->size;
		}
		req->opAdded[op->opt_code] = true;
	}
}

MYDWORD updateDHCP(data9 *req)
{
	//debug("updateDHCP");
	data8 *dhcpData = (data8*)calloc(1, sizeof(data8));
	strcpy(dhcpData->hostname, req->hostname);
	memcpy(dhcpData->bp_chaddr, req->dhcpp.header.bp_chaddr, req->dhcpp.header.bp_hlen);
	dhcpData->bp_hlen = req->dhcpp.header.bp_hlen;
	dhcpData->ip = req->dhcpEntry->ip;
	dhcpData->local = 1;

	MYDWORD hangTime = req->lease;

	if (req->rebind > req->lease)
		hangTime = req->rebind;

	if (!req->req_type || hangTime > (MYDWORD)(INT_MAX - t))
	{
		req->dhcpEntry->expiry = INT_MAX;
		dhcpData->expiry = INT_MAX;
	}
	else
	{
		dhcpData->expiry = hangTime + t;
		req->dhcpEntry->expiry = dhcpData->expiry;
	}

	req->dhcpEntry->display = true;
	req->dhcpEntry->local = true;
	setLeaseExpiry(req->dhcpEntry);

	if (req->dhcpEntry->dhcpInd)
		dhcpData->dhcpInd = req->dhcpEntry->dhcpInd;
	else
	{
		cfig.dhcpInd++;
		req->dhcpEntry->dhcpInd = cfig.dhcpInd;
	}

	pthread_t threadId;
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	int errcode = pthread_create(&threadId, &attr, updateStateFile, (void*)dhcpData);
	pthread_attr_destroy(&attr);

	return req->dhcpEntry->ip;
}

void updateDNS(data9 *req)
{
	MYDWORD expiry = INT_MAX;

	if (req->lease < (MYDWORD)(INT_MAX - t))
		expiry = t + req->lease;

	if (req->dhcpEntry && cfig.replication != 2)
	{
		//printf("Update DNS t=%d exp=%d\n", t, req->dhcpEntry->expiry);
		if (isLocal(req->dhcpEntry->ip))
			add2Cache(currentInd, req->hostname, req->dhcpEntry->ip, expiry, LOCAL_A, LOCAL_PTR_AUTH);
		else
			add2Cache(currentInd, req->hostname, req->dhcpEntry->ip, expiry, LOCAL_A, LOCAL_PTR_NAUTH);
	}
}

void setTempLease(data7 *dhcpEntry)
{
	if (dhcpEntry && dhcpEntry->ip)
	{
		dhcpEntry->display = false;
		dhcpEntry->local = false;
		dhcpEntry->expiry = t + 20;

		int ind = getIndex(dhcpEntry->rangeInd, dhcpEntry->ip);

		if (ind >= 0)
		{
			if (cfig.dhcpRanges[dhcpEntry->rangeInd].expiry[ind] != INT_MAX)
				cfig.dhcpRanges[dhcpEntry->rangeInd].expiry[ind] = dhcpEntry->expiry;

			cfig.dhcpRanges[dhcpEntry->rangeInd].dhcpEntry[ind] = dhcpEntry;
		}
	}
}

void setLeaseExpiry(data7 *dhcpEntry, MYDWORD lease)
{
	//printf("%d=%d\n", t, lease);
	if (dhcpEntry && dhcpEntry->ip)
	{
		if (lease > (MYDWORD)(INT_MAX - t))
			dhcpEntry->expiry = INT_MAX;
		else
			dhcpEntry->expiry = t + lease;

		int ind = getIndex(dhcpEntry->rangeInd, dhcpEntry->ip);

		if (ind >= 0)
		{
			if (cfig.dhcpRanges[dhcpEntry->rangeInd].expiry[ind] != INT_MAX)
				cfig.dhcpRanges[dhcpEntry->rangeInd].expiry[ind] = dhcpEntry->expiry;

			cfig.dhcpRanges[dhcpEntry->rangeInd].dhcpEntry[ind] = dhcpEntry;
		}
	}
}

void setLeaseExpiry(data7 *dhcpEntry)
{
	if (dhcpEntry && dhcpEntry->ip)
	{
		int ind = getIndex(dhcpEntry->rangeInd, dhcpEntry->ip);

		if (ind >= 0)
		{
			if (cfig.dhcpRanges[dhcpEntry->rangeInd].expiry[ind] != INT_MAX)
				cfig.dhcpRanges[dhcpEntry->rangeInd].expiry[ind] = dhcpEntry->expiry;

			cfig.dhcpRanges[dhcpEntry->rangeInd].dhcpEntry[ind] = dhcpEntry;
		}
	}
}

void lockIP(MYDWORD ip)
{
	if (dhcpService && ip)
	{
		MYDWORD iip = htonl(ip);

		for (char rangeInd = 0; rangeInd < cfig.rangeCount; rangeInd++)
		{
			if (iip >= cfig.dhcpRanges[rangeInd].rangeStart && iip <= cfig.dhcpRanges[rangeInd].rangeEnd)
			{
				int ind = iip - cfig.dhcpRanges[rangeInd].rangeStart;

				if (cfig.dhcpRanges[rangeInd].expiry[ind] != INT_MAX)
					cfig.dhcpRanges[rangeInd].expiry[ind] = INT_MAX;

				break;
			}
		}
	}
}

void holdIP(MYDWORD ip)
{
	if (dhcpService && ip)
	{
		MYDWORD iip = htonl(ip);

		for (char rangeInd = 0; rangeInd < cfig.rangeCount; rangeInd++)
		{
			if (iip >= cfig.dhcpRanges[rangeInd].rangeStart && iip <= cfig.dhcpRanges[rangeInd].rangeEnd)
			{
				int ind = iip - cfig.dhcpRanges[rangeInd].rangeStart;

				if (cfig.dhcpRanges[rangeInd].expiry[ind] == 0)
					cfig.dhcpRanges[rangeInd].expiry[ind] = 1;

				break;
			}
		}
	}
}

void *sendToken(void *lpParam)
{
	//debug("Send Token");
	sleep(10);

	while (true)
	{
		errno = 0;

		sendto(cfig.dhcpReplConn.sock,
				token.raw,
				token.bytes,
				0,
				(sockaddr*)&token.remote,
				sizeof(token.remote));

//		errno = WSAGetLastError();
//
//		if (!errno && (verbatim || cfig.dhcpLogLevel >= 2))
//		{
//			sprintf(logBuff, "Token Sent");
//			logMess(logBuff, 2);
//		}

		sleep(300);
	}

	pthread_exit(NULL);
}


MYDWORD sendRepl(data9 *req)
{
	data3 op;

	MYBYTE *opPointer = req->dhcpp.vend_data;

	while ((*opPointer) != DHCP_OPTION_END && opPointer < req->vp)
	{
		if ((*opPointer) == DHCP_OPTION_MESSAGETYPE)
		{
			*(opPointer + 2) = DHCP_MESS_INFORM;
			break;
		}
		opPointer = opPointer + *(opPointer + 1) + 2;
	}

	if (!req->opAdded[DHCP_OPTION_MESSAGETYPE])
	{
		op.opt_code = DHCP_OPTION_MESSAGETYPE;
		op.size = 1;
		op.value[0] = DHCP_MESS_INFORM;
		pvdata(req, &op);
	}

	if (req->hostname[0] && !req->opAdded[DHCP_OPTION_HOSTNAME])
	{
		op.opt_code = DHCP_OPTION_HOSTNAME;
		op.size = strlen(req->hostname);
		memcpy(op.value, req->hostname, op.size);
		pvdata(req, &op);
	}

//	op.opt_code = DHCP_OPTION_SERIAL;
//	op.size = 4;
//	pULong(op.value, cfig.serial1);
//	pvdata(req, &op);

	*(req->vp) = DHCP_OPTION_END;
	req->vp++;
	req->bytes = req->vp - (MYBYTE*)req->raw;

	req->dhcpp.header.bp_op = BOOTP_REQUEST;
	errno = 0;

	req->bytes = sendto(cfig.dhcpReplConn.sock,
	                    req->raw,
	                    req->bytes,
	                    0,
						(sockaddr*)&token.remote,
						sizeof(token.remote));

	//errno = WSAGetLastError();

	if (errno || req->bytes <= 0)
	{
		cfig.dhcpRepl = 0;

		if (verbatim || cfig.dhcpLogLevel >= 1)
		{
			if (cfig.replication == 1)
				sprintf(logBuff, "Error %s Sending DHCP Update to Secondary Server", strerror(errno));
			else
				sprintf(logBuff, "Error %s Sending DHCP Update to Primary Server", strerror(errno));

			logMess(logBuff, 1);
		}

		return 0;
	}
	else if (verbatim || cfig.dhcpLogLevel >= 2)
	{
		if (cfig.replication == 1)
			sprintf(logBuff, "DHCP Update for host %s (%s) sent to Secondary Server", req->dhcpEntry->mapname, IP2String(tempbuff, req->dhcpEntry->ip));
		else
			sprintf(logBuff, "DHCP Update for host %s (%s) sent to Primary Server", req->dhcpEntry->mapname, IP2String(tempbuff, req->dhcpEntry->ip));

		logMess(logBuff, 2);
	}

	return req->dhcpp.header.bp_yiaddr;
}

/*
MYDWORD sendRepl(data7 *dhcpEntry)
{
	data9 req;
	memset(&req, 0, sizeof(data9));
	req.vp = req.dhcpp.vend_data;
	req.messsize = sizeof(dhcp_packet);
	req.dhcpEntry = dhcpEntry;

	req.dhcpp.header.bp_op = BOOTP_REQUEST;
	req.dhcpp.header.bp_xid = t;
	req.dhcpp.header.bp_ciaddr = dhcpEntry->ip;
	req.dhcpp.header.bp_yiaddr = dhcpEntry->ip;
	req.dhcpp.header.bp_hlen = 16;
	getHexValue(req.dhcpp.header.bp_chaddr, req.dhcpEntry->mapname, &(req.dhcpp.header.bp_hlen));
	req.dhcpp.header.bp_magic_num[0] = 99;
	req.dhcpp.header.bp_magic_num[1] = 130;
	req.dhcpp.header.bp_magic_num[2] = 83;
	req.dhcpp.header.bp_magic_num[3] = 99;
	strcpy(req.hostname, dhcpEntry->hostname);

	return sendRepl(&req);
}
*/

void recvRepl(data9 *req)
{
	cfig.dhcpRepl = t + 600;

	MYDWORD ip = req->dhcpp.header.bp_yiaddr ? req->dhcpp.header.bp_yiaddr : req->dhcpp.header.bp_ciaddr;

	if (!ip || !req->dhcpp.header.bp_hlen)
	{
//		if (verbatim || cfig.dhcpLogLevel >= 2)
//		{
//			sprintf(logBuff, "Token Received");
//			logMess(logBuff, 2);
//		}

		if (req->dns)
			cfig.dnsRepl = t + 600;

		if (cfig.replication == 1)
		{
			if (req->hostname[0])
				add2Cache(0, req->hostname, cfig.zoneServers[1], INT_MAX, LOCAL_A, LOCAL_PTR_AUTH);

			errno = 0;

			sendto(cfig.dhcpReplConn.sock,
					token.raw,
					token.bytes,
					0,
					(sockaddr*)&token.remote,
					sizeof(token.remote));

//			errno = WSAGetLastError();
//
//			if (!errno && (verbatim || cfig.dhcpLogLevel >= 2))
//			{
//				sprintf(logBuff, "Token Responded");
//				logMess(logBuff, 2);
//			}
		}
		return;
	}

	char rInd = getRangeInd(ip);

	if (rInd >= 0)
	{
		int ind  = getIndex(rInd, ip);
		req->dhcpEntry = cfig.dhcpRanges[rInd].dhcpEntry[ind];

		if (req->dhcpEntry && !req->dhcpEntry->fixed && strcasecmp(req->dhcpEntry->mapname, req->chaddr))
			req->dhcpEntry->expiry = 0;
	}

	req->dhcpEntry = findDHCPEntry(req->chaddr);

	if (req->dhcpEntry && req->dhcpEntry->ip != ip)
	{
		if (req->dhcpEntry->fixed)
		{
			if (cfig.replication == 1)
				sprintf(logBuff, "DHCP Update ignored for %s (%s) from Secondary Server", req->chaddr, IP2String(tempbuff, ip));
			else
				sprintf(logBuff, "DHCP Update ignored for %s (%s) from Primary Server", req->chaddr, IP2String(tempbuff, ip));

			logMess(logBuff, 1);
			return;
		}
		else if (req->dhcpEntry->rangeInd >= 0)
		{
			int ind  = getIndex(req->dhcpEntry->rangeInd, req->dhcpEntry->ip);

			if (ind >= 0)
				cfig.dhcpRanges[req->dhcpEntry->rangeInd].dhcpEntry[ind] = 0;
		}
	}

	if (!req->dhcpEntry && rInd >= 0)
	{
		req->dhcpEntry = (data7*)calloc(1, sizeof(data7));

		if (!req->dhcpEntry)
		{
			sprintf(logBuff, "Memory Allocation Error");
			logMess(logBuff, 1);
			return;
		}

		req->dhcpEntry->mapname = cloneString(req->chaddr);

		if (!req->dhcpEntry->mapname)
		{
			sprintf(logBuff, "Memory Allocation Error");
			free(req->dhcpEntry);
			logMess(logBuff, 1);
			return;
		}

		dhcpCache[req->dhcpEntry->mapname] = req->dhcpEntry;
	}

	if (req->dhcpEntry)
	{
		req->dhcpEntry->ip = ip;
		req->dhcpEntry->rangeInd = rInd;

		if (!req->dhcpEntry->hostname)
				req->dhcpEntry->hostname = cloneString(req->hostname);
		else if (req->hostname[0] && strcasecmp(req->dhcpEntry->hostname, req->hostname))
		{
			free(req->dhcpEntry->hostname);
			req->dhcpEntry->hostname = cloneString(req->hostname);
		}

		req->dhcpEntry->display = true;
		req->dhcpEntry->local = false;

		MYDWORD hangTime = req->lease;

		if (req->rebind > req->lease)
			hangTime = req->rebind;

		setLeaseExpiry(req->dhcpEntry, hangTime);

		data8 *dhcpData = (data8*)calloc(1, sizeof(data8));
		strcpy(dhcpData->hostname, req->hostname);
		memcpy(dhcpData->bp_chaddr, req->dhcpp.header.bp_chaddr, req->dhcpp.header.bp_hlen);
		dhcpData->bp_hlen = req->dhcpp.header.bp_hlen;
		dhcpData->ip = req->dhcpEntry->ip;
		dhcpData->expiry = req->dhcpEntry->expiry;
		dhcpData->local = false;

		if (req->dhcpEntry->dhcpInd)
			dhcpData->dhcpInd = req->dhcpEntry->dhcpInd;
		else
		{
			cfig.dhcpInd++;
			req->dhcpEntry->dhcpInd = cfig.dhcpInd;
		}

		pthread_t threadId;
		pthread_attr_t attr;
		pthread_attr_init(&attr);
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		int errcode = pthread_create(&threadId, &attr, updateStateFile, (void*)dhcpData);
		pthread_attr_destroy(&attr);

		if (dnsService && cfig.replication == 1)
			updateDNS(req);
	}
	else
	{
		if (cfig.replication == 1)
			sprintf(logBuff, "DHCP Update ignored for %s (%s) from Secondary Server", req->chaddr, IP2String(tempbuff, ip));
		else
			sprintf(logBuff, "DHCP Update ignored for %s (%s) from Primary Server", req->chaddr, IP2String(tempbuff, ip));

		logMess(logBuff, 1);
		return;
	}

	if (verbatim || cfig.dhcpLogLevel >= 2)
	{
		if (cfig.replication == 1)
			sprintf(logBuff, "DHCP Update received for %s (%s) from Secondary Server", req->chaddr, IP2String(tempbuff, ip));
		else
			sprintf(logBuff, "DHCP Update received for %s (%s) from Primary Server", req->chaddr, IP2String(tempbuff, ip));

		logMess(logBuff, 2);
	}
}

char getRangeInd(MYDWORD ip)
{
	if (ip)
	{
		MYDWORD iip = htonl(ip);

		for (char k = 0; k < cfig.rangeCount; k++)
			if (iip >= cfig.dhcpRanges[k].rangeStart && iip <= cfig.dhcpRanges[k].rangeEnd)
				return k;
	}
	return -1;
}

int getIndex(char rangeInd, MYDWORD ip)
{
	if (ip && rangeInd >= 0 && rangeInd < cfig.rangeCount)
	{
		MYDWORD iip = htonl(ip);
		if (iip >= cfig.dhcpRanges[rangeInd].rangeStart && iip <= cfig.dhcpRanges[rangeInd].rangeEnd)
			return (iip - cfig.dhcpRanges[rangeInd].rangeStart);
	}
	return -1;
}

void loadOptions(FILE *f, const char *sectionName, data20 *optionData)
{
	optionData->options = NULL;
	optionData->ip = 0;
	optionData->mask = 0;
	MYBYTE maxInd = sizeof(opData) / sizeof(data4);
	MYBYTE options[sizeof(dhcp_packet) - sizeof(dhcp_header)];
	MYWORD buffsize = sizeof(options);
	MYBYTE *dp = options;
	MYBYTE op_specified[256];

	memset(op_specified, 0, 256);
	*dp = 0;
	dp++;

	char raw[512];
	char name[512];
	char value[512];

	while (readSection(raw, f))
	{
		MYBYTE *ddp = dp;
		MYBYTE hoption[256];
		MYBYTE valSize = sizeof(hoption) - 1;
		MYBYTE opTag = 0;
		MYBYTE opType = 0;
		MYBYTE valType = 0;
		bool tagFound = false;

		mySplit(name, value, raw, '=');

		//printf("%s=%s\n", name, value);

		if (!name[0])
		{
			sprintf(logBuff, "Warning: section [%s] invalid option %s ignored", sectionName, raw);
			logMess(logBuff, 1);
			continue;
		}

		if (!strcasecmp(name, "DHCPRange"))
		{
			if (!strcasecmp(sectionName, RANGESET))
				addDHCPRange(value);
			else
			{
				sprintf(logBuff, "Warning: section [%s] option %s not allowed in this section, option ignored", sectionName, raw);
				logMess(logBuff, 1);
			}
			continue;
		}
		else if (!strcasecmp(name, "IP"))
		{
			if (!strcasecmp(sectionName, GLOBALOPTIONS) || !strcasecmp(sectionName, RANGESET))
			{
				sprintf(logBuff, "Warning: section [%s] option %s not allowed in this section, option ignored", sectionName, raw);
				logMess(logBuff, 1);
			}
			else if (!isIP(value) && strcasecmp(value, "0.0.0.0"))
			{
				sprintf(logBuff, "Warning: section [%s] option Invalid IP Addr %s option ignored", sectionName, value);
				logMess(logBuff, 1);
			}
			else
				optionData->ip = inet_addr(value);

			continue;
		}
		else if (!strcasecmp(name, "FilterMacRange"))
		{
			if (!strcasecmp(sectionName, RANGESET))
				addMacRange(optionData->rangeSetInd, value);
			else
			{
				sprintf(logBuff, "Warning: section [%s] option %s not allowed in this section, option ignored", sectionName, raw);
				logMess(logBuff, 1);
			}
			continue;
		}

		if (!value[0])
			valType = 9;
		else if (value[0] == '"' && value[strlen(value)-1] == '"')
		{
			valType = 2;
			value[0] = NBSP;
			value[strlen(value) - 1] = NBSP;
			myTrim(value, value);

			if (strlen(value) <= UCHAR_MAX)
				valSize = strlen(value);
			else
			{
				sprintf(logBuff, "Warning: section [%s] option %s value too big, option ignored", sectionName, raw);
				logMess(logBuff, 1);
				continue;
			}
		}
		else if (strchr(value, ':'))
		{
			valType = 2;
			valSize = sizeof(hoption) - 1;
			char *errorPos = getHexValue(hoption, value, &valSize);

			if (errorPos)
			{
				valType = 1;
				valSize = strlen(value);
			}
			else
				memcpy(value, hoption, valSize);
		}
		else if (isInt(value) && atol(value) > USHRT_MAX)
			valType = 4;
		else if (isInt(value) && atoi(value) > UCHAR_MAX)
			valType = 5;
		else if (isInt(value))
			valType = 6;
//		else if ((strchr(value, '.') && (opType == 2 || opType == 3 || opType == 8 || opType == 0)) || (!strchr(value, '.') && strchr(value, ',')))
		else if (strchr(value, '.') || strchr(value, ','))
		{
			valType = 2;
			char buff[1024];
			int numbytes = myTokenize(buff, value, "/,.", true);

			if (numbytes > 255)
			{
				sprintf(logBuff, "Warning: section [%s] option %s, too many bytes, entry ignored", sectionName, raw);
				logMess(logBuff, 1);
				continue;
			}
			else
			{
				char *ptr = buff;
				valSize = 0;

				for (; *ptr; ptr = myGetToken(ptr, 1))
				{
					//printf("%s:", ptr);
					if (isInt(ptr) && atoi(ptr) <= UCHAR_MAX)
					{
						hoption[valSize] = atoi(ptr);
						valSize++;
					}
					else
						break;
				}

				if (!(*ptr))
					memcpy(value, hoption, valSize);
				else
				{
					valType = 1;
					valSize = strlen(value);
				}
			}
		}
		else
		{
			if (strlen(value) <= UCHAR_MAX)
			{
				valSize = strlen(value);
				valType = 1;
			}
			else
			{
				sprintf(logBuff, "Warning: section [%s] option %s value too long, option ignored", sectionName, raw);
				logMess(logBuff, 1);
				continue;
			}
		}

		if (!strcasecmp(name, "FilterVendorClass"))
		{
			if (!strcasecmp(sectionName, RANGESET))
				addVendClass(optionData->rangeSetInd, value, valSize);
			else
			{
				sprintf(logBuff, "Warning: section [%s] option %s not allowed in this section, option ignored", sectionName, raw);
				logMess(logBuff, 1);
			}
			continue;
		}
		else if (!strcasecmp(name, "FilterUserClass"))
		{
			if (!strcasecmp(sectionName, RANGESET))
				addUserClass(optionData->rangeSetInd, value, valSize);
			else
			{
				sprintf(logBuff, "Warning: section [%s] option %s not allowed in this section, option ignored", sectionName, raw);
				logMess(logBuff, 1);
			}
			continue;
		}
		else if (!strcasecmp(name, "FilterSubnetSelection"))
		{
			if (valSize != 4)
			{
				sprintf(logBuff, "Warning: section [%s] invalid value %s, option ignored", sectionName, raw);
				logMess(logBuff, 1);
			}
			else if (!strcasecmp(sectionName, RANGESET))
			{
				addServer(cfig.rangeSet[optionData->rangeSetInd].subnetIP, MAX_RANGE_FILTERS, fIP(value));
				cfig.hasFilter = 1;
			}
			else
			{
				sprintf(logBuff, "Warning: section [%s] option %s not allowed in this section, option ignored", sectionName, raw);
				logMess(logBuff, 1);
			}
			continue;
		}
		else if (!strcasecmp(name, "TargetRelayAgent"))
		{
			if (valSize != 4)
			{
				sprintf(logBuff, "Warning: section [%s] invalid value %s, option ignored", sectionName, raw);
				logMess(logBuff, 1);
			}
			else if (!strcasecmp(sectionName, RANGESET))
			{
				cfig.rangeSet[optionData->rangeSetInd].targetIP = fIP(value);
				//printf("TARGET IP %s set RangeSetInd  %d\n", IP2String(tempbuff, cfig.rangeSet[optionData->rangeSetInd].targetIP), optionData->rangeSetInd);
			}
			else
			{
				sprintf(logBuff, "Warning: section [%s] option %s not allowed in this section, option ignored", sectionName, raw);
				logMess(logBuff, 1);
			}
			continue;
		}

		opTag = 0;

		if (isInt(name))
		{
			if (atoi(name) < 1 || atoi(name) >= 254)
			{
				sprintf(logBuff, "Warning: section [%s] invalid option %s, ignored", sectionName, raw);
				logMess(logBuff, 1);
				continue;
			}

			opTag = atoi(name);
			opType = 0;
		}

		for (MYBYTE i = 0; i < maxInd; i++)
			if (!strcasecmp(name, opData[i].opName) || (opTag && opTag == opData[i].opTag))
			{
				opTag = opData[i].opTag;
				opType = opData[i].opType;
				tagFound = true;
				break;
			}

		if (!opTag)
		{
			sprintf(logBuff, "Warning: section [%s] invalid option %s, ignored", sectionName, raw);
			logMess(logBuff, 1);
			continue;
		}

		if (!opType)
			opType = valType;

		//sprintf(logBuff, "Tag %i ValType %i opType %i value=%s size=%u", opTag, valType, opType, value, valSize);
		//logMess(logBuff, 1);

		if (op_specified[opTag])
		{
			sprintf(logBuff, "Warning: section [%s] duplicate option %s, ignored", sectionName, raw);
			logMess(logBuff, 1);
			continue;
		}

		//printf("Option=%u opType=%u valueType=%u valSize=%u\n", opTag, opType, valType, valSize);

		op_specified[opTag] = true;

		if (valType == 9)
		{
			if (buffsize > 2)
			{
				*dp = opTag;
				dp++;
				*dp = 0;
				dp++;
				buffsize -= 2;
			}
			else
			{
				sprintf(logBuff, "Warning: section [%s] option %s, no more space for options", sectionName, raw);
				logMess(logBuff, 1);
			}
			continue;
		}

		switch (opType)
		{
			case 1:
			{
				value[valSize] = 0;
				valSize++;

				if (valType != 1 && valType != 2)
				{
					sprintf(logBuff, "Warning: section [%s] option %s, need string value, option ignored", sectionName, raw);
					logMess(logBuff, 1);
				}
				else if (opTag == DHCP_OPTION_DOMAINNAME)
				{
					sprintf(logBuff, "Warning: section [%s] option %u should be under [DOMAIN_NAME], ignored", sectionName, opTag);
					logMess(logBuff, 1);
					continue;
				}
				else if (buffsize > valSize + 2)
				{
					*dp = opTag;
					dp++;
					*dp = valSize;
					dp++;
					memcpy(dp, value, valSize);
					dp += valSize;
					buffsize -= (valSize + 2);
				}
				else
				{
					sprintf(logBuff, "Warning: section [%s] option %s, no more space for options", sectionName, raw);
					logMess(logBuff, 1);
				}
			}
			break;

			case 3:
			case 8:
			{
				if (valType == 2)
				{
					if (opType == 3 && valSize % 4)
					{
						sprintf(logBuff, "Warning: section [%s] option %s, missing/extra bytes/octates in IP, option ignored", sectionName, raw);
						logMess(logBuff, 1);
						continue;
					}
					else if (opType == 8 && valSize % 8)
					{
						sprintf(logBuff, "Warning: section [%s] option %s, some values not in IP/Mask form, option ignored", sectionName, raw);
						logMess(logBuff, 1);
						continue;
					}

					if (opTag == DHCP_OPTION_NETMASK)
					{
						if (valSize != 4 || !checkMask(fIP(value)))
						{
							sprintf(logBuff, "Warning: section [%s] Invalid subnetmask %s, option ignored", sectionName, raw);
							logMess(logBuff, 1);
							continue;
						}
						else
							optionData->mask = fIP(value);
					}

					if (buffsize > valSize + 2)
					{
						*dp = opTag;
						dp++;
						*dp = valSize;
						dp++;
						memcpy(dp, value, valSize);
						dp += valSize;
						buffsize -= (valSize + 2);
					}
					else
					{
						sprintf(logBuff, "Warning: section [%s] option %s, no more space for options", sectionName, raw);
						logMess(logBuff, 1);
					}
				}
				else
				{
					sprintf(logBuff, "Warning: section [%s] option %s, Invalid value, should be one or more IP/4 Bytes", sectionName, raw);
					logMess(logBuff, 1);
				}
			}
			break;

			case 4:
			{
				MYDWORD j;

				if (valType == 2 && valSize == 4)
					j = fULong(value);
				else if (valType >= 4 && valType <= 6)
					j = atol(value);
				else
				{
					sprintf(logBuff, "Warning: section [%s] option %s, value should be integer between 0 & %u or 4 bytes, option ignored", sectionName, name, UINT_MAX);
					logMess(logBuff, 1);
					continue;
				}

				if (opTag == DHCP_OPTION_IPADDRLEASE)
				{
					if (j == 0)
						j = UINT_MAX;

					if (!strcasecmp(sectionName, GLOBALOPTIONS))
					{
						sprintf(logBuff, "Warning: section [%s] option %s not allowed in this section, please set it in [TIMINGS] section", sectionName, raw);
						logMess(logBuff, 1);
						continue;
					}
					else if (j > cfig.lease)
					{
						sprintf(logBuff, "Warning: section [%s] option %s value should be less then %u (max lease), ignored", sectionName, name, cfig.lease);
						logMess(logBuff, 1);
						continue;
					}
				}

				if (buffsize > 6)
				{
					*dp = opTag;
					dp++;
					*dp = 4;
					dp++;
					dp += pULong(dp, j);
					buffsize -= 6;
					//printf("%s=%u=%u\n",opData[op_index].opName,opData[op_index].opType,htonl(j));
				}
				else
				{
					sprintf(logBuff, "Warning: section [%s] option %s, no more space for options", sectionName, raw);
					logMess(logBuff, 1);
				}
			}
			break;

			case 5:
			{
				MYWORD j;

				if (valType == 2 && valSize == 2)
					j = fUShort(value);
				else if (valType == 5 || valType == 6)
					j = atol(value);
				else
				{
					sprintf(logBuff, "Warning: section [%s] option %s, value should be between 0 & %u or 2 bytes, option ignored", sectionName, name, USHRT_MAX);
					logMess(logBuff, 1);
					continue;
				}

				if (buffsize > 4)
				{
					*dp = opTag;
					dp++;
					*dp = 2;
					dp++;
					dp += pUShort(dp, j);
					buffsize -= 4;
				}
				else
				{
					sprintf(logBuff, "Warning: section [%s] option %s, no more space for options", sectionName, raw);
					logMess(logBuff, 1);
				}
			}
			break;

			case 6:
			{
				MYBYTE j;

				if (valType == 2 && valSize == 1)
					j = *value;
				else if (valType == 6)
					j = atol(value);
				else
				{
					sprintf(logBuff, "Warning: section [%s] option %s, value should be between 0 & %u or single byte, option ignored", sectionName, name, UCHAR_MAX);
					logMess(logBuff, 1);
					continue;
				}

				if (buffsize > 3)
				{
					*dp = opTag;
					dp++;
					*dp = 1;
					dp++;
					*dp = j;
					dp++;
					buffsize -= 3;
				}
				else
				{
					sprintf(logBuff, "Warning: section [%s] option %s, no more space for options", sectionName, raw);
					logMess(logBuff, 1);
				}
			}
			break;

			case 7:
			{
				MYBYTE j;

				if (valType == 2 && valSize == 1 && *value < 2)
					j = *value;
				else if (valType == 1 && (!strcasecmp(value, "yes") || !strcasecmp(value, "on") || !strcasecmp(value, "true")))
					j = 1;
				else if (valType == 1 && (!strcasecmp(value, "no") || !strcasecmp(value, "off") || !strcasecmp(value, "false")))
					j = 0;
				else if (valType == 6 && atoi(value) < 2)
					j = atoi(value);
				else
				{
					sprintf(logBuff, "Warning: section [%s] option %s, value should be yes/on/true/1 or no/off/false/0, option ignored", sectionName, raw);
					logMess(logBuff, 1);
					continue;
				}

				if (buffsize > 3)
				{
					*dp = opTag;
					dp++;
					*dp = 1;
					dp++;
					*dp = j;
					dp++;
					buffsize -= 3;
				}
				else
				{
					sprintf(logBuff, "Warning: section [%s] option %s, no more space for options", sectionName, raw);
					logMess(logBuff, 1);
				}
			}
			break;

			default:
			{
				if (valType == 6)
				{
					valType = 2;
					valSize = 1;
					*value = atoi(value);
				}

				if (opType == 2 && valType != 2)
				{
					sprintf(logBuff, "Warning: section [%s] option %s, value should be comma separated bytes or hex string, option ignored", sectionName, raw);
					logMess(logBuff, 1);
					continue;
				}
				else if (buffsize > valSize + 2)
				{
					*dp = opTag;
					dp++;
					*dp = valSize;
					dp++;
					memcpy(dp, value, valSize);
					dp += valSize;
					buffsize -= (valSize + 2);
				}
				else
				{
					sprintf(logBuff, "Warning: section [%s] option %s, no more space for options", sectionName, raw);
					logMess(logBuff, 1);
				}
			}
			break;
		}

		//printf("%s Option=%u opType=%u valType=%u  valSize=%u\n", raw, opTag, opType, valType, valSize);
		//printf("%s %s\n", name, hex2String(tempbuff, ddp, valSize+2, ':'));
	}

	//printf("%s=%s\n", sectionName, optionData->vendClass);

	*dp = DHCP_OPTION_END;
	dp++;
	MYWORD optionSize = (dp - options);

	if (optionSize > 2)
	{
		optionData->options = (MYBYTE*)calloc(1, optionSize);

		if (!optionData->options)
		{
			sprintf(logBuff, "DHCP Option Load, Memory Allocation Error");
			logMess(logBuff, 1);
		}

		memcpy(optionData->options, options, optionSize);
	}
}

void lockOptions(FILE *f)
{
	char raw[512];
	char name[512];
	char value[512];

	while (readSection(raw, f))
	{
		mySplit(name, value, raw, '=');

		if (!name[0] || !value[0])
			continue;

		int op_index;
		MYBYTE n = sizeof(opData) / sizeof(data4);

		for (op_index = 0; op_index < n; op_index++)
			if (!strcasecmp(name, opData[op_index].opName) || (opData[op_index].opTag && atoi(name) == opData[op_index].opTag))
				break;

		if (op_index >= n)
			continue;

		if (opData[op_index].opType == 3)
		{
			if (myTokenize(value, value, "/,.", true))
			{
				char *ptr = value;
				char hoption[256];
				MYBYTE valueSize = 0;

				for (; *ptr; ptr = myGetToken(ptr, 1))
				{
					if (valueSize >= UCHAR_MAX)
						break;
					else if (isInt(ptr) && atoi(ptr) <= UCHAR_MAX)
					{
						hoption[valueSize] = atoi(ptr);
						valueSize++;
					}
					else
						break;
				}

				if (*ptr)
					continue;

				if (valueSize % 4)
					continue;

				for (MYBYTE i = 0; i < valueSize; i += 4)
				{
					MYDWORD ip = *((MYDWORD*)&(hoption[i]));

					if (ip != INADDR_ANY && ip != INADDR_NONE)
						lockIP(ip);
				}
			}
		}
	}
}

void addDHCPRange(char *dp)
{
	MYDWORD rs = 0;
	MYDWORD re = 0;
	char name[512];
	char value[512];
	mySplit(name, value, dp, '-');

	if (isIP(name) && isIP(value))
	{
		rs = htonl(inet_addr(name));
		re = htonl(inet_addr(value));

		if (rs && re && rs <= re)
		{
			data13 *range;
			MYBYTE m = 0;

			for (; m < MAX_DHCP_RANGES && cfig.dhcpRanges[m].rangeStart; m++)
			{
				range = &cfig.dhcpRanges[m];

				if ((rs >= range->rangeStart && rs <= range->rangeEnd)
						|| (re >= range->rangeStart && re <= range->rangeEnd)
						|| (range->rangeStart >= rs && range->rangeStart <= re)
						|| (range->rangeEnd >= rs && range->rangeEnd <= re))
				{
					sprintf(logBuff, "Warning: DHCP Range %s overlaps with another range, ignored", dp);
					logMess(logBuff, 1);
					return;
				}
			}

			if (m < MAX_DHCP_RANGES)
			{
				cfig.dhcpSize += (re - rs + 1);
				range = &cfig.dhcpRanges[m];
				range->rangeStart = rs;
				range->rangeEnd = re;
				range->expiry = (time_t*)calloc((re - rs + 1), sizeof(time_t));
				range->dhcpEntry = (data7**)calloc((re - rs + 1), sizeof(data7*));

				if (!range->expiry || !range->dhcpEntry)
				{
					if (range->expiry)
						free(range->expiry);

					if (range->dhcpEntry)
						free(range->dhcpEntry);

					sprintf(logBuff, "DHCP Ranges Load, Memory Allocation Error");
					logMess(logBuff, 1);
					return;
				}
			}
		}
		else
		{
			sprintf(logBuff, "Section [%s] Invalid DHCP range %s in ini file, ignored", RANGESET, dp);
			logMess(logBuff, 1);
		}
	}
	else
	{
		sprintf(logBuff, "Section [%s] Invalid DHCP range %s in ini file, ignored", RANGESET, dp);
		logMess(logBuff, 1);
	}
}

void addVendClass(MYBYTE rangeSetInd, char *vendClass, MYBYTE vendClassSize)
{
	data14 *rangeSet = &cfig.rangeSet[rangeSetInd];

	MYBYTE i = 0;

	for (; i <= MAX_RANGE_FILTERS && rangeSet->vendClassSize[i]; i++);

	if (i >= MAX_RANGE_FILTERS || !vendClassSize)
		return;

	rangeSet->vendClass[i] = (MYBYTE*)calloc(vendClassSize, 1);

	if(!rangeSet->vendClass[i])
	{
		sprintf(logBuff, "Vendor Class Load, Memory Allocation Error");
		logMess(logBuff, 1);
	}
	else
	{
		cfig.hasFilter = true;
		rangeSet->vendClassSize[i] = vendClassSize;
		memcpy(rangeSet->vendClass[i], vendClass, vendClassSize);
		//printf("Loaded Vendor Class %s Size=%i rangeSetInd=%i Ind=%i\n", rangeSet->vendClass[i], rangeSet->vendClassSize[i], rangeSetInd, i);
		//printf("Loaded Vendor Class %s Size=%i rangeSetInd=%i Ind=%i\n", hex2String(tempbuff, rangeSet->vendClass[i], rangeSet->vendClassSize[i], ':'), rangeSet->vendClassSize[i], rangeSetInd, i);
	}
}

void addUserClass(MYBYTE rangeSetInd, char *userClass, MYBYTE userClassSize)
{
	data14 *rangeSet = &cfig.rangeSet[rangeSetInd];

	MYBYTE i = 0;

	for (; i <= MAX_RANGE_FILTERS && rangeSet->userClassSize[i]; i++);

	if (i >= MAX_RANGE_FILTERS || !userClassSize)
		return;

	rangeSet->userClass[i] = (MYBYTE*)calloc(userClassSize, 1);

	if(!rangeSet->userClass[i])
	{
		sprintf(logBuff, "Vendor Class Load, Memory Allocation Error");
		logMess(logBuff, 1);
	}
	else
	{
		cfig.hasFilter = true;
		rangeSet->userClassSize[i] = userClassSize;
		memcpy(rangeSet->userClass[i], userClass, userClassSize);
		//printf("Loaded User Class %s Size=%i rangeSetInd=%i Ind=%i\n", hex2String(tempbuff, rangeSet->userClass[i], rangeSet->userClassSize[i], ':'), rangeSet->vendClassSize[i], rangeSetInd, i);
	}
}

void addMacRange(MYBYTE rangeSetInd, char *macRange)
{
	if (macRange[0])
	{
		data14 *rangeSet = &cfig.rangeSet[rangeSetInd];

		MYBYTE i = 0;

		for (; i <= MAX_RANGE_FILTERS && rangeSet->macSize[i]; i++);

		if (i >= MAX_RANGE_FILTERS)
			return;

		char name[256];
		char value[256];

		mySplit(name, value, macRange, '-');

		//printf("%s=%s\n", name, value);

		if(!name[0] || !value[0])
		{
			sprintf(logBuff, "Section [%s], invalid Filter_Mac_Range %s, ignored", RANGESET, macRange);
			logMess(logBuff, 1);
		}
		else
		{
			MYBYTE macSize1 = 16;
			MYBYTE macSize2 = 16;
			MYBYTE *macStart = (MYBYTE*)calloc(1, macSize1);
			MYBYTE *macEnd = (MYBYTE*)calloc(1, macSize2);

			if(!macStart || !macEnd)
			{
				sprintf(logBuff, "DHCP Range Load, Memory Allocation Error");
				logMess(logBuff, 1);
			}
			else if (getHexValue(macStart, name, &macSize1) || getHexValue(macEnd, value, &macSize2))
			{
				sprintf(logBuff, "Section [%s], Invalid character in Filter_Mac_Range %s", RANGESET, macRange);
				logMess(logBuff, 1);
				free(macStart);
				free(macEnd);
			}
			else if (memcmp(macStart, macEnd, 16) > 0)
			{
				sprintf(logBuff, "Section [%s], Invalid Filter_Mac_Range %s, (higher bound specified on left), ignored", RANGESET, macRange);
				logMess(logBuff, 1);
				free(macStart);
				free(macEnd);
			}
			else if (macSize1 != macSize2)
			{
				sprintf(logBuff, "Section [%s], Invalid Filter_Mac_Range %s, (start/end size mismatched), ignored", RANGESET, macRange);
				logMess(logBuff, 1);
				free(macStart);
				free(macEnd);
			}
			else
			{
				cfig.hasFilter = true;
				rangeSet->macSize[i] = macSize1;
				rangeSet->macStart[i] = macStart;
				rangeSet->macEnd[i] = macEnd;
				//printf("Mac Loaded, Size=%i Start=%s rangeSetInd=%i Ind=%i\n", rangeSet->macSize[i], hex2String(tempbuff, rangeSet->macStart[i], rangeSet->macSize[i]), rangeSetInd, i);
			}
		}
	}
}

void loadDHCP()
{
	data7 *dhcpEntry = NULL;
	char mapname[64];
	FILE *f = NULL;
	FILE *ff = NULL;

	if (f = openSection(GLOBALOPTIONS, 1))
	{
		data20 optionData;
		loadOptions(f, GLOBALOPTIONS, &optionData);
		cfig.options = optionData.options;
		cfig.mask = optionData.mask;
	}

	if (!cfig.mask)
		cfig.mask = inet_addr("255.255.255.0");

	for (MYBYTE i = 1; i <= MAX_RANGE_SETS ; i++)
	{
		if (f = openSection(RANGESET, i))
		{
			MYBYTE m = cfig.rangeCount;
			data20 optionData;
			optionData.rangeSetInd = i - 1;
			loadOptions(f, RANGESET, &optionData);
			cfig.rangeSet[optionData.rangeSetInd].active = true;

			for (; m < MAX_DHCP_RANGES && cfig.dhcpRanges[m].rangeStart; m++)
			{
				cfig.dhcpRanges[m].rangeSetInd = optionData.rangeSetInd;
				cfig.dhcpRanges[m].options = optionData.options;
				cfig.dhcpRanges[m].mask = optionData.mask;
			}
			cfig.rangeCount = m;
		}
		else
			break;
	}

	//printf("%s\n", IP2String(tempbuff, cfig.mask));

	for (char rangeInd = 0; rangeInd < cfig.rangeCount; rangeInd++)
	{
		if (!cfig.dhcpRanges[rangeInd].mask)
			cfig.dhcpRanges[rangeInd].mask = cfig.mask;

		for (MYDWORD iip = cfig.dhcpRanges[rangeInd].rangeStart; iip <= cfig.dhcpRanges[rangeInd].rangeEnd; iip++)
		{
			MYDWORD ip = htonl(iip);

			if ((cfig.dhcpRanges[rangeInd].mask | (~ip)) == UINT_MAX || (cfig.dhcpRanges[rangeInd].mask | ip) == UINT_MAX)
				cfig.dhcpRanges[rangeInd].expiry[iip - cfig.dhcpRanges[rangeInd].rangeStart] = INT_MAX;
		}
	}

	if (f = openSection(GLOBALOPTIONS, 1))
		lockOptions(f);

	for (MYBYTE i = 1; i <= MAX_RANGE_SETS ;i++)
	{
		if (f = openSection(RANGESET, i))
			lockOptions(f);
		else
			break;
	}

	ff = fopen(iniFile, "rt");

	if (ff)
	{
		char sectionName[512];

		while (fgets(sectionName, 510, ff))
		{
			if (*sectionName == '[')
			{
				char *secend = strchr(sectionName, ']');

				if (secend)
				{
					*secend = 0;
					sectionName[0] = NBSP;
					myTrim(sectionName, sectionName);
				}
				else
					continue;
			}
			else
				continue;

			if (!strchr(sectionName, ':'))
				continue;

			//printf("%s\n", sectionName);

			MYBYTE hexValue[UCHAR_MAX];
			MYBYTE hexValueSize = sizeof(hexValue);
			data20 optionData;

			if (strlen(sectionName) <= 48 && !getHexValue(hexValue, sectionName, &hexValueSize))
			{
				if (hexValueSize <= 16)
				{
					dhcpEntry = findDHCPEntry(hex2String(mapname, hexValue, hexValueSize));

					if (!dhcpEntry)
					{
						if (f = openSection(sectionName, 1))
							loadOptions(f, sectionName, &optionData);
						if (f = openSection(sectionName, 1))
							lockOptions(f);

						dhcpMap::iterator p = dhcpCache.begin();

						for (; p != dhcpCache.end(); p++)
						{
							if (p->second && p->second->ip && p->second->ip == optionData.ip)
								break;
						}

						if (p == dhcpCache.end())
						{
							dhcpEntry = (data7*)calloc(1, sizeof(data7));

							if (!dhcpEntry)
							{
								sprintf(logBuff, "Host Options Load, Memory Allocation Error");
								logMess(logBuff, 1);
								return;
							}

							dhcpEntry->mapname = cloneString(mapname);

							if (!dhcpEntry->mapname)
							{
								sprintf(logBuff, "Host Data Load, Memory Allocation Error");
								logMess(logBuff, 1);
								return;
							}

							dhcpEntry->ip = optionData.ip;
							dhcpEntry->options = optionData.options;
							dhcpEntry->rangeInd = getRangeInd(optionData.ip);
							dhcpEntry->fixed = 1;
							lockIP(optionData.ip);
							dhcpCache[dhcpEntry->mapname] = dhcpEntry;
							//printf("%s=%s=%s\n", mapname, dhcpEntry->mapname, IP2String(tempbuff, optionData.ip));
						}
						else
						{
							sprintf(logBuff, "Static DHCP Host [%s] Duplicate IP Address %s, Entry ignored", sectionName, IP2String(tempbuff, optionData.ip));
							logMess(logBuff, 1);
						}
					}
					else
					{
						sprintf(logBuff, "Duplicate Static DHCP Host [%s] ignored", sectionName);
						logMess(logBuff, 1);
					}
				}
				else
				{
					sprintf(logBuff, "Invalid Static DHCP Host MAC Addr size, ignored", sectionName);
					logMess(logBuff, 1);
				}
			}
			else
			{
				sprintf(logBuff, "Invalid Static DHCP Host MAC Addr [%s] ignored", sectionName);
				logMess(logBuff, 1);
			}

			if (!optionData.ip)
			{
				sprintf(logBuff, "Warning: No IP Address for DHCP Static Host %s specified", sectionName);
				logMess(logBuff, 1);
			}
		}

		fclose(ff);
	}

	ff = fopen(leaFile, "rb");

	if (ff)
	{
		data8 dhcpData;

		while (fread(&dhcpData, sizeof(data8), 1, ff))
		{
			char rangeInd = -1;
			int ind = -1;

			//printf("Loading %s=%s\n", dhcpData.hostname, IP2String(tempbuff, dhcpData.ip));

			if (dhcpData.bp_hlen <= 16 && !findServer(network.allServers, MAX_SERVERS, dhcpData.ip))
			{
				hex2String(mapname, dhcpData.bp_chaddr, dhcpData.bp_hlen);

				dhcpMap::iterator p = dhcpCache.begin();

				for (; p != dhcpCache.end(); p++)
				{
					dhcpEntry = p->second;

					if (dhcpEntry && (!strcasecmp(mapname, dhcpEntry->mapname) || dhcpEntry->ip == dhcpData.ip))
						break;
				}

				if (p != dhcpCache.end() && (strcasecmp(mapname, dhcpEntry->mapname) || dhcpEntry->ip != dhcpData.ip))
					continue;

				dhcpEntry = findDHCPEntry(mapname);
				rangeInd = getRangeInd(dhcpData.ip);

				if(!dhcpEntry && rangeInd >= 0)
				{
					dhcpEntry = (data7*)calloc(1, sizeof(data7));

					if (!dhcpEntry)
					{
						sprintf(logBuff, "Loading Existing Leases, Memory Allocation Error");
						logMess(logBuff, 1);
						return;
					}

					dhcpEntry->mapname = cloneString(mapname);

					if (!dhcpEntry->mapname)
					{
						sprintf(logBuff, "Loading Existing Leases, Memory Allocation Error");
						free(dhcpEntry);
						logMess(logBuff, 1);
						return;
					}

					dhcpCache[dhcpEntry->mapname] = dhcpEntry;
				}

				if (dhcpEntry)
				{
					dhcpEntry->ip = dhcpData.ip;
					dhcpEntry->rangeInd = rangeInd;
					dhcpEntry->expiry = dhcpData.expiry;
					dhcpEntry->local = dhcpData.local;
					dhcpEntry->display = true;
					dhcpEntry->hostname = cloneString(dhcpData.hostname);
					setLeaseExpiry(dhcpEntry);
					//printf("Loaded %s=%s\n", dhcpData.hostname, IP2String(tempbuff, dhcpData.ip));
				}
			}
		}

		fclose(ff);

		ff = fopen(leaFile, "wb");
		cfig.dhcpInd = 0;

		if (ff)
		{
			dhcpMap::iterator p = dhcpCache.begin();

			for (; p != dhcpCache.end(); p++)
			{
				if ((dhcpEntry = p->second) && (dhcpEntry->expiry > t || !dhcpEntry->fixed))
				{
					memset(&dhcpData, 0, sizeof(data8));
					dhcpData.bp_hlen = 16;
					getHexValue(dhcpData.bp_chaddr, dhcpEntry->mapname, &dhcpData.bp_hlen);
					dhcpData.ip = dhcpEntry->ip;
					dhcpData.expiry = dhcpEntry->expiry;
					dhcpData.local = dhcpEntry->local;

					if (dhcpEntry->hostname)
						strcpy(dhcpData.hostname, dhcpEntry->hostname);

					cfig.dhcpInd++;
					dhcpData.dhcpInd = cfig.dhcpInd;
					dhcpEntry->dhcpInd = cfig.dhcpInd;
					fwrite(&dhcpData, sizeof(data8), 1, ff);
				}
			}
			fclose(ff);
		}
	}
}

bool getSection(const char *sectionName, char *buffer, MYBYTE serial, char *fileName)
{
	//printf("%s=%s\n",fileName,sectionName);
	char section[128];
	sprintf(section, "[%s]", sectionName);
	myUpper(section);
	FILE *f = fopen(fileName, "rt");
	char buff[512];
	MYBYTE found = 0;

	if (f)
	{
		while (fgets(buff, 511, f))
		{
			myUpper(buff);
			myTrim(buff, buff);

			if (strstr(buff, section) == buff)
			{
				found++;
				if (found == serial)
				{
					//printf("%s=%s\n",fileName,sectionName);
					while (fgets(buff, 511, f))
					{
						myTrim(buff, buff);

						if (strstr(buff, "[") == buff)
							break;

						if ((*buff) >= '0' && (*buff) <= '9' || (*buff) >= 'A' && (*buff) <= 'Z' || (*buff) >= 'a' && (*buff) <= 'z' || ((*buff) && strchr("/\\?*", (*buff))))
						{
							buffer += sprintf(buffer, "%s", buff);
							buffer++;
						}
					}
					break;
				}
			}
		}
		fclose(f);
	}

	*buffer = 0;
	*(buffer + 1) = 0;
	return (found == serial);
}

FILE *openSection(const char *sectionName, MYBYTE serial)
{
	char section[128];
	sprintf(section, "[%s]", sectionName);
	myUpper(section);
	FILE *f = NULL;
	f = fopen(iniFile, "rt");

	if (f)
	{
		//printf("opened %s=%d\n", tempbuff, f);
		char buff[512];
		MYBYTE found = 0;

		while (fgets(buff, 511, f))
		{
			myUpper(buff);
			myTrim(buff, buff);

			if (strstr(buff, section) == buff)
			{
				found++;

				if (found == serial)
				{
					MYDWORD fpos = ftell(f);

					if (fgets(buff, 511, f))
					{
						myTrim(buff, buff);

						if (buff[0] == '@')
						{
							fclose(f);
							f = NULL;

							buff[0] = NBSP;
							myTrim(buff, buff);

							if (strchr(buff, '\\') || strchr(buff, '/'))
								strcpy(tempbuff, buff);
							else
								sprintf(tempbuff, "%s%s", filePATH, buff);

							//printf("%s\n", tempbuff);

							f = fopen(tempbuff, "rt");

							if (f)
								return f;
							else
							{
								sprintf(logBuff, "Error: Section [%s], file %s not found", sectionName, tempbuff);
								logMess(logBuff, 1);
								return NULL;
							}
						}
						else
						{
							fseek(f, fpos, SEEK_SET);
							return f;
						}
					}
				}
			}
		}
		fclose(f);
	}
	return NULL;
}

char *readSection(char* buff, FILE *f)
{
	while (fgets(buff, 511, f))
	{
		myTrim(buff, buff);

		if (*buff == '[')
			break;

		if ((*buff) >= '0' && (*buff) <= '9' || (*buff) >= 'A' && (*buff) <= 'Z' || (*buff) >= 'a' && (*buff) <= 'z' || ((*buff) && strchr("/\\?*", (*buff))))
			return buff;
	}

	fclose(f);
	return NULL;
}

char* myGetToken(char* buff, MYBYTE index)
{
	while (*buff)
	{
		if (index)
			index--;
		else
			break;

		buff += strlen(buff) + 1;
	}

	return buff;
}

MYWORD myTokenize(char *target, char *source, const char *sep, bool whiteSep)
{
	bool found = true;
	char *dp = target;
	MYWORD kount = 0;

	while (*source)
	{
		if (sep && sep[0] && strchr(sep, (*source)))
		{
			found = true;
			source++;
			continue;
		}
		else if (whiteSep && (*source) <= NBSP)
		{
			found = true;
			source++;
			continue;
		}

		if (found)
		{
			if (target != dp)
			{
				*dp = 0;
				dp++;
			}
			kount++;
		}

		found = false;
		*dp = *source;
		dp++;
		source++;
	}

	*dp = 0;
	dp++;
	*dp = 0;

	//printf("%s\n", target);

	return kount;
}

char* myTrim(char *target, char *source)
{
	while ((*source) && (*source) <= NBSP)
		source++;

	int i = 0;

	for (; i < 511 && source[i]; i++)
		target[i] = source[i];

	target[i] = source[i];
	i--;

	for (; i >= 0 && target[i] <= NBSP; i--)
		target[i] = 0;

	return target;
}

void mySplit(char *name, char *value, char *source, char splitChar)
{
	int i = 0;
	int j = 0;
	int k = 0;

	for (; source[i] && j <= 510 && source[i] != splitChar; i++, j++)
	{
		name[j] = source[i];
	}

	if (source[i])
	{
		i++;
		for (; k <= 510 && source[i]; i++, k++)
		{
			value[k] = source[i];
		}
	}

	name[j] = 0;
	value[k] = 0;

	myTrim(name, name);
	myTrim(value, value);
	//printf("%s %s\n", name, value);
}


char *strqtype(char *buff, MYBYTE qtype)
{
	switch (qtype)
	{
		case 1:
			strcpy(buff, "A");
			break;
		case 2:
			strcpy(buff, "NS");
			break;
		case 3:
			strcpy(buff, "MD");
			break;
		case 4:
			strcpy(buff, "MF");
			break;
		case 5:
			strcpy(buff, "CNAME");
			break;
		case 6:
			strcpy(buff, "SOA");
			break;
		case 7:
			strcpy(buff, "MB");
			break;
		case 8:
			strcpy(buff, "MG");
			break;
		case 9:
			strcpy(buff, "MR");
			break;
		case 10:
			strcpy(buff, "NULL");
			break;
		case 11:
			strcpy(buff, "WKS");
			break;
		case 12:
			strcpy(buff, "PTR");
			break;
		case 13:
			strcpy(buff, "HINFO");
			break;
		case 14:
			strcpy(buff, "MINFO");
			break;
		case 15:
			strcpy(buff, "MX");
			break;
		case 16:
			strcpy(buff, "TXT");
			break;
		case 28:
			strcpy(buff, "AAAA");
			break;
		case 251:
			strcpy(buff, "IXFR");
			break;
		case 252:
			strcpy(buff, "AXFR");
			break;
		case 253:
			strcpy(buff, "MAILB");
			break;
		case 254:
			strcpy(buff, "MAILA");
			break;
		default:
			strcpy(buff, "ANY");
			break;
	}
	return buff;
}

MYDWORD getClassNetwork(MYDWORD ip)
{
	data15 data;
	data.ip = ip;
	data.octate[3] = 0;

	if (data.octate[0] < 192)
		data.octate[2] = 0;

	if (data.octate[0] < 128)
		data.octate[1] = 0;

	return data.ip;
}

/*
char *IP2Auth(MYDWORD ip)
{
data15 data;
data.ip = ip;

if (data.octate[0] >= 192)
sprintf(tempbuff, "%u.%u.%u", data.octate[2], data.octate[1], data.octate[0]);
else if (data.octate[0] >= 128)
sprintf(tempbuff, "%u.%u", data.octate[1], data.octate[0]);
else
sprintf(tempbuff, "%u", data.octate[0]);

strcat(tempbuff, arpa);
return tempbuff;
}
*/

char *IP2String(char *target, MYDWORD ip)
{
	data15 inaddr;
	inaddr.ip = ip;
	sprintf(target, "%u.%u.%u.%u", inaddr.octate[0], inaddr.octate[1], inaddr.octate[2], inaddr.octate[3]);
	//MYBYTE *octate = (MYBYTE*)&ip;
	//sprintf(target, "%u.%u.%u.%u", octate[0], octate[1], octate[2], octate[3]);
	return target;
}

MYDWORD *addServer(MYDWORD *array, MYBYTE maxServers, MYDWORD ip)
{
	for (MYBYTE i = 0; i < maxServers; i++)
	{
		if (array[i] == ip)
			return &(array[i]);
		else if (!array[i])
		{
			array[i] = ip;
			return &(array[i]);
		}
	}
	return NULL;
}

MYDWORD *findServer(MYDWORD *array, MYBYTE maxServers, MYDWORD ip)
{
	if (ip)
	{
		for (MYBYTE i = 0; i < maxServers && array[i]; i++)
		{
			if (array[i] == ip)
				return &(array[i]);
		}
	}
	return NULL;
}

bool isInt(char *str)
{
	if (!str || !(*str))
		return false;

	for(; *str; str++)
		if (*str <  '0' || *str > '9')
			return false;

	return true;
}

bool isIP(char *str)
{
	if (!str || !(*str))
		return false;

	MYDWORD ip = inet_addr(str);
	int j = 0;

	for (; *str; str++)
	{
		if (*str == '.' && *(str + 1) != '.')
			j++;
		else if (*str < '0' || *str > '9')
			return false;
	}

	if (j == 3)
	 {
		if (ip == INADDR_NONE || ip == INADDR_ANY)
			return false;
		else
			return true;
	}
	else
		return false;
}

/*
char *toBase64(MYBYTE *source, MYBYTE length)
{
	MYBYTE a = 0, b = 0, i = 0;
	char *dp = tempbuff;

	for (; length; length--, source++)
	{
		i += 2;
		a = (*source) >> i;
		*dp = base64[a + b];
		dp++;
		b = (*source) << (8 - i);
		b >>= 2;
		if (i == 6)
		{
			*dp = base64[b];
			dp++;
			i = b = 0;
		}
	}
	if (i)
	{
		*dp = base64[b];
		dp++;
	}
	*dp = 0;
	//printf("%s\n",tempbuff);
	return tempbuff;
}

MYBYTE getBaseValue(MYBYTE a)
{
	if (a >= 'A' && a <= 'Z')
		a -= 'A';
	else if (a >= 'a' && a <= 'z')
		a = a - 'a' + 26;
	else if (a >= '0' && a <= '9')
		a = a - '0' + 52;
	else if (a == '+')
		a = 62;
	else if (a == '/')
		a = 63;
	else
		a = UCHAR_MAX;

	return a;
}

MYBYTE fromBase64(MYBYTE *target, char *source)
{
	//printf("SOURCE=%s\n", source);
	MYBYTE b = 0;
	MYBYTE shift = 4;
	MYBYTE bp_hlen = (3 * strlen(source))/4;
	*target = 0;

	if (*source)
	{
		b = getBaseValue(*source);
		*target = b << 2;
		source++;

		while (*source)
		{
			b = getBaseValue(*source);
			(*target) += (b >> (8 - shift));
			target++;
			(*target) = (b << shift);
			shift += 2;

			if (shift > 8)
			{
				source++;

				if (*source)
				{
					b = getBaseValue(*source);
					*target = b << 2;
					shift = 4;
				}
				else
					break;
			}

			source++;
		}
	}
	//printf("SIZE=%u\n", bp_hlen);
	return bp_hlen;
}

char *toUUE(char *tempbuff, MYBYTE *source, MYBYTE length)
{
	MYBYTE a = 0, b = 0, i = 0;
	char *dp = tempbuff;

	for (; length; length--, source++)
	{
		i += 2;
		a = (*source) >> i;
		*dp = a + b + NBSP;
		dp++;
		b = (*source) << (8 - i);
		b >>= 2;
		if (i == 6)
		{
			*dp = b + NBSP;
			dp++;
			i = b = 0;
		}
	}
	if (i)
	{
		*dp = b + NBSP;
		dp++;
	}
	*dp = 0;
	//printf("%s\n",tempbuff);
	return tempbuff;
}

MYBYTE fromUUE(MYBYTE *target, char *source)
{
	//printf("SOURCE=%s\n", source);
	MYBYTE b = 0;
	MYBYTE shift = 4;
	MYBYTE bp_hlen = (3 * strlen(source))/4;
	*target = 0;

	if (*source)
	{
		b = *source - NBSP;
		*target = b << 2;
		source++;

		while (*source)
		{
			b = *source - NBSP;
			(*target) += (b >> (8 - shift));
			target++;
			(*target) = (b << shift);
			shift += 2;

			if (shift > 8)
			{
				source++;

				if (*source)
				{
					b = *source - NBSP;
					*target = b << 2;
					shift = 4;
				}
				else
					break;
			}

			source++;
		}
	}
	//printf("SIZE=%u\n", bp_hlen);
	return bp_hlen;
}
*/

char *hex2String(char *target, MYBYTE *hex, MYBYTE bytes)
{
	char *dp = target;

	if (bytes)
		dp += sprintf(target, "%02x", *hex);
	else
		*target = 0;

	for (MYBYTE i = 1; i < bytes; i++)
			dp += sprintf(dp, ":%02x", *(hex + i));

	return target;
}

char *genHostName(char *target, MYBYTE *hex, MYBYTE bytes)
{
	char *dp = target;

	if (bytes)
		dp += sprintf(target, "Host%02x", *hex);
	else
		*target = 0;

	for (MYBYTE i = 1; i < bytes; i++)
			dp += sprintf(dp, "%02x", *(hex + i));

	return target;
}

/*
char *IP62String(char *target, MYBYTE *source)
{
	MYWORD *dw = (MYWORD*)source;
	char *dp = target;
	MYBYTE markbyte;

	for (markbyte = 4; markbyte > 0 && !dw[markbyte - 1]; markbyte--);

	for (MYBYTE i = 0; i < markbyte; i++)
		dp += sprintf(dp, "%x:", ntohs(dw[i]));

	for (markbyte = 4; markbyte < 8 && !dw[markbyte]; markbyte++);

	for (MYBYTE i = markbyte; i < 8; i++)
		dp += sprintf(dp, ":%x", htons(dw[i]));

	return target;
}
*/

char *IP62String(char *target, MYBYTE *source)
{
	char *dp = target;
	bool zerostarted = false;
	bool zeroended = false;

	for (MYBYTE i = 0; i < 16; i += 2, source += 2)
	{
		if (source[0])
		{
			if (zerostarted)
				zeroended = true;

			if (zerostarted && zeroended)
			{
				dp += sprintf(dp, "::");
				zerostarted = false;
			}
			else if (dp != target)
				dp += sprintf(dp, ":");

			dp += sprintf(dp, "%x", source[0]);
			dp += sprintf(dp, "%02x", source[1]);
		}
		else if (source[1])
		{
			if (zerostarted)
				zeroended = true;

			if (zerostarted && zeroended)
			{
				dp += sprintf(dp, "::");
				zerostarted = false;
			}
			else if (dp != target)
				dp += sprintf(dp, ":");

			dp += sprintf(dp, "%0x", source[1]);
		}
		else if (!zeroended)
			zerostarted = true;
	}

	return target;
}

char *getHexValue(MYBYTE *target, char *source, MYBYTE *size)
{
	if (*size)
		memset(target, 0, (*size));

	for ((*size) = 0; (*source) && (*size) < UCHAR_MAX; (*size)++, target++)
	{
		if ((*source) >= '0' && (*source) <= '9')
		{
			(*target) = (*source) - '0';
		}
		else if ((*source) >= 'a' && (*source) <= 'f')
		{
			(*target) = (*source) - 'a' + 10;
		}
		else if ((*source) >= 'A' && (*source) <= 'F')
		{
			(*target) = (*source) - 'A' + 10;
		}
		else
		{
			return source;
		}

		source++;

		if ((*source) >= '0' && (*source) <= '9')
		{
			(*target) *= 16;
			(*target) += (*source) - '0';
		}
		else if ((*source) >= 'a' && (*source) <= 'f')
		{
			(*target) *= 16;
			(*target) += (*source) - 'a' + 10;
		}
		else if ((*source) >= 'A' && (*source) <= 'F')
		{
			(*target) *= 16;
			(*target) += (*source) - 'A' + 10;
		}
		else if ((*source) == ':' || (*source) == '-')
		{
			source++;
			continue;
		}
		else if (*source)
		{
			return source;
		}
		else
		{
			continue;
		}

		source++;

		if ((*source) == ':' || (*source) == '-')
		{
			source++;
		}
		else if (*source)
			return source;
	}

	if (*source)
		return source;

	return NULL;
}

char *myUpper(char *string)
{
	char diff = 'a' - 'A';
	MYWORD len = strlen(string);
	for (int i = 0; i < len; i++)
		if (string[i] >= 'a' && string[i] <= 'z')
			string[i] -= diff;
	return string;
}

char *myLower(char *string)
{
	char diff = 'a' - 'A';
	MYWORD len = strlen(string);
	for (int i = 0; i < len; i++)
		if (string[i] >= 'A' && string[i] <= 'Z')
			string[i] += diff;
	return string;
}

bool wildcmp(char *string, char *wild)
{
	// Written by Jack Handy - jakkhandy@hotmail.com
	// slightly modified
	char *cp = NULL;
	char *mp = NULL;

	while ((*string) && (*wild != '*'))
	{
		if ((*wild != *string) && (*wild != '?'))
		{
			return 0;
		}
		wild++;
		string++;
	}

	while (*string)
	{
		if (*wild == '*')
		{
			if (!*++wild)
				return 1;

			mp = wild;
			cp = string + 1;
		}
		else if ((*wild == *string) || (*wild == '?'))
		{
			wild++;
			string++;
		}
		else
		{
			wild = mp;
			string = cp++;
		}
	}

	while (*wild == '*')
		wild++;

	return !(*wild);
}

bool isLocal(MYDWORD ip)
{
	if (cfig.rangeStart && htonl(ip) >= cfig.rangeStart && htonl(ip) <= cfig.rangeEnd)
		return true;
	else if (getRangeInd(ip) >= 0)
		return true;
	else
		return false;
}

MYBYTE makeLocal(char *mapname)
{
	if (!strcasecmp(mapname, cfig.zone))
	{
		mapname[0] = 0;
		return DNTYPE_A_ZONE;
	}
	else if (!strcasecmp(mapname, cfig.authority))
		return DNTYPE_P_ZONE;
	else if (char *dp = strchr(mapname, '.'))
	{
		if (!strcasecmp(dp + 1, cfig.zone))
		{
			*dp = 0;
			return DNTYPE_A_LOCAL;
		}
		else if (dp = strstr(mapname, arpa))
		{
			if (strstr(mapname, cfig.authority))
			{
				*dp = 0;
				return DNTYPE_P_LOCAL;
			}
			else
			{
				*dp = 0;
				return DNTYPE_P_EXT;
			}
		}
		else if (strstr(mapname, ip6arpa))
			return DNTYPE_P_EXT;
		else
			return DNTYPE_A_EXT;
	}
	else
		return DNTYPE_A_BARE;
}

void listCache()
{
	hostMap::iterator p = dnsCache[currentInd].begin();
	data7 *cache = NULL;

	while (p != dnsCache[currentInd].end())
	{
		cache = p->second;
		sprintf(logBuff, "%s=%s %d %s", cache->mapname, IP2String(tempbuff, cache->ip), cache->hostname, cache->hostname);
		logMess(logBuff, 1);
		p++;
	}
}

void checkSize(MYBYTE ind)
{
	//listCache();
	//printf("Start %u=%u\n",dnsCache[ind].size(),dnsAge[ind].size());
	//printf("Cache size %u=%u\n",dnsCache[ind].size(),dnsAge[ind].size());
	data7 *cache = NULL;
	//MYBYTE maxDelete = 3;
	expiryMap::iterator p = dnsAge[ind].begin();
	expiryMap::iterator q;

	//while (p != dnsAge[ind].end() && p->first < t && maxDelete > 0)
	while (p != dnsAge[ind].end() && p->first <= t)
	{
		cache = p->second;
		//printf("processing %s=%i\n", cache->mapname, p->first - t);

		if (cache->expiry <= t)
		{
			q = p;
			p++;
			dnsAge[ind].erase(q);

			if (cache->dataType == QUEUE && cache->expiry)
			{
				if (cache->dnsIndex < MAX_SERVERS)
				{
					if (network.currentDNS == cache->dnsIndex)
					{
						if (network.dns[1])
						{
							network.currentDNS++;

							if (network.currentDNS >= MAX_SERVERS || !network.dns[network.currentDNS])
								network.currentDNS = 0;
						}
					}
				}
				else if (cache->dnsIndex >= 128 && cache->dnsIndex < 192)
				{
					data6 *dnsRoute = &cfig.dnsRoutes[(cache->dnsIndex - 128) / 2];
					MYBYTE currentDNS = cache->dnsIndex % 2;

					if (dnsRoute->currentDNS == currentDNS && dnsRoute->dns[1])
						dnsRoute->currentDNS = 1 - dnsRoute->currentDNS;
				}
			}


			if (cfig.replication != 2)
			{
				if (cache->dataType == LOCAL_A)
					cfig.serial1 = t;
				else if (cache->dataType == LOCAL_PTR_AUTH)
					cfig.serial2 = t;
			}

			//sprintf(logBuff, "t=%u expiry=%u DataType=%u Cache Size=%u, Age Size=%u, Entry %s being deleted", t, cache->expiry, cache->dataType, dnsCache[ind].size(), dnsAge[ind].size(), cache->mapname);
			//logMess(logBuff, 1);
			delDnsEntry(ind, cache);
			//maxDelete--;
		}
		else
		{
			q = p;
			p++;
			dnsAge[ind].erase(q);
			dnsAge[ind].insert(pair<time_t, data7*>(cache->expiry, cache));
		}
	}

	//printf("Done %u=%u\n",dnsCache[ind].size(),dnsAge[ind].size());
/*
	if (ind == currentInd && dhcpService)
	{
		//printf("dhcpAge=%u\n", dhcpAge.size());

		p = dhcpAge.begin();

		while (p != dhcpAge.end() && p->first < t)
		{
			cache = p->second;
			//printf("processing %s=%i\n", cache->mapname, p->first - t);

			if (cache->hanged && cache->expiry > t)
			{
				q = p;
				p++;
				dhcpAge.erase(q);
				dhcpAge.insert(pair<time_t, data7*>(cache->expiry, cache));
			}
			else
			{
				q = p;
				p++;
				dhcpAge.erase(q);

				if (cache->hanged && cache->expiry < t)
				{
					sendRepl(cache);
					printf("Lease released\n");
				}

				cache->hanged = false;
			}
		}
	}
*/
}

void calcRangeLimits(MYDWORD ip, MYDWORD mask, MYDWORD *rangeStart, MYDWORD *rangeEnd)
{
	*rangeStart = htonl(ip & mask) + 1;
	*rangeEnd = htonl(ip | (~mask)) - 1;
}

bool checkMask(MYDWORD mask)
{
	mask = htonl(mask);
	while (mask)
	{
		if (mask < (mask << 1))
			return false;

		mask <<= 1;
	}
	return true;
}

MYDWORD calcMask(MYDWORD rangeStart, MYDWORD rangeEnd)
{
	data15 ip1, ip2, mask;

	ip1.ip = htonl(rangeStart);
	ip2.ip = htonl(rangeEnd);

	for (MYBYTE i = 0; i < 4; i++)
	{
		mask.octate[i] = ip1.octate[i] ^ ip2.octate[i];

		if (i && mask.octate[i - 1] < 255)
			mask.octate[i] = 0;
		else if (mask.octate[i] == 0)
			mask.octate[i] = 255;
		else if (mask.octate[i] < 2)
			mask.octate[i] = 254;
		else if (mask.octate[i] < 4)
			mask.octate[i] = 252;
		else if (mask.octate[i] < 8)
			mask.octate[i] = 248;
		else if (mask.octate[i] < 16)
			mask.octate[i] = 240;
		else if (mask.octate[i] < 32)
			mask.octate[i] = 224;
		else if (mask.octate[i] < 64)
			mask.octate[i] = 192;
		else if (mask.octate[i] < 128)
			mask.octate[i] = 128;
		else
			mask.octate[i] = 0;
	}
	return mask.ip;
}

data7 *findEntry(MYBYTE ind, char *key, MYBYTE entryType)
{
	myLower(key);
	hostMap::iterator it = dnsCache[ind].find(key);

	while (it != dnsCache[ind].end() && !strcasecmp(it->second->mapname, key))
	{
		if (it->second->dataType == entryType)
			return it->second;
		else
			it++;
	}

	return NULL;
}

data7 *findEntry(MYBYTE ind, char *key)
{
	//printf("finding %u=%s\n",ind,key);
	myLower(key);
	hostMap::iterator it = dnsCache[ind].find(key);

	if (it != dnsCache[ind].end())
		return it->second;
	else
		return NULL;
}

data7 *findDHCPEntry(char *key)
{
	//printf("finding %u=%s\n",ind,key);
	myLower(key);
	dhcpMap::iterator it = dhcpCache.find(key);

	if (it == dhcpCache.end())
		return NULL;
	else
		return it->second;
}

void addEntry(MYBYTE ind, data7 *entry)
{
	myLower(entry->mapname);
	dnsCache[ind].insert(pair<string, data7*>(entry->mapname, entry));

	if (entry->expiry && entry->expiry < INT_MAX)
		dnsAge[ind].insert(pair<time_t, data7*>(entry->expiry, entry));
}

void delDnsEntry(MYBYTE ind, data7* cache)
{
	if (cache)
	{
		//printf("DataType=%u Size=%u, Entry %s being deleted\n", cache->dataType, dnsCache[ind].size(), cache->mapname);

		if (ind <= 1)
		{
			hostMap::iterator r = dnsCache[ind].find(cache->mapname);

			for (; r != dnsCache[ind].end(); r++)
				if (strcasecmp(r->second->mapname, cache->mapname))
					break;
				else if (r->second == cache)
				{
					dnsCache[ind].erase(r);
					break;
				}

			switch (cache->dataType)
			{
				case QUEUE:

					if (cache->addr)
						free(cache->addr);

					if (cache->query)
						free(cache->query);

					if (cache->mapname)
						free(cache->mapname);

					break;

				case LOCAL_PTR_AUTH:
				case LOCAL_PTR_NAUTH:
				case LOCALHOST_PTR:
				case SERVER_PTR_AUTH:
				case SERVER_PTR_NAUTH:
				case STATIC_PTR_AUTH:
				case STATIC_PTR_NAUTH:
				case LOCAL_CNAME:
				case EXT_CNAME:
				case CACHED:

					if (cache->hostname)
						free(cache->hostname);

					if (cache->mapname)
						free(cache->mapname);

					break;

				default:

					if (cache->mapname)
						free(cache->mapname);

					break;
			}

			free(cache);
		}
	}
	return;
}

char *cloneString(char *string)
{
	char *s = (char*)calloc(1, strlen(string) + 1);

	if (s)
		strcpy(s, string);

	return s;
}

MYDWORD getSerial(char *zone)
{
	char tempbuff[256];
	char logBuff[256];
	MYDWORD serial1 = 0;
	data5 req;
	memset(&req, 0, sizeof(data5));
	req.remote.sin_family = AF_INET;
	req.remote.sin_port = htons(IPPORT_DNS);
	timeval tv1;
	fd_set readfds1;

	if (cfig.replication == 2)
		req.remote.sin_addr.s_addr = cfig.zoneServers[0];
	else
		req.remote.sin_addr.s_addr = cfig.zoneServers[1];

	req.sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);
	req.dnsp = (dnsPacket*)req.raw;
	req.dnsp->header.qdcount = htons(1);
	req.dnsp->header.xid = (t % USHRT_MAX);
	req.dp = &req.dnsp->data;
	req.dp += pQu(req.dp, zone);
	req.dp += pUShort(req.dp, DNS_TYPE_SOA);
	req.dp += pUShort(req.dp, DNS_CLASS_IN);
	req.bytes = req.dp - req.raw;
	//pUShort(req.raw, req.bytes - 2);

	if ((req.bytes = sendto(req.sock, req.raw, req.bytes, 0, (sockaddr*)&req.remote, sizeof(req.remote))) <= 0)
	{
		closesocket(req.sock);
		sprintf(logBuff, "Failed to send request to Primary Server %s", IP2String(tempbuff, req.remote.sin_addr.s_addr));
		logDNSMess(logBuff, 1);
		return 0;
	}

	FD_ZERO(&readfds1);
	tv1.tv_sec = 5;
	tv1.tv_usec = 0;
	FD_SET(req.sock, &readfds1);
	select(USHRT_MAX, &readfds1, NULL, NULL, &tv1);

	if (FD_ISSET(req.sock, &readfds1))
	{
		req.sockLen = sizeof(req.remote);
		req.bytes = recvfrom(req.sock, req.raw, sizeof(req.raw), 0, (sockaddr*)&req.remote, &req.sockLen);

		if (req.bytes > 0 && req.dnsp->header.qr && !req.dnsp->header.rcode && ntohs(req.dnsp->header.ancount))
		{
			req.dp = &req.dnsp->data;
			for (int j = 1; j <= ntohs(req.dnsp->header.qdcount); j++)
			{
				req.dp += fQu(tempbuff, req.dnsp, req.dp);
				req.dp += 4;
			}

			for (int i = 1; i <= ntohs(req.dnsp->header.ancount); i++)
			{
				req.dp += fQu(tempbuff, req.dnsp, req.dp);
				req.qtype = fUShort(req.dp);
				req.dp += 2; //type
				req.qclass = fUShort(req.dp);
				req.dp += 2; //class
				fULong(req.dp);
				req.dp += 4; //ttl
				req.dp += 2; //datalength

				if (req.qtype == DNS_TYPE_SOA)
				{
					req.dp += fQu(tempbuff, req.dnsp, req.dp);
					req.dp += fQu(tempbuff, req.dnsp, req.dp);
					serial1 = fULong(req.dp);
				}
			}
		}
	}

	closesocket(req.sock);
	return serial1;
}

void checkDNS(MYBYTE dnsIndex)
{
	//printf("DNS Index %u\n", dnsIndex);
	data5 req;
	memset(&req, 0, sizeof(data5));
	strcpy(req.query, "1.0.0.127.in-addr.arpa");
	req.remote.sin_family = AF_INET;
	req.remote.sin_port = htons(IPPORT_DNS);

	if (dnsIndex < MAX_SERVERS)
	{
		if (network.currentDNS == dnsIndex)
			req.remote.sin_addr.s_addr = network.dns[dnsIndex];
		else
			return;
	}
	else if (dnsIndex >= 128 && dnsIndex < 192)
	{
		MYBYTE childIndex = (dnsIndex - 128) / 2;
		data6 *dnsRoute = &cfig.dnsRoutes[childIndex];
		MYBYTE currentDNS = dnsIndex % 2;

		if (dnsRoute->currentDNS == currentDNS)
			req.remote.sin_addr.s_addr = dnsRoute->dns[currentDNS];
		else
			return;
	}
	else
		return;

	req.dnsp = (dnsPacket*)req.raw;
	req.dnsp->header.qdcount = htons(1);
	req.dnsp->header.xid = (t % USHRT_MAX);
	req.dp = &req.dnsp->data;
	req.dp += pQu(req.dp, req.query);
	req.dp += pUShort(req.dp, DNS_TYPE_PTR);
	req.dp += pUShort(req.dp, DNS_CLASS_IN);
	req.bytes = req.dp - req.raw;

	char mapname[8];
	sprintf(mapname, "%u", req.dnsp->header.xid);
	data7 *queue = findEntry(currentInd, mapname, DNS_CHECK);

	if (!queue)
	{
		if ((req.bytes = sendto(network.forwConn.sock, req.raw, req.bytes, 0, (sockaddr*)&req.remote, sizeof(req.remote))) > 0)
		{
			queue = (data7*)calloc(1, sizeof(data7));
			if (queue)
			{
				queue->mapname = cloneString(mapname);

				if (!queue->mapname)
				{
					free(queue);
					return;
				}

				queue->expiry = 2 + t;
				queue->dataType = DNS_CHECK;
				queue->sockInd = UCHAR_MAX;
				queue->dnsIndex = dnsIndex;
				addEntry(currentInd, queue);
			}
			else
				return;

			if (verbatim || cfig.dnsLogLevel >= 1)
			{
				if (dnsIndex < MAX_SERVERS)
					sprintf(logBuff, "Verification sent to Forwarding DNS Server %s", IP2String(tempbuff, req.remote.sin_addr.s_addr));
				else
					sprintf(logBuff, "Verification sent to Child DNS Server %s", IP2String(tempbuff, req.remote.sin_addr.s_addr));

				logDNSMess(logBuff, 1);
			}
		}
	}
}

char *getServerName(char *target, MYDWORD ip)
{
	data5 req;
	memset(&req, 0, sizeof(data5));
	req.remote.sin_family = AF_INET;
	req.remote.sin_port = htons(IPPORT_DNS);
	req.remote.sin_addr.s_addr = ip;

	timeval tv1;
	fd_set readfds1;

	req.sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);

	req.dnsp = (dnsPacket*)req.raw;
	req.dnsp->header.qdcount = htons(1);
	req.dnsp->header.xid = (t % USHRT_MAX);
	req.dp = &req.dnsp->data;
	IP2String(target, htonl(ip));
	strcat(target, arpa);
	req.dp += pQu(req.dp, target);
	req.dp += pUShort(req.dp, DNS_TYPE_PTR);
	req.dp += pUShort(req.dp, DNS_CLASS_IN);
	req.bytes = req.dp - req.raw;
	//pUShort(req.raw, req.bytes - 2);

	if ((req.bytes = sendto(req.sock, req.raw, req.bytes, 0, (sockaddr*)&req.remote, sizeof(req.remote))) <= 0)
	{
		closesocket(req.sock);
		return NULL;
	}

	FD_ZERO(&readfds1);
	tv1.tv_sec = 5;
	tv1.tv_usec = 0;
	FD_SET(req.sock, &readfds1);
	select(USHRT_MAX, &readfds1, NULL, NULL, &tv1);

	if (FD_ISSET(req.sock, &readfds1))
	{
		req.sockLen = sizeof(req.remote);
		req.bytes = recvfrom(req.sock, req.raw, sizeof(req.raw), 0, (sockaddr*)&req.remote, &req.sockLen);
		if (req.bytes > 0 && req.dnsp->header.qr && !req.dnsp->header.rcode && ntohs(req.dnsp->header.ancount))
		{
			closesocket(req.sock);
			return getResult(&req);
		}
	}

	closesocket(req.sock);
	return NULL;
}

MYWORD recvTcpDnsMess(SOCKET sock, char *target, bool ready)
{
	timeval tv1;
	fd_set readfds1;

	if (!ready)
	{
		FD_ZERO(&readfds1);
		tv1.tv_sec = 5;
		tv1.tv_usec = 0;
		FD_SET(sock, &readfds1);

		if (!select(sock + 1, &readfds1, NULL, NULL, &tv1))
			return 0;
	}

	errno = 0;
	MYWORD rcd = recv(sock, target, 2, 0);
	//errno = WSAGetLastError();

	if (errno)
		return 0;

	if (rcd == 2)
	{
		MYWORD bytes = fUShort(target) + rcd;
		char *ptr;

		while (rcd < bytes)
		{
			FD_ZERO(&readfds1);
			tv1.tv_sec = 5;
			tv1.tv_usec = 0;
			FD_SET(sock, &readfds1);
			ptr = target + rcd;

			if (select(sock + 1, &readfds1, NULL, NULL, &tv1))
			{
				errno = 0;
				rcd += recv(sock, ptr, bytes - rcd, 0);
				//errno = WSAGetLastError();

				if (errno)
					return 0;
			}
			else
				return 0;
		}
		return rcd;
	}
	return 0;
}

void emptyCache(MYBYTE rInd)
{
	//data7 *cache = NULL;

	//sprintf(logBuff, "Emptying cache[%d] Start %d=%d",rInd, dnsCache[rInd].size(), dnsAge[rInd].size());
	//logMess(logBuff, 2);

	cfig.mxCount[rInd] = 0;
	dnsAge[rInd].clear();
	hostMap::iterator p = dnsCache[rInd].begin();
	hostMap::iterator q;

	while (p != dnsCache[rInd].end())
	{
		p++;
		delDnsEntry(rInd, p->second);
	}
}

void *checkZone(void *lpParam)
{
	char tempbuff[256];
	char logBuff[256];

	sleep((cfig.refresh));

	while (kRunning)
	{
		MYBYTE updateCache = 1 - currentInd;
		emptyCache(updateCache);
		sprintf(logBuff, "Checking Serial from Primary Server %s", IP2String(tempbuff, cfig.zoneServers[0]));
		logDNSMess(logBuff, 2);

		MYDWORD serial1 = getSerial(cfig.zone);
		MYDWORD serial2 = getSerial(cfig.authority);

		if (!serial1 || !serial2)
		{
			cfig.dhcpRepl = 0;
			cfig.dnsRepl = 0;
			sprintf(logBuff, "Failed to get Serial from %s, waiting %i seconds to retry", IP2String(tempbuff, cfig.zoneServers[0]), cfig.retry);
			logDNSMess(logBuff, 1);
			sleep((cfig.retry));
			continue;
		}
		else if (cfig.serial1 && cfig.serial1 == serial1 && cfig.serial2 && cfig.serial2 == serial2)
		{
			cfig.dnsRepl = t + cfig.refresh;
			sprintf(logBuff, "Zone Refresh not required");
			logDNSMess(logBuff, 2);

			if (cfig.expire > (MYDWORD)(INT_MAX - t))
				cfig.expireTime = INT_MAX;
			else
				cfig.expireTime = t + cfig.expire;

			sleep((cfig.refresh));
		}
		else
		{
			//WaitForSingleObject(rEvent, INFINITE);
			serial1 = getZone(updateCache, cfig.zone);
			serial2 = getZone(updateCache, cfig.authority);
			//SetEvent(rEvent);

			if (!serial1 || !serial2)
			{
				sprintf(logBuff, "Waiting %u seconds to retry", cfig.retry);
				logDNSMess(logBuff, 1);
				sleep((cfig.retry));
			}
			else
			{
				cfig.dnsRepl = t + cfig.refresh;
				newInd = updateCache;
				cfig.serial1 = serial1;
				cfig.serial2 = serial2;

				if (cfig.expire > (MYDWORD)(INT_MAX - t))
					cfig.expireTime = INT_MAX;
				else
					cfig.expireTime = t + cfig.expire;

				sleep((cfig.refresh));
			}
		}
	}
	pthread_exit(NULL);
}

MYDWORD getZone(MYBYTE updateCache, char *zone)
{
	char tempbuff[256];
	char logBuff[256];
	char hostname[256];
	char cname[256];
	char localhost[] = "localhost";
	MYBYTE zoneType = 0;
	MYDWORD serial1 = 0;
	MYDWORD serial2 = 0;
	MYDWORD hostExpiry = 0;
	MYDWORD refresh = 0;
	MYDWORD retry = 0;
	MYDWORD expire = 0;
	MYDWORD expiry;
	MYDWORD minimum = 0;
	int added = 0;
	char *data;
	char *dp;
	MYDWORD ip;
	data5 req;

	if (!strcasecmp(zone, cfig.zone))
	{
		zoneType = DNTYPE_A_ZONE;
		add2Cache(updateCache, localhost, inet_addr("127.0.0.1"), INT_MAX, LOCALHOST_A, 0);
	}
	else if (!strcasecmp(zone, cfig.authority))
	{
		zoneType = DNTYPE_P_ZONE;
		add2Cache(updateCache, localhost, inet_addr("127.0.0.1"), INT_MAX, 0, LOCALHOST_PTR);
	}
	else
		return 0;

	memset(&req, 0, sizeof(data5));
	req.sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);

	if (req.sock == INVALID_SOCKET)
	{
		sprintf(logBuff, "Failed to Create Socket, Zone Transfer Failed");
		logDNSMess(logBuff, 1);
		return 0;
	}

	req.addr.sin_family = AF_INET;
	req.addr.sin_addr.s_addr = cfig.zoneServers[1];
	req.addr.sin_port = 0;

	int nRet = bind(req.sock, (sockaddr*)&req.addr, sizeof(req.addr));

	if (nRet == SOCKET_ERROR)
	{
		closesocket(req.sock);
		sprintf(logBuff, "Error: Interface %s not ready, Zone Transfer Failed", IP2String(tempbuff, req.addr.sin_addr.s_addr));
		logDNSMess(logBuff, 1);
		return 0;
	}

	req.remote.sin_family = AF_INET;
	req.remote.sin_port = htons(IPPORT_DNS);
	req.remote.sin_addr.s_addr = cfig.zoneServers[0];

	req.sockLen = sizeof(req.remote);

	if (connect(req.sock, (sockaddr*)&req.remote, req.sockLen) >= 0)
	{
		req.dp = req.raw;
		req.dp += 2;
		req.dnsp = (dnsPacket*)req.dp;
		req.dnsp->header.qdcount = htons(1);
		req.dnsp->header.xid = (t % USHRT_MAX);
		req.dp = &req.dnsp->data;
		req.dp += pQu(req.dp, zone);
		req.dp += pUShort(req.dp, DNS_TYPE_AXFR);
		req.dp += pUShort(req.dp, DNS_CLASS_IN);
		req.bytes = req.dp - req.raw;
		pUShort(req.raw, req.bytes - 2);

		if (send(req.sock, req.raw, req.bytes, 0) < req.bytes)
		{
			closesocket(req.sock);
			sprintf(logBuff, "Failed to contact Primary Server %s, Zone Transfer Failed", IP2String(tempbuff, req.remote.sin_addr.s_addr));
			logDNSMess(logBuff, 1);
			return 0;
		}

		while (kRunning)
		{
			req.bytes = recvTcpDnsMess(req.sock, req.raw, false);
			//printf("bytes = %u\n", req.bytes);

			if (req.bytes < 2)
				break;

			MYWORD pktSize = fUShort(req.raw);

			if ((MYWORD)req.bytes < pktSize + 2)
				break;

			req.dnsp = (dnsPacket*)(req.raw + 2);
			req.dp = &req.dnsp->data;

			if (!req.dnsp->header.qr || req.dnsp->header.rcode || !ntohs(req.dnsp->header.ancount))
				break;

			for (int j = 1; j <= ntohs(req.dnsp->header.qdcount); j++)
			{
				req.dp += fQu(hostname, req.dnsp, req.dp);
				req.dp += 4;
			}

			for (int i = 1; i <= ntohs(req.dnsp->header.ancount); i++)
			{
				//char *dp = req.dp;
				req.dp += fQu(hostname, req.dnsp, req.dp);

				if (!hostname[0])
					continue;

				//printf("%s\n", hostname);
				req.qtype = fUShort(req.dp);
				req.dp += 2; //type
				req.qclass = fUShort(req.dp);
				req.dp += 2; //class
				expiry = fULong(req.dp);
				req.dp += 4; //ttl
				int dataSize = fUShort(req.dp);
				req.dp += 2; //datalength
				data = req.dp;
				req.dp += dataSize;

				switch (req.qtype)
				{
					case DNS_TYPE_SOA:

						data += fQu(hostname, req.dnsp, data);
						data += fQu(cname, req.dnsp, data);

						if (!serial1)
						{
							hostExpiry = expiry;
							serial1 = fULong(data);
							data += 4;
							refresh = fULong(data);
							data += 4;
							retry = fULong(data);
							data += 4;
							expire = fULong(data);
							data += 4;
							minimum = fULong(data);
							data += 4;
							added++;
						}
						else if (!serial2)
							serial2 = fULong(data);

						break;

					case DNS_TYPE_A:

						ip = fIP(data);
						makeLocal(hostname);
						add2Cache(updateCache, hostname, ip, INT_MAX, STATIC_A_AUTH, NONE);
						added++;
						break;

					case DNS_TYPE_PTR:

						myLower(hostname);
						dp = strstr(hostname, arpa);

						if (dp)
						{
							*dp = 0;
							ip = ntohl(inet_addr(hostname));
							fQu(hostname, req.dnsp, data);
							makeLocal(hostname);
							add2Cache(updateCache, hostname, ip, INT_MAX, NONE, STATIC_PTR_AUTH);
							added++;
						}
						break;

					case DNS_TYPE_MX:

						if (cfig.replication == 2 && makeLocal(hostname) == DNTYPE_A_ZONE)
						{
							cfig.mxServers[updateCache][cfig.mxCount[updateCache]].pref = fUShort(data);
							data += sizeof(MYWORD);
							fQu(cname, req.dnsp, data);
							strcpy(cfig.mxServers[updateCache][cfig.mxCount[updateCache]].hostname, cname);
							cfig.mxCount[updateCache]++;
							added++;
						}
						break;

					case DNS_TYPE_NS:
						if (cfig.replication == 2)
						{
							if (zoneType == DNTYPE_A_ZONE)
							{
								fQu(cfig.nsA, req.dnsp, data);
								strcpy(cfig.nsABare, cfig.nsA);
								makeLocal(cfig.nsABare);
							}
							else
							{
								fQu(cfig.nsP, req.dnsp, data);
								strcpy(cfig.nsPBare, cfig.nsP);
								makeLocal(cfig.nsPBare);
							}
						}
						break;

					case DNS_TYPE_CNAME:
						if (cfig.replication == 2)
						{
							fQu(cname, req.dnsp, data);
							MYBYTE cname_type = 0;

							if (makeLocal(cname) == DNTYPE_A_EXT)
								cname_type = EXT_CNAME;
							else
								cname_type = LOCAL_CNAME;

							makeLocal(hostname);

							data7 *cache = findEntry(updateCache, hostname, cname_type);

							if (!cache)
							{
								cache = (data7*)calloc(1, sizeof(data7));

								if (cache)
								{
									cache->mapname = cloneString(hostname);
									cache->dataType = cname_type;
									cache->hostname = cloneString(cname);

									if (cache->mapname && cache->hostname)
									{
										addEntry(updateCache, cache);
									}
									else
									{
										sprintf(logBuff, "Memory Error");
										logDNSMess(logBuff, 1);
										continue;
									}
								}
								else
								{
									sprintf(logBuff, "Memory Error");
									logDNSMess(logBuff, 1);
									continue;
								}
							}
							else
							{
								if (strcasecmp(cname, cache->hostname))
								{
									free(cache->hostname);
									cache->hostname = cloneString(cname);
								}
							}

							cache->expiry = INT_MAX;
//							cache->serial = serial1;
							added++;
						}
						break;
				}
				//printf("serial=%u %u %u\n", serial1, serial2, hostExpiry);
			}
		}

		closesocket(req.sock);

		if (serial1 && serial1 == serial2 && hostExpiry)
		{
			if (cfig.replication == 2)
			{
				cfig.lease = hostExpiry;
				cfig.refresh = refresh;
				cfig.retry = retry;
				cfig.expire = expire;
				cfig.minimum = minimum;
			}

			//printf("Refresh ind %i serial %u size %i\n", updateCache, serial1, dnsCache[updateCache].size());
			sprintf(logBuff, "Zone %s Transferred from Primary Server, %u RRs imported", zone, added);
			logDNSMess(logBuff, 1);
			return serial1;
		}
		else if (!serial1)
		{
			sprintf(logBuff, "Replication Server %s, Missing Serial", IP2String(tempbuff, req.remote.sin_addr.s_addr));
			logDNSMess(logBuff, 1);
		}
		else if (serial1 != serial2)
		{
			sprintf(logBuff, "Replication Server %s, Serial Changed %u %u", IP2String(tempbuff, req.remote.sin_addr.s_addr), serial1, serial2);
			logDNSMess(logBuff, 1);
		}
		else
		{
			sprintf(logBuff, "Replication Server %s, Invalid AXFR data", IP2String(tempbuff, req.remote.sin_addr.s_addr));
			logDNSMess(logBuff, 1);
		}
	}
	else
	{
		//errno = WSAGetLastError();
		sprintf(logBuff, "Failed to contact Primary Server %s, Zone Transfer Failed", IP2String(tempbuff, req.remote.sin_addr.s_addr));
		logDNSMess(logBuff, 1);
		closesocket(req.sock);
	}

	return 0;
}

bool getSecondary()
{
	char hostname[256];
	MYDWORD ip;
	MYDWORD hostExpiry = 0;
	MYDWORD expiry = 0;
	char *data = NULL;
	char *dp = NULL;
	MYWORD rr = 0;
	data5 req;
	MYDWORD serial = 0;

	memset(&req, 0, sizeof(data5));
	req.sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);

	if (req.sock == INVALID_SOCKET)
		return false;

	req.addr.sin_family = AF_INET;
	req.addr.sin_addr.s_addr = cfig.zoneServers[0];
	req.addr.sin_port = 0;

	int nRet = bind(req.sock, (sockaddr*)&req.addr, sizeof(req.addr));

	if (nRet == SOCKET_ERROR)
	{
		closesocket(req.sock);
		return false;
	}

	req.remote.sin_family = AF_INET;
	req.remote.sin_port = htons(IPPORT_DNS);

	if (dhcpService && cfig.replication == 1)
		req.remote.sin_addr.s_addr = cfig.zoneServers[1];
	else
		return false;

	req.sockLen = sizeof(req.remote);
	time_t t = time(NULL);

	if (connect(req.sock, (sockaddr*)&req.remote, req.sockLen) == 0)
	{
		req.dp = req.raw;
		req.dp += 2;
		req.dnsp = (dnsPacket*)req.dp;
		req.dnsp->header.qdcount = htons(1);
		req.dnsp->header.xid = (t % USHRT_MAX);
		req.dp = &req.dnsp->data;
		req.dp += pQu(req.dp, cfig.authority);
		req.dp += pUShort(req.dp, DNS_TYPE_AXFR);
		req.dp += pUShort(req.dp, DNS_CLASS_IN);
		req.bytes = req.dp - req.raw;
		pUShort(req.raw, (req.bytes - 2));

		if (send(req.sock, req.raw, req.bytes, 0) < req.bytes)
		{
			closesocket(req.sock);
			return false;
		}

		while (kRunning)
		{
			req.bytes = recvTcpDnsMess(req.sock, req.raw, false);
			//printf("bytes = %u\n", req.bytes);

			if (req.bytes < 2)
				break;

			MYWORD pktSize = fUShort(req.raw);

			if ((MYWORD)req.bytes < pktSize + 2)
				break;

			req.dnsp = (dnsPacket*)(req.raw + 2);
			req.dp = &req.dnsp->data;

			if (!req.dnsp->header.qr || req.dnsp->header.rcode || !ntohs(req.dnsp->header.ancount))
				break;

			for (int j = 1; j <= ntohs(req.dnsp->header.qdcount); j++)
			{
				req.dp += fQu(hostname, req.dnsp, req.dp);
				req.dp += 4;
			}

			for (int i = 1; i <= ntohs(req.dnsp->header.ancount); i++)
			{
				//char *dp = req.dp;
				req.dp += fQu(hostname, req.dnsp, req.dp);
				//printf("%s\n", hostname);
				req.qtype = fUShort(req.dp);
				req.dp += 2; //type
				req.qclass = fUShort(req.dp);
				req.dp += 2; //class
				expiry = fULong(req.dp);
				req.dp += 4; //ttl
				int dataSize = fUShort(req.dp);
				req.dp += 2; //datalength
				data = req.dp;
				req.dp += dataSize;

				if (req.qtype == DNS_TYPE_PTR)
				{
					myLower(hostname);
					dp = strstr(hostname, arpa);

					if (dp)
					{
						*dp = 0;
						ip = ntohl(inet_addr(hostname));
						fQu(hostname, req.dnsp, data);
						makeLocal(hostname);

						//printf("candidate %s=%s\n", hostname, IP2String(tempbuff, ip));

						dhcpMap::iterator p = dhcpCache.begin();
						data7 *dhcpEntry = NULL;

						for (; p != dhcpCache.end(); p++)
						{
							if ((dhcpEntry = p->second) && dhcpEntry->ip && dhcpEntry->hostname)
							{
								//printf("%s=%s\n", dhcpEntry->hostname, hostname);
								if (ip == dhcpEntry->ip && !strcasecmp(hostname, dhcpEntry->hostname))
								{
									//printf("added %s=%s\n", hostname, IP2String(tempbuff, ip));
									if (expiry < (MYDWORD)(INT_MAX - t))
										expiry += t;
									else
										expiry = INT_MAX;

									add2Cache(0, hostname, ip, expiry, LOCAL_A, LOCAL_PTR_AUTH);
									rr++;
									break;
								}
							}
						}
					}
				}
			}
		}

		sprintf(logBuff, "%u RRs rebuild from Secondary Server", rr);
		logDNSMess(logBuff, 2);
		closesocket(req.sock);
		return true;
	}
	else
	{
//		errno = WSAGetLastError();
//		sprintf(logBuff, "Failed to connect to Secondary Server %s, Winsock Error %u", IP2String(tempbuff, req.remote.sin_addr.s_addr), errno);
//		logDNSMess(logBuff, 1);
		closesocket(req.sock);
		return false;
	}
}

void *init(void *lparam)
{
    char raw[512];
    char name[512];
    char value[512];
    FILE *f = NULL;

	if (f = openSection("LOGGING", 1))
	{
		cfig.dnsLogLevel = 1;
		cfig.dhcpLogLevel = 1;
		tempbuff[0] = 0;

		while (readSection(raw, f))
		{
			mySplit(name, value, raw, '=');

			if (name[0] && value[0])
			{
				if (!strcasecmp(name, "DNSLogLevel"))
				{
					if (!strcasecmp(value, "None"))
						cfig.dnsLogLevel = 0;
					else if (!strcasecmp(value, "Normal"))
						cfig.dnsLogLevel = 1;
					else if (!strcasecmp(value, "All"))
						cfig.dnsLogLevel = 2;
					else
						sprintf(tempbuff, "Section [LOGGING], Invalid DNSLogLevel: %s", value);
				}
				else if (!strcasecmp(name, "DHCPLogLevel"))
				{
					if (!strcasecmp(value, "None"))
						cfig.dhcpLogLevel = 0;
					else if (!strcasecmp(value, "Normal"))
						cfig.dhcpLogLevel = 1;
					else if (!strcasecmp(value, "All"))
						cfig.dhcpLogLevel = 2;
					else
						sprintf(tempbuff, "Section [LOGGING], Invalid DHCPLogLevel: %s", value);
				}
				else
					sprintf(tempbuff, "Section [LOGGING], Invalid Entry %s ignored", raw);
			}
			else
				sprintf(tempbuff, "Section [LOGGING], Invalid Entry %s ignored", raw);
		}

		if (tempbuff[0])
			logMess(logBuff, 1);

		sprintf(logBuff, "%s Starting...", sVersion);
		logMess(logBuff, 1);
	}
	else
		printf("%s Starting...", sVersion);

	sleep(1);

	if ((f = fopen(iniFile, "rt")))
	{
		fclose(f);
	}
	else
	{
		sprintf(logBuff, "Warning: file %s not found, defaults will be used", iniFile);
		logMess(logBuff, 1);
	}

	if (f = openSection("SERVICES", 1))
	{
		dhcpService = false;
		dnsService = false;

		while(readSection(raw, f))
		{
			if (!strcasecmp(raw, "DNS"))
				dnsService = true;
			else if (!strcasecmp(raw, "DHCP"))
				dhcpService = true;
			else
			{
				sprintf(logBuff, "Section [SERVICES] invalid entry %s ignored", raw);
				logMess(logBuff, 1);
			}
		}

		if (!dhcpService && !dnsService)
		{
			dhcpService = true;
			dnsService = true;
		}
	}

	if (dnsService)
	{
		sprintf(logBuff, "Starting DNS Service");
		logDNSMess(logBuff, 1);
	}

	if (dhcpService)
	{
		sprintf(logBuff, "Starting DHCP Service");
		logMess(logBuff, 1);
	}

	sleep(1);

	if (dnsService)
	{
		if (cfig.dnsLogLevel == 2)
			sprintf(logBuff, "DNS Logging: All");
		else if (cfig.dnsLogLevel == 1)
			sprintf(logBuff, "DNS Logging: Normal");
		else
			sprintf(logBuff, "DNS Logging: None");

		logMess(logBuff, 1);
	}

	if (dhcpService)
	{
		if (cfig.dhcpLogLevel >= 2)
			sprintf(logBuff, "DHCP Logging: All");
		else if (cfig.dhcpLogLevel == 1)
			sprintf(logBuff, "DHCP Logging: Normal");
		else
			sprintf(logBuff, "DHCP Logging: None");

		logMess(logBuff, 1);
	}

	cfig.lease = 36000;

	if (f = openSection("TIMINGS", 1))
	{
		while (readSection(raw, f))
		{
			mySplit(name, value, raw, '=');

			if (name[0] && value[0])
			{
				if (atol(value) || !strcasecmp(value,"0"))
				{
					if (!strcasecmp(name, "AddressTime"))
					{
						cfig.lease = atol(value);

						if (!cfig.lease)
							cfig.lease = UINT_MAX;
					}
					else if (!strcasecmp(name, "Refresh"))
						cfig.refresh = atol(value);
					else if (!strcasecmp(name, "Retry"))
						cfig.retry = atol(value);
					else if (!strcasecmp(name, "Expire"))
						cfig.expire = atol(value);
					else if (!strcasecmp(name, "Minimum"))
						cfig.minimum = atol(value);
					else if (!strcasecmp(name, "MinCacheTime"))
						cfig.minCache = atol(value);
					else if (!strcasecmp(name, "MaxCacheTime"))
						cfig.maxCache = atol(value);
					else
					{
						sprintf(logBuff, "Section [TIMINGS], Invalid Entry: %s ignored", raw);
						logDNSMess(logBuff, 1);
					}
				}
				else
				{
					sprintf(logBuff, "Section [TIMINGS], Invalid value: %s ignored", value);
					logDNSMess(logBuff, 1);
				}
			}
			else
			{
				sprintf(logBuff, "Section [TIMINGS], Missing value, entry %s ignored", raw);
				logDNSMess(logBuff, 1);
			}
		}
	}

	if (!cfig.refresh)
	{
		cfig.refresh = cfig.lease / 10;

		if (cfig.refresh > 3600)
			cfig.refresh = 3600;

		if (cfig.refresh < 300)
			cfig.refresh = 300;
	}

	if (!cfig.retry || cfig.retry > cfig.refresh)
	{
		cfig.retry = cfig.refresh / 5;

		if (cfig.retry > 600)
			cfig.retry = 600;

		if (cfig.retry < 60)
			cfig.retry = 60;
	}

	if (!cfig.expire)
	{
		if (UINT_MAX/24 > cfig.lease)
			cfig.expire = 24 * cfig.lease;
		else
			cfig.expire = UINT_MAX;
	}

	if (!cfig.minimum)
		cfig.minimum = cfig.retry;

	if (f = openSection("DOMAIN_NAME", 1))
	{
		while (readSection(raw, f))
		{
			mySplit(name, value, raw, '=');

			if (name[0] && value[0])
			{
				data15 mask;
				data15 network;
				char left[64];

				cfig.authority[0] = 0;
				myLower(value);
				mask.ip = 0;
				network.ip = 0;

				for (MYBYTE octateNum = 0; octateNum < 3; octateNum++)
				{
					mySplit(left, value, value, '.');
					if (left[0] == '0' || (atoi(left) && atoi(left) < 256))
					{
						for (int j = 2; j >= 0; j--)
						{
							network.octate[j + 1] = network.octate[j];
							mask.octate[j + 1] = mask.octate[j];
						}

						mask.octate[0] = UCHAR_MAX;
						network.octate[0] = atoi(left);
						strcat(cfig.authority, left);
						strcat(cfig.authority, ".");
					}
					else
						break;

					if (!strcasecmp(value, arpa + 1))
						break;
				}

				if (!strcasecmp(value, arpa + 1))
				{
					strcat(cfig.authority, arpa + 1);
					cfig.aLen = strlen(cfig.authority);
					calcRangeLimits(network.ip, mask.ip, &cfig.rangeStart, &cfig.rangeEnd);
					cfig.authorized = 1;
				}
				else
				{
					sprintf(logBuff, "Warning: Invalid Domain Name (Part %s), ignored", cfig.authority);
					cfig.aLen = 0;
					cfig.authority[0] = 0;
					logDNSMess(logBuff, 1);
				}
			}

			if (chkQu(name))
			{
				strcpy(cfig.zone, name);
				cfig.zLen = strlen(cfig.zone);
			}
			else
			{
				cfig.aLen = 0;
				cfig.authority[0] = 0;
				sprintf(logBuff, "Warning: Invalid Domain Name %s, ignored", raw);
				logDNSMess(logBuff, 1);
			}
		}
	}

	cfig.fixedSocket = socket(AF_INET, SOCK_DGRAM, 0);

	if (cfig.fixedSocket < 0)
	{
		sprintf(logBuff, "Failed to create Socket");
		logMess(logBuff, 1);
		exit(EXIT_FAILURE);
	}

	getInterfaces(&network);
	sprintf(cfig.servername_fqn, "%s.%s", cfig.servername, cfig.zone);

	if (f = openSection("ZONE_REPLICATION", 1))
	{
		int i = 2;
		while (readSection(raw, f))
		{
			if(i < MAX_TCP_CLIENTS)
			{
				if (dnsService && !cfig.authorized)
				{
					sprintf(logBuff, "Section [ZONE_REPLICATION], Server is not an authority, entry %s ignored", raw);
					logMess(logBuff, 1);
					continue;
				}

				mySplit(name, value, raw, '=');

				if (name[0] && value[0])
				{
					if (chkQu(name) && !isIP(name) && isIP(value))
					{
						if (!strcasecmp(name, "Primary"))
							cfig.zoneServers[0] = inet_addr(value);
						else if (!strcasecmp(name, "Secondary"))
							cfig.zoneServers[1] = inet_addr(value);
						else if (dnsService && !strcasecmp(name, "AXFRClient"))
						{
							cfig.zoneServers[i] = inet_addr(value);
							i++;
						}
						else
						{
							sprintf(logBuff, "Section [ZONE_REPLICATION] Invalid Entry: %s ignored", raw);
							logMess(logBuff, 1);
						}
					}
					else
					{
						sprintf(logBuff, "Section [ZONE_REPLICATION] Invalid Entry: %s ignored", raw);
						logMess(logBuff, 1);
					}
				}
				else
				{
					sprintf(logBuff, "Section [ZONE_REPLICATION], Missing value, entry %s ignored", raw);
					logMess(logBuff, 1);
				}
			}
		}
	}

	if (!cfig.zoneServers[0] && cfig.zoneServers[1])
	{
		sprintf(logBuff, "Section [ZONE_REPLICATION] Missing Primary Server");
		logMess(logBuff, 1);
	}
	else if (cfig.zoneServers[0] && !cfig.zoneServers[1])
	{
		sprintf(logBuff, "Section [ZONE_REPLICATION] Missing Secondary Server");
		logMess(logBuff, 1);
	}
	else if (cfig.zoneServers[0] && cfig.zoneServers[1])
	{
		if (findServer(network.staticServers, MAX_TCP_CLIENTS, cfig.zoneServers[0]) && findServer(network.staticServers, MAX_TCP_CLIENTS, cfig.zoneServers[1]))
		{
			sprintf(logBuff, "Section [ZONE_REPLICATION] Primary & Secondary should be Different Boxes");
			logMess(logBuff, 1);
		}
		else if (findServer(network.staticServers, MAX_SERVERS, cfig.zoneServers[0]))
			cfig.replication = 1;
		else if (findServer(network.staticServers, MAX_SERVERS, cfig.zoneServers[1]))
			cfig.replication = 2;
		else
		{
			sprintf(logBuff, "Section [ZONE_REPLICATION] No Server IP not found on this Machine");
			logMess(logBuff, 1);
		}
	}

	if (cfig.replication != 2)
	{
		strcpy(cfig.nsP, cfig.servername_fqn);
		strcpy(cfig.nsA, cfig.servername_fqn);
		strcpy(cfig.nsPBare, cfig.servername);
		strcpy(cfig.nsABare, cfig.servername);
	}

	if (dhcpService)
	{
		loadDHCP();

		for (int i = 0; i < cfig.rangeCount; i++)
		{
			char *logPtr = logBuff;
			logPtr += sprintf(logPtr, "DHCP Range: ");
			logPtr += sprintf(logPtr, "%s", IP2String(tempbuff, htonl(cfig.dhcpRanges[i].rangeStart)));
			logPtr += sprintf(logPtr, "-%s", IP2String(tempbuff, htonl(cfig.dhcpRanges[i].rangeEnd)));
			logPtr += sprintf(logPtr, "/%s", IP2String(tempbuff, cfig.dhcpRanges[i].mask));
			logMess(logBuff, 1);
		}


		if (cfig.replication)
		{
			lockIP(cfig.zoneServers[0]);
			lockIP(cfig.zoneServers[1]);
		}
	}

	if (dnsService)
	{
		if (f = openSection("DNS_ALLOWED_HOSTS", 1))
		{
			int i = 0;

			while (readSection(raw, f))
			{
				if(i < MAX_DNS_RANGES)
				{
					MYDWORD rs = 0;
					MYDWORD re = 0;
					mySplit(name, value, raw, '-');

					if (isIP(name) && isIP(value))
					{
						rs = htonl(inet_addr(name));
						re = htonl(inet_addr(value));
					}
					else if (isIP(name) && !value[0])
					{
						rs = htonl(inet_addr(name));
						re = rs;
					}

					//printf("%u=%u\n", rs, re);

					if (rs && re && rs <= re)
					{
						cfig.dnsRanges[i].rangeStart = rs;
						cfig.dnsRanges[i].rangeEnd = re;
						i++;
					}
					else
					{
						sprintf(logBuff, "Section [DNS_ALLOWED_HOSTS] Invalid entry %s in ini file, ignored", raw);
						logDNSMess(logBuff, 1);
					}
				}
			}
		}

		if (cfig.replication != 2 && (f = openSection("DNS_HOSTS", 1)))
		{
			while (readSection(raw, f))
			{
				mySplit(name, value, raw, '=');

				if (name[0] && value[0])
				{
					if (chkQu(name) && !isIP(name))
					{
						MYDWORD ip = inet_addr(value);
						MYBYTE nameType = makeLocal(name);
						bool ipLocal = isLocal(ip);

						if (!strcasecmp(value, "0.0.0.0"))
						{
							addHostNotFound(0, name);
							continue;
						}
						else if (!ip)
						{
							sprintf(logBuff, "Section [DNS_HOSTS] Invalid Entry %s ignored", raw);
							logDNSMess(logBuff, 1);
							continue;
						}

						switch (nameType)
						{
							case DNTYPE_A_ZONE:
							case DNTYPE_A_BARE:
							case DNTYPE_A_LOCAL:
								add2Cache(0, name, ip, INT_MAX, STATIC_A_AUTH, 0);
								break;

							default:
								if (cfig.replication)
								{
									sprintf(logBuff, "Section [DNS_HOSTS] forward entry for %s not in Forward Zone, ignored", raw);
									logDNSMess(logBuff, 1);
								}
								else
									add2Cache(0, name, ip, INT_MAX, STATIC_A_NAUTH, 0);

								break;
						}

						if (ipLocal)
						{
							add2Cache(0, name, ip, INT_MAX, 0, STATIC_PTR_AUTH);
							holdIP(ip);
						}
						else if (cfig.replication)
						{
							sprintf(logBuff, "Section [DNS_HOSTS] reverse entry for %s not in Reverse Zone, ignored", raw);
							logDNSMess(logBuff, 1);
						}
						else
							add2Cache(0, name, ip, INT_MAX, 0, STATIC_PTR_NAUTH);
					}
					else
					{
						sprintf(logBuff, "Section [DNS_HOSTS] Invalid Entry: %s ignored", raw);
						logDNSMess(logBuff, 1);
					}
				}
				else
				{
					sprintf(logBuff, "Section [DNS_HOSTS], Missing value, entry %s ignored", raw);
					logDNSMess(logBuff, 1);
				}
			}
		}

		if (cfig.replication != 2 && (f = openSection("ALIASES", 1)))
		{
			int i = 0;

			while (readSection(raw, f))
			{
				mySplit(name, value, raw, '=');

				if (name[0] && value[0])
				{
					MYBYTE nameType = makeLocal(name);
					MYBYTE aliasType = makeLocal(value);

					if (chkQu(name) && chkQu(value) && strcasecmp(value, cfig.zone))
					{
						if ((nameType == DNTYPE_A_BARE || nameType == DNTYPE_A_LOCAL || nameType == DNTYPE_A_ZONE))
						{
							data7 *cache = findEntry(0, name);

							if (!cache)
							{
								cache = (data7*)calloc(1, sizeof(data7));

								if (cache)
								{
									if ((aliasType == DNTYPE_A_BARE || aliasType == DNTYPE_A_LOCAL || aliasType == DNTYPE_A_ZONE))
										cache->dataType = LOCAL_CNAME;
									else
										cache->dataType = EXT_CNAME;

									cache->mapname = cloneString(name);
									cache->hostname = cloneString(value);

									if (!cache->mapname || !cache->hostname)
									{
										sprintf(logBuff, "Section [ALIASES] entry %s memory error", raw);
										logDNSMess(logBuff, 1);
									}
									else
									{
										cache->expiry = INT_MAX;
//										cache->serial = cfig.serial1;
										addEntry(0, cache);
										i++;
									}
								}
								else
								{
									sprintf(logBuff, "Section [ALIASES] entry %s memory error", raw);
									logDNSMess(logBuff, 1);
								}
							}
							else
							{
								sprintf(logBuff, "Section [ALIASES] duplicate entry %s ignored", raw);
								logDNSMess(logBuff, 1);
							}
						}
						else
						{
							sprintf(logBuff, "Section [ALIASES] alias %s should be bare/local name, entry ignored", name);
							logDNSMess(logBuff, 1);
						}
					}
					else
					{
						sprintf(logBuff, "Section [ALIASES] Invalid Entry: %s ignored", raw);
						logDNSMess(logBuff, 1);
					}
				}
				else
				{
					sprintf(logBuff, "Section [ALIASES], Missing value, entry %s ignored", raw);
					logDNSMess(logBuff, 1);
				}
			}
		}

		if (cfig.replication != 2 && (f = openSection("MAIL_SERVERS", 1)))
		{
			cfig.mxCount[0] = 0;

			while (readSection(raw, f))
			{
				if (cfig.mxCount[0] < MAX_SERVERS)
				{
					mySplit(name, value, raw, '=');
					if (name[0] && value[0])
					{
						if (chkQu(name) && atoi(value))
						{
							cfig.mxServers[0][cfig.mxCount[0]].pref = atoi(value);
							cfig.mxServers[1][cfig.mxCount[0]].pref = atoi(value);

							if (!strchr(name, '.'))
							{
								strcat(name, ".");
								strcat(name, cfig.zone);
							}

							strcpy(cfig.mxServers[0][cfig.mxCount[0]].hostname, name);
							strcpy(cfig.mxServers[1][cfig.mxCount[0]].hostname, name);
							cfig.mxCount[0]++;
						}
						else
						{
							sprintf(logBuff, "Section [MAIL_SERVERS] Invalid Entry: %s ignored", raw);
							logDNSMess(logBuff, 1);
						}
					}
					else
					{
						sprintf(logBuff, "Section [MAIL_SERVERS], Missing value, entry %s ignored", raw);
						logDNSMess(logBuff, 1);
					}
				}
				//cfig.mxCount[1] = cfig.mxCount[0];
			}
		}

		if (f = openSection("CONDITIONAL_FORWARDERS", 1))
		{
			int i = 0;

			while (readSection(raw, f))
			{
				if (i < MAX_COND_FORW)
				{
					mySplit(name, value, raw, '=');

					if (name[0] && value[0])
					{
						int j = 0;

						for (; j < MAX_COND_FORW && cfig.dnsRoutes[j].zone[0]; j++)
						{
							if (!strcasecmp(cfig.dnsRoutes[j].zone, name))
							{
								sprintf(logBuff, "Section [CONDITIONAL_FORWARDERS], Duplicate Entry for Child Zone %s ignored", raw);
								logDNSMess(logBuff, 1);
								break;
							}
						}

						if (j < MAX_COND_FORW && !cfig.dnsRoutes[j].zone[0])
						{
							if (name[0] && chkQu(name) && value[0])
							{
								char *value1 = strchr(value, ',');

								if (value1)
								{
									*value1 = 0;
									value1++;

									MYDWORD ip = inet_addr(myTrim(value, value));
									MYDWORD ip1 = inet_addr(myTrim(value1, value1));

									if (isIP(value) && isIP(value1))
									{
										strcpy(cfig.dnsRoutes[i].zone, name);
										cfig.dnsRoutes[i].zLen = strlen(cfig.dnsRoutes[i].zone);
										cfig.dnsRoutes[i].dns[0] = ip;
										cfig.dnsRoutes[i].dns[1] = ip1;
										i++;
									}
									else
									{
										sprintf(logBuff, "Section [CONDITIONAL_FORWARDERS] Invalid Entry: %s ignored", raw);
										logDNSMess(logBuff, 1);
									}
								}
								else
								{
									MYDWORD ip = inet_addr(value);

									if (isIP(value))
									{
										strcpy(cfig.dnsRoutes[i].zone, name);
										cfig.dnsRoutes[i].zLen = strlen(cfig.dnsRoutes[i].zone);
										cfig.dnsRoutes[i].dns[0] = ip;
										i++;
									}
									else
									{
										sprintf(logBuff, "Section [CONDITIONAL_FORWARDERS] Invalid Entry: %s ignored", raw);
										logDNSMess(logBuff, 1);
									}
								}
							}
							else
							{
								sprintf(logBuff, "Section [CONDITIONAL_FORWARDERS] Invalid Entry: %s ignored", raw);
								logDNSMess(logBuff, 1);
							}
						}
					}
					else
					{
						sprintf(logBuff, "Section [CONDITIONAL_FORWARDERS], Missing value, entry %s ignored", raw);
						logDNSMess(logBuff, 1);
					}
				}
			}
		}

		if (f = openSection("WILD_HOSTS", 1))
		{
			int i = 0;

			while (readSection(raw, f))
			{
				if (i < MAX_WILD_HOSTS)
				{
					mySplit(name, value, raw, '=');
					if (name[0] && value[0])
					{
						if (chkQu(name) && (isIP(value) || !strcasecmp(value, "0.0.0.0")))
						{
							MYDWORD ip = inet_addr(value);
							strcpy(cfig.wildHosts[i].wildcard, name);
							myLower(cfig.wildHosts[i].wildcard);
							cfig.wildHosts[i].ip = ip;
							i++;
						}
						else
						{
							sprintf(logBuff, "Section [WILD_HOSTS] Invalid Entry: %s ignored", raw);
							logDNSMess(logBuff, 1);
						}
					}
					else
					{
						sprintf(logBuff, "Section [WILD_HOSTS], Missing value, entry %s ignored", raw);
						logDNSMess(logBuff, 1);
					}
				}
			}
		}


		if (cfig.replication == 2)
		{
			while (true)
			{
				MYDWORD serial1 = getSerial(cfig.zone);
				MYDWORD serial2 = getSerial(cfig.authority);
				cfig.serial1 = getZone(0, cfig.zone);
				cfig.serial2 = getZone(0, cfig.authority);

				if (cfig.serial1 && cfig.serial2)
					break;

				sprintf(logBuff, "Failed to get Zones from Primary Server, waiting %d seconds to retry", cfig.retry);
				logDNSMess(logBuff, 1);

				sleep(cfig.retry);
			}

			if (dhcpService)
			{
				data7 *cache = NULL;
				hostMap::iterator p = dnsCache[0].begin();

				while (p != dnsCache[0].end())
				{
					cache = p->second;

					switch (cache->dataType)
					{
						case STATIC_A_AUTH:
							holdIP(cache->ip);
							break;

						case STATIC_PTR_AUTH:
							holdIP(htonl(inet_addr(cache->mapname)));
							break;
					}

					p++;
				}
			}

			if (cfig.expire > (MYDWORD)(INT_MAX - t))
				cfig.expireTime = INT_MAX;
			else
				cfig.expireTime = t + cfig.expire;

			pthread_t threadId;
			pthread_attr_t attr;
			pthread_attr_init(&attr);
			pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
			int errcode = pthread_create(&threadId, &attr, checkZone, 0);
			pthread_attr_destroy(&attr);
		}
		else if (cfig.replication == 1)
		{
			cfig.serial1 = t;
			cfig.serial2 = t;
			cfig.expireTime = INT_MAX;
			char localhost[] = "localhost";
			add2Cache(0, localhost, inet_addr("127.0.0.1"), INT_MAX, LOCALHOST_A, LOCALHOST_PTR);

			if (isLocal(cfig.zoneServers[0]))
				add2Cache(0, cfig.servername, cfig.zoneServers[0], INT_MAX, SERVER_A_AUTH, SERVER_PTR_AUTH);
			else
				add2Cache(0, cfig.servername, cfig.zoneServers[0], INT_MAX, SERVER_A_AUTH, SERVER_PTR_NAUTH);

			for (int i = 0; i < 2; i++)
			{
				if (getSecondary())
					break;
			}
		}
		else
		{
			cfig.serial1 = t;
			cfig.serial2 = t;
			cfig.expireTime = INT_MAX;
			char localhost[] = "localhost";
			add2Cache(0, localhost, inet_addr("127.0.0.1"), INT_MAX, LOCALHOST_A, LOCALHOST_PTR);

			bool ifspecified = false;

			if (f = openSection("LISTEN_ON", 1))
			{
				while (readSection(raw, f))
				{
					ifspecified = true;
					MYDWORD ip = inet_addr(raw);

					if (ip && ip != INADDR_NONE)
					{
						if (isLocal(ip))
							add2Cache(0, cfig.servername, ip, INT_MAX, SERVER_A_AUTH, SERVER_PTR_AUTH);
						else
							add2Cache(0, cfig.servername, ip, INT_MAX, SERVER_A_AUTH, SERVER_PTR_NAUTH);
					}
				}
			}

			for (int i = 0; !ifspecified && i < MAX_SERVERS && network.allServers[i]; i++)
			{
				if (isLocal(network.allServers[i]))
					add2Cache(0, cfig.servername, network.allServers[i], INT_MAX, SERVER_A_AUTH, SERVER_PTR_AUTH);
				else
					add2Cache(0, cfig.servername, network.allServers[i], INT_MAX, SERVER_A_AUTH, SERVER_PTR_NAUTH);
			}
		}
	}

	if (dhcpService)
	{
		if (cfig.replication)
		{
			cfig.dhcpReplConn.sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);

			if (cfig.dhcpReplConn.sock == INVALID_SOCKET)
			{
				sprintf(logBuff, "Failed to Create DHCP Replication Socket");
				logMess(logBuff, 1);
			}
			else
			{
				//printf("Socket %u\n", cfig.dhcpReplConn.sock);

				if (cfig.replication == 1)
					cfig.dhcpReplConn.server = cfig.zoneServers[0];
				else
					cfig.dhcpReplConn.server = cfig.zoneServers[1];

				cfig.dhcpReplConn.addr.sin_family = AF_INET;
				cfig.dhcpReplConn.addr.sin_addr.s_addr = cfig.dhcpReplConn.server;
				cfig.dhcpReplConn.addr.sin_port = 0;

				int nRet = bind(cfig.dhcpReplConn.sock, (sockaddr*)&cfig.dhcpReplConn.addr, sizeof(struct sockaddr_in));

				if (nRet == SOCKET_ERROR)
				{
					cfig.dhcpReplConn.ready = false;
					sprintf(logBuff, "DHCP Replication Server, Bind Failed");
					logMess(logBuff, 1);
				}
				else
				{
					cfig.dhcpReplConn.port = IPPORT_DHCPS;
					cfig.dhcpReplConn.loaded = true;
					cfig.dhcpReplConn.ready = true;

					data3 op;
					memset(&token, 0, sizeof(data9));
					token.vp = token.dhcpp.vend_data;
					token.messsize = sizeof(dhcp_packet);

					token.remote.sin_port = htons(IPPORT_DHCPS);
					token.remote.sin_family = AF_INET;

					if (cfig.replication == 1)
						token.remote.sin_addr.s_addr = cfig.zoneServers[1];
					else if (cfig.replication == 2)
						token.remote.sin_addr.s_addr = cfig.zoneServers[0];

					token.dhcpp.header.bp_op = BOOTP_REQUEST;
					token.dhcpp.header.bp_xid = t;
					token.dhcpp.header.bp_magic_num[0] = 99;
					token.dhcpp.header.bp_magic_num[1] = 130;
					token.dhcpp.header.bp_magic_num[2] = 83;
					token.dhcpp.header.bp_magic_num[3] = 99;

					op.opt_code = DHCP_OPTION_MESSAGETYPE;
					op.size = 1;
					op.value[0] = DHCP_MESS_INFORM;
					pvdata(&token, &op);

					if (dnsService)
					{
						op.opt_code = DHCP_OPTION_DNS;
						op.size = 4;

						if (cfig.replication == 1)
							pIP(op.value, cfig.zoneServers[0]);
						else
							pIP(op.value, cfig.zoneServers[1]);

						pvdata(&token, &op);

						if (cfig.replication == 2)
						{
							op.opt_code = DHCP_OPTION_HOSTNAME;
							op.size = strlen(cfig.servername);
							memcpy(op.value, cfig.servername, op.size);
							pvdata(&token, &op);
						}
					}

					token.vp[0] = DHCP_OPTION_END;
					token.vp++;
					token.bytes = token.vp - (MYBYTE*)token.raw;

					if (cfig.replication == 2)
					{
						pthread_t threadId;
						pthread_attr_t attr;
						pthread_attr_init(&attr);
						pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
						int errcode = pthread_create(&threadId, &attr, sendToken, 0);
						pthread_attr_destroy(&attr);
					}
				}
			}
		}

		if (cfig.lease >= INT_MAX)
			sprintf(logBuff, "Max Lease: Infinity");
		else
			sprintf(logBuff, "Max Lease: %u (sec)", cfig.lease);

		logMess(logBuff, 1);
	}

	if (cfig.replication == 1)
		sprintf(logBuff, "Server Name: %s (Primary)", cfig.servername);
	else if (cfig.replication == 2)
		sprintf(logBuff, "Server Name: %s (Secondary)", cfig.servername);
	else
		sprintf(logBuff, "Server Name: %s", cfig.servername);

	logDNSMess(logBuff, 1);

	if (dnsService)
	{
		if (cfig.authorized)
			sprintf(logBuff, "Authority for Zone: %s (%s)", cfig.zone, cfig.authority);
		else
			sprintf(logBuff, "Domain Name: %s", cfig.zone);

		logDNSMess(logBuff, 1);

		if (cfig.lease >= INT_MAX)
			sprintf(logBuff, "Default Host Expiry: Infinity");
		else
			sprintf(logBuff, "Default Host Expiry: %u (sec)", cfig.lease);

		logDNSMess(logBuff, 1);

		if (cfig.replication)
		{
			sprintf(logBuff, "Refresh: %u (sec)", cfig.refresh);
			logDNSMess(logBuff, 1);
			sprintf(logBuff, "Retry: %u (sec)", cfig.retry);
			logDNSMess(logBuff, 1);

			if (cfig.expire == UINT_MAX)
				sprintf(logBuff, "Expire: Infinity");
			else
				sprintf(logBuff, "Expire: %u (sec)", cfig.expire);

			logDNSMess(logBuff, 1);
			sprintf(logBuff, "Min: %u (sec)", cfig.minimum);
			logDNSMess(logBuff, 1);
		}

		for (int i = 0; i < MAX_COND_FORW && cfig.dnsRoutes[i].dns[0]; i++)
		{
			char temp[256];

			if (!cfig.dnsRoutes[i].dns[1])
				sprintf(logBuff, "Conditional Forwarder: %s for %s", IP2String(tempbuff, cfig.dnsRoutes[i].dns[0]), cfig.dnsRoutes[i].zone);
			else
				sprintf(logBuff, "Conditional Forwarder: %s, %s for %s", IP2String(temp, cfig.dnsRoutes[i].dns[0]), IP2String(tempbuff, cfig.dnsRoutes[i].dns[1]), cfig.dnsRoutes[i].zone);

			logDNSMess(logBuff, 1);
		}

		for (int i = 0; i < MAX_SERVERS && network.dns[i]; i++)
		{
			sprintf(logBuff, "Default Forwarding Server: %s", IP2String(tempbuff, network.dns[i]));
			logDNSMess(logBuff, 1);
		}

		//char temp[128];

		for (int i = 0; i <= MAX_DNS_RANGES && cfig.dnsRanges[i].rangeStart; i++)
		{
			char *logPtr = logBuff;
			logPtr += sprintf(logPtr, "%s", "DNS Service Permitted Hosts: ");
			logPtr += sprintf(logPtr, "%s-", IP2String(tempbuff, htonl(cfig.dnsRanges[i].rangeStart)));
			logPtr += sprintf(logPtr, "%s", IP2String(tempbuff, htonl(cfig.dnsRanges[i].rangeEnd)));
			logDNSMess(logBuff, 1);
		}
	}
	else
	{
		sprintf(logBuff, "Domain Name: %s", cfig.zone);
		logDNSMess(logBuff, 1);
	}

	sprintf(logBuff, "Detecting Static Interfaces..");
	logMess(logBuff, 1);
	getInterfaces(&newNetwork);
	memcpy(cfig.oldservers, newNetwork.staticServers, (MAX_SERVERS * sizeof(MYDWORD)));

	do
	{
		if (cfig.dhcpReplConn.ready && newNetwork.maxFD < cfig.dhcpReplConn.sock)
			newNetwork.maxFD = cfig.dhcpReplConn.sock;

		bool bindfailed = false;

		if (f = openSection("LISTEN_ON", 1))
		{
			//char *name = myGetToken(iniStr, 0)
			int i = 0;

			while (readSection(raw, f))
			{
				if(i < MAX_SERVERS)
				{
					cfig.ifspecified = true;
					MYDWORD addr = inet_addr(raw);

					if (isIP(raw))
					{
						for (MYBYTE m = 0; ; m++)
						{
							if (m >= MAX_SERVERS || !newNetwork.staticServers[m])
							{
								if (findServer(newNetwork.allServers, MAX_SERVERS, addr))
								{
									sprintf(logBuff, "Warning: Section [LISTEN_ON], Interface %s is not Static, ignored", raw);
									logMess(logBuff, 1);
								}
								else
								{
									bindfailed = true;
									sprintf(logBuff, "Warning: Section [LISTEN_ON], Interface %s not available, ignored", raw);
									logMess(logBuff, 1);
								}
								break;
							}
							else if (newNetwork.staticServers[m] == addr)
							{
								for (MYBYTE n = 0; n < MAX_SERVERS; n++)
								{
									if (newNetwork.listenServers[n] == addr)
										break;
									else if (!newNetwork.listenServers[n])
									{
										newNetwork.listenServers[n] = newNetwork.staticServers[m];
										newNetwork.listenMasks[n] = newNetwork.staticMasks[m];
										break;
									}
								}
								break;
							}
						}
					}
					else
					{
						sprintf(logBuff, "Warning: Section [LISTEN_ON], Invalid Interface Address %s, ignored", raw);
						logMess(logBuff, 1);
					}
				}
			}
		}

		if (!cfig.ifspecified)
		{
			for (MYBYTE n = 0; n < MAX_SERVERS && newNetwork.staticServers[n]; n++)
			{
				newNetwork.listenServers[n] = newNetwork.staticServers[n];
				newNetwork.listenMasks[n] = newNetwork.staticMasks[n];
			}
		}

		//printf("Setting DHCP Sockets\n");

		if (dhcpService)
		{
			int i = 0;

			for (int j = 0; j < MAX_SERVERS && newNetwork.listenServers[j]; j++)
			{
				int k = 0;

				for (; k < MAX_SERVERS && network.dhcpConn[k].loaded; k++)
				{
					if (network.dhcpConn[k].ready && network.dhcpConn[k].server == newNetwork.listenServers[j])
						break;
				}

				if (network.dhcpConn[k].ready && network.dhcpConn[k].server == newNetwork.listenServers[j])
				{
					memcpy(&(newNetwork.dhcpConn[i]), &(network.dhcpConn[k]), sizeof(DhcpConnType));

					if (newNetwork.maxFD < newNetwork.dhcpConn[i].sock)
						newNetwork.maxFD = newNetwork.dhcpConn[i].sock;

					network.dhcpConn[k].ready = false;
					i++;
					continue;
				}
				else
				{
					newNetwork.dhcpConn[i].sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);

					if (newNetwork.dhcpConn[i].sock == INVALID_SOCKET)
					{
						bindfailed = true;
						sprintf(logBuff, "Failed to Create Socket");
						logMess(logBuff, 1);
						continue;
					}

					//printf("Socket %u\n", newNetwork.dhcpConn[i].sock);

					newNetwork.dhcpConn[i].addr.sin_family = AF_INET;
					newNetwork.dhcpConn[i].addr.sin_addr.s_addr = newNetwork.listenServers[j];
					newNetwork.dhcpConn[i].addr.sin_port = htons(IPPORT_DHCPS);
					newNetwork.dhcpConn[i].reUseVal = true;
					newNetwork.dhcpConn[i].reUseSize = sizeof(newNetwork.dhcpConn[i].reUseVal);

					setsockopt(newNetwork.dhcpConn[i].sock, SOL_SOCKET, SO_REUSEADDR, (char*)&newNetwork.dhcpConn[i].reUseVal, newNetwork.dhcpConn[i].reUseSize);

					newNetwork.dhcpConn[i].broadCastVal = true;
					newNetwork.dhcpConn[i].broadCastSize = sizeof(newNetwork.dhcpConn[i].broadCastVal);

					setsockopt(newNetwork.dhcpConn[i].sock, SOL_SOCKET, SO_BROADCAST, (char*)&newNetwork.dhcpConn[i].broadCastVal, newNetwork.dhcpConn[i].broadCastSize);
					int nRet = bind(newNetwork.dhcpConn[i].sock, (sockaddr*)&newNetwork.dhcpConn[i].addr, sizeof(struct sockaddr_in));

					if (nRet == SOCKET_ERROR)
					{
						bindfailed = true;
						close(newNetwork.dhcpConn[i].sock);
						sprintf(logBuff, "%s Port 67 already in use", IP2String(tempbuff, newNetwork.listenServers[j]));
						logMess(logBuff, 1);
						continue;
					}

					newNetwork.dhcpConn[i].loaded = true;
					newNetwork.dhcpConn[i].ready = true;

					if (newNetwork.maxFD < newNetwork.dhcpConn[i].sock)
						newNetwork.maxFD = newNetwork.dhcpConn[i].sock;

					newNetwork.dhcpConn[i].server = newNetwork.listenServers[j];
					newNetwork.dhcpConn[i].mask = newNetwork.listenMasks[j];
					newNetwork.dhcpConn[i].port = IPPORT_DHCPS;

					i++;
				}
			}

			if (network.dhcpListener.ready)
			{
				memcpy(&(newNetwork.dhcpListener), &(network.dhcpListener), sizeof(DhcpConnType));

				if (newNetwork.maxFD < newNetwork.dhcpListener.sock)
					newNetwork.maxFD = newNetwork.dhcpListener.sock;

				network.dhcpListener.ready = false;
			}
			else
			{
				newNetwork.dhcpListener.sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);

				if (newNetwork.dhcpListener.sock == INVALID_SOCKET)
				{
					bindfailed = true;
					sprintf(logBuff, "Failed to Creat DHCP Socket");
					logMess(logBuff, 1);
				}
				else
				{
					newNetwork.dhcpListener.reUseVal = true;
					newNetwork.dhcpListener.reUseSize = sizeof(newNetwork.dhcpListener.reUseVal);
					setsockopt(newNetwork.dhcpListener.sock, SOL_SOCKET, SO_REUSEADDR, (char*)&newNetwork.dhcpListener.reUseVal, newNetwork.dhcpListener.reUseSize);
					newNetwork.dhcpListener.pktinfoVal = true;
					newNetwork.dhcpListener.pktinfoSize = sizeof(newNetwork.dhcpListener.pktinfoVal);
					setsockopt(newNetwork.dhcpListener.sock, IPPROTO_IP, IP_PKTINFO, &newNetwork.dhcpListener.pktinfoVal, newNetwork.dhcpListener.pktinfoSize);

					newNetwork.dhcpListener.addr.sin_family = AF_INET;
					newNetwork.dhcpListener.addr.sin_addr.s_addr = INADDR_ANY;
					newNetwork.dhcpListener.addr.sin_port = htons(IPPORT_DHCPS);

					int nRet = bind(newNetwork.dhcpListener.sock,
									(sockaddr*)&newNetwork.dhcpListener.addr,
									sizeof(struct sockaddr_in)
								   );

					if (nRet == SOCKET_ERROR)
					{
						bindfailed = true;
						close(newNetwork.dhcpListener.sock);
						sprintf(logBuff, "DHCP Port 67 already in use");
						logMess(logBuff, 1);
					}
					else
					{
						newNetwork.dhcpListener.loaded = true;
						newNetwork.dhcpListener.ready = true;

						if (newNetwork.maxFD < newNetwork.dhcpListener.sock)
							newNetwork.maxFD = newNetwork.dhcpListener.sock;
					}
				}
			}

			newNetwork.httpConn.port = 6789;
			newNetwork.httpConn.server = newNetwork.dhcpConn[0].server;
			newNetwork.httpConn.loaded = true;

			if (f = openSection("HTTP_INTERFACE", 1))
			{
				while (readSection(raw, f))
				{
					mySplit(name, value, raw, '=');

					if (!strcasecmp(name, "HTTPServer"))
					{
						mySplit(name, value, value, ':');

						if (isIP(name))
						{
							newNetwork.httpConn.loaded = true;
							newNetwork.httpConn.server = inet_addr(name);
						}
						else
						{
							newNetwork.httpConn.loaded = false;
							sprintf(logBuff, "Warning: Section [HTTP_INTERFACE], Invalid IP Address %s, ignored", name);
							logMess(logBuff, 1);
						}

						if (value[0])
						{
							if (atoi(value))
								newNetwork.httpConn.port = atoi(value);
							else
							{
								newNetwork.httpConn.loaded = false;
								sprintf(logBuff, "Warning: Section [HTTP_INTERFACE], Invalid port %s, ignored", value);
								logMess(logBuff, 1);
							}
						}

						if (newNetwork.httpConn.server != inet_addr("127.0.0.1") && !findServer(newNetwork.allServers, MAX_SERVERS, newNetwork.httpConn.server))
						{
							bindfailed = true;
							newNetwork.httpConn.loaded = false;
							sprintf(logBuff, "Warning: Section [HTTP_INTERFACE], %s not available, ignored", raw);
							logMess(logBuff, 1);
						}
					}
					else if (!strcasecmp(name, "HTTPClient"))
					{
						if (isIP(value))
							addServer(cfig.httpClients, 8, inet_addr(value));
						else
						{
							sprintf(logBuff, "Warning: Section [HTTP_INTERFACE], invalid client IP %s, ignored", raw);
							logMess(logBuff, 1);
						}
					}
					else
					{
						sprintf(logBuff, "Warning: Section [HTTP_INTERFACE], invalid entry %s, ignored", raw);
						logMess(logBuff, 1);
					}
				}
			}

			if (newNetwork.httpConn.loaded)
			{
				if (network.httpConn.ready && network.httpConn.server == newNetwork.httpConn.server)
				{
					memcpy(&(newNetwork.httpConn), &(network.httpConn), sizeof(ConnType));

					if (newNetwork.httpConn.sock > newNetwork.maxFD)
						newNetwork.maxFD = newNetwork.httpConn.sock;

					network.httpConn.ready = false;
				}
				else
				{
					newNetwork.httpConn.sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);

					if (newNetwork.httpConn.sock == INVALID_SOCKET)
					{
						bindfailed = true;
						sprintf(logBuff, "Failed to Create Socket");
						logMess(logBuff, 1);
					}
					else
					{
						//printf("Socket %u\n", newNetwork.httpConn.sock);

						newNetwork.httpConn.addr.sin_family = AF_INET;
						newNetwork.httpConn.addr.sin_addr.s_addr = newNetwork.httpConn.server;
						newNetwork.httpConn.addr.sin_port = htons(newNetwork.httpConn.port);

						int nRet = bind(newNetwork.httpConn.sock,
										(sockaddr*)&newNetwork.httpConn.addr,
										sizeof(struct sockaddr_in));

						if (nRet == SOCKET_ERROR)
						{
							bindfailed = true;
							sprintf(logBuff, "Http Interface %s TCP Port %u not available", IP2String(tempbuff, newNetwork.httpConn.server), newNetwork.httpConn.port);
							logMess(logBuff, 1);
							closesocket(newNetwork.httpConn.sock);
						}
						else
						{
							nRet = listen(newNetwork.httpConn.sock, SOMAXCONN);

							if (nRet == SOCKET_ERROR)
							{
								bindfailed = true;
								sprintf(logBuff, "%s TCP Port %u Error on Listen", IP2String(tempbuff, newNetwork.httpConn.server), newNetwork.httpConn.port);
								logMess(logBuff, 1);
								closesocket(newNetwork.httpConn.sock);
							}
							else
							{
								newNetwork.httpConn.loaded = true;
								newNetwork.httpConn.ready = true;

								if (newNetwork.httpConn.sock > newNetwork.maxFD)
									newNetwork.maxFD = newNetwork.httpConn.sock;
							}
						}
					}
				}
			}
		}

		//printf("Setting DNS Sockets\n");

		if (dnsService)
		{
			int i = 0;

			for (int j = 0; j < MAX_SERVERS && newNetwork.listenServers[j]; j++)
			{
				int k = 0;

				for (; k < MAX_SERVERS && network.dnsUdpConn[k].loaded; k++)
				{
					if (network.dnsUdpConn[k].ready && network.dnsUdpConn[k].server == newNetwork.listenServers[j])
						break;
				}

				if (network.dnsUdpConn[k].ready && network.dnsUdpConn[k].server == newNetwork.listenServers[j])
				{
					memcpy(&(newNetwork.dnsUdpConn[i]), &(network.dnsUdpConn[k]), sizeof(ConnType));

					if (newNetwork.maxFD < newNetwork.dnsUdpConn[i].sock)
						newNetwork.maxFD = newNetwork.dnsUdpConn[i].sock;

					network.dnsUdpConn[k].ready = false;
					i++;
					continue;
				}
				else
				{
					newNetwork.dnsUdpConn[i].sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);

					if (newNetwork.dnsUdpConn[i].sock == INVALID_SOCKET)
					{
						bindfailed = true;
						sprintf(logBuff, "Failed to Create Socket");
						logDNSMess(logBuff, 1);
						continue;
					}

					//printf("Socket %u\n", newNetwork.dnsUdpConn[i].sock);

					newNetwork.dnsUdpConn[i].addr.sin_family = AF_INET;
					newNetwork.dnsUdpConn[i].addr.sin_addr.s_addr = newNetwork.listenServers[j];
					newNetwork.dnsUdpConn[i].addr.sin_port = htons(IPPORT_DNS);

					int nRet = bind(newNetwork.dnsUdpConn[i].sock,
									(sockaddr*)&newNetwork.dnsUdpConn[i].addr,
									sizeof(struct sockaddr_in)
								   );

					if (nRet == SOCKET_ERROR)
					{
						bindfailed = true;
						closesocket(newNetwork.dnsUdpConn[i].sock);
						sprintf(logBuff, "Warning: %s UDP Port 53 already in use", IP2String(tempbuff, newNetwork.listenServers[j]));
						logDNSMess(logBuff, 1);
						continue;
					}

					newNetwork.dnsUdpConn[i].loaded = true;
					newNetwork.dnsUdpConn[i].ready = true;

					if (newNetwork.maxFD < newNetwork.dnsUdpConn[i].sock)
						newNetwork.maxFD = newNetwork.dnsUdpConn[i].sock;

					newNetwork.dnsUdpConn[i].server = newNetwork.listenServers[j];
					newNetwork.dnsUdpConn[i].port = IPPORT_DNS;

					i++;
				}
			}

			if (network.forwConn.ready)
			{
				memcpy(&(newNetwork.forwConn), &(network.forwConn), sizeof(ConnType));

				if (newNetwork.maxFD < newNetwork.forwConn.sock)
					newNetwork.maxFD = newNetwork.forwConn.sock;

				network.forwConn.ready = false;
			}
			else
			{
				newNetwork.forwConn.sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);

				if (newNetwork.forwConn.sock == INVALID_SOCKET)
				{
					bindfailed = true;
					sprintf(logBuff, "Failed to Create Socket");
					logDNSMess(logBuff, 1);
				}
				else
				{
					newNetwork.forwConn.addr.sin_family = AF_INET;
					newNetwork.forwConn.server = network.dns[0];
					newNetwork.forwConn.port = IPPORT_DNS;
					//bind(newNetwork.forwConn.sock, (sockaddr*)&newNetwork.forwConn.addr, sizeof(struct sockaddr_in));

					newNetwork.forwConn.loaded = true;
					newNetwork.forwConn.ready = true;

					if (newNetwork.maxFD < newNetwork.forwConn.sock)
						newNetwork.maxFD = newNetwork.forwConn.sock;
				}
			}

			i = 0;

			for (int j = 0; j < MAX_SERVERS && newNetwork.listenServers[j]; j++)
			{
				int k = 0;

				for (; k < MAX_SERVERS && network.dnsTcpConn[k].loaded; k++)
				{
					if (network.dnsTcpConn[k].ready && network.dnsTcpConn[k].server == newNetwork.listenServers[j])
						break;
				}

				if (network.dnsTcpConn[k].ready && network.dnsTcpConn[k].server == newNetwork.listenServers[j])
				{
					memcpy(&(newNetwork.dnsTcpConn[i]), &(network.dnsTcpConn[k]), sizeof(ConnType));

					if (newNetwork.maxFD < newNetwork.dnsTcpConn[i].sock)
						newNetwork.maxFD = newNetwork.dnsTcpConn[i].sock;

					network.dnsTcpConn[k].ready = false;
					i++;
					continue;
				}
				else
				{
					newNetwork.dnsTcpConn[i].sock = socket( PF_INET, SOCK_STREAM, IPPROTO_TCP);

					if (newNetwork.dnsTcpConn[i].sock == INVALID_SOCKET)
					{
						bindfailed = true;
						sprintf(logBuff, "Failed to Create Socket");
						logDNSMess(logBuff, 1);
					}
					else
					{
						//printf("Socket %u\n", newNetwork.dnsTcpConn[i].sock);
						newNetwork.dnsTcpConn[i].addr.sin_family = AF_INET;
						newNetwork.dnsTcpConn[i].addr.sin_addr.s_addr = newNetwork.listenServers[j];
						newNetwork.dnsTcpConn[i].addr.sin_port = htons(IPPORT_DNS);

						int nRet = bind(newNetwork.dnsTcpConn[i].sock,
										(sockaddr*)&newNetwork.dnsTcpConn[i].addr,
										sizeof(struct sockaddr_in));

						if (nRet == SOCKET_ERROR)
						{
							bindfailed = true;
							closesocket(newNetwork.dnsTcpConn[i].sock);
							sprintf(logBuff, "Warning: %s TCP Port 53 already in use", IP2String(tempbuff, newNetwork.listenServers[j]));
							logDNSMess(logBuff, 1);
						}
						else
						{
							nRet = listen(newNetwork.dnsTcpConn[i].sock, SOMAXCONN);

							if (nRet == SOCKET_ERROR)
							{
								closesocket(newNetwork.dnsTcpConn[i].sock);
								sprintf(logBuff, "TCP Port 53 Error on Listen");
								logDNSMess(logBuff, 1);
							}
							else
							{
								newNetwork.dnsTcpConn[i].server = newNetwork.listenServers[j];
								newNetwork.dnsTcpConn[i].port = IPPORT_DNS;

								newNetwork.dnsTcpConn[i].loaded = true;
								newNetwork.dnsTcpConn[i].ready = true;

								if (newNetwork.maxFD < newNetwork.dnsTcpConn[i].sock)
									newNetwork.maxFD = newNetwork.dnsTcpConn[i].sock;

								i++;
							}
						}
					}
				}
			}
		}

		newNetwork.maxFD++;

		if (dhcpService)
		{
			for (MYBYTE m = 0; m < MAX_SERVERS && newNetwork.allServers[m]; m++)
				lockIP(newNetwork.allServers[m]);

			for (MYBYTE m = 0; m < MAX_SERVERS && newNetwork.dns[m]; m++)
				lockIP(newNetwork.dns[m]);
		}

		if (bindfailed)
			cfig.failureCount++;
		else
			cfig.failureCount = 0;

		closeConn();
		memcpy(&network, &newNetwork, sizeof(data1));

		//printf("%i %i %i\n", network.dhcpConn[0].ready, network.dnsUdpConn[0].ready, network.dnsTcpConn[0].ready);

		if ((dhcpService && !network.dhcpConn[0].ready) || (dnsService && !(network.dnsUdpConn[0].ready && network.dnsTcpConn[0].ready)))
		{
			sprintf(logBuff, "No Static Interface ready, Waiting...");
			logMess(logBuff, 1);
			continue;
		}

		if (dhcpService && network.httpConn.ready)
		{
			sprintf(logBuff, "Lease Status URL: http://%s:%u", IP2String(tempbuff, network.httpConn.server), network.httpConn.port);
			logMess(logBuff, 1);
		}

		for (int i = 0; i < MAX_SERVERS && network.staticServers[i]; i++)
		{
			for (MYBYTE j = 0; j < MAX_SERVERS; j++)
			{
				if (network.dhcpConn[j].server == network.staticServers[i] || network.dnsUdpConn[j].server == network.staticServers[i])
				{
					sprintf(logBuff, "Listening On: %s", IP2String(tempbuff, network.staticServers[i]));
					logMess(logBuff, 1);
					break;
				}
			}
		}

		network.ready = true;

	} while (detectChange());

	pthread_exit(NULL);
}

bool detectChange()
{
	//printf("Entering detectchange\n");

    while (kRunning)
    {
		sleep(20);
		//printf("Checking Networks (failue count=%u, failue cycle=%u)..\n", cfig.failureCount, cfig.failureCycle);

		if (!cfig.ifspecified)
			getInterfaces(&newNetwork);

		if (memcmp(cfig.oldservers, newNetwork.staticServers, (MAX_SERVERS * sizeof(MYDWORD))))
		{
			memcpy(cfig.oldservers, newNetwork.staticServers, (MAX_SERVERS * sizeof(MYDWORD)));
			sprintf(logBuff, "Network changed, re-detecting Listening Interfaces..");
			logMess(logBuff, 1);
			break;
		}
		else if (cfig.failureCount)
		{
			cfig.failureCycle++;

			if (kRunning && cfig.failureCycle == (MYDWORD)pow(2, cfig.failureCount))
			{
				sprintf(logBuff, "Retrying failed Listening Interfaces..");
				logMess(logBuff, 1);
				break;
			}
		}
		else
			cfig.failureCycle = 0;
	}

	network.ready = false;

	while (kRunning && network.busy)
		sleep(1);

	//printf("Returning from detectchange\n");

	if (kRunning)
		return true;
	else
		return false;
}

void getInterfaces(data1 *network)
{
	memset(network, 0, sizeof(data1));

	Ifc.ifc_len = sizeof(IfcBuf);
	Ifc.ifc_buf = (char*)IfcBuf;

	if (ioctl(cfig.fixedSocket, SIOCGIFCONF, &Ifc) >= 0)
	{

		MYDWORD addr, mask;
		short flags;
		struct ifreq pIfr;
		MYBYTE numInterfaces = Ifc.ifc_len / sizeof(ifreq);

		for (MYBYTE i = 0 ; i < numInterfaces; i++)
		{
			memcpy(&pIfr, &(IfcBuf[i]), sizeof(ifreq));

			if (!ioctl(cfig.fixedSocket, SIOCGIFADDR, &pIfr))
				addr = ((struct sockaddr_in*)&pIfr.ifr_addr)->sin_addr.s_addr;
			else
				addr = 0;

			if (!ioctl(cfig.fixedSocket, SIOCGIFNETMASK, &pIfr))
				mask = ((struct sockaddr_in*)&pIfr.ifr_addr)->sin_addr.s_addr;
			else
				mask = 0;

			if (!ioctl(cfig.fixedSocket, SIOCGIFFLAGS, &pIfr))
				flags = pIfr.ifr_flags;
			else
				flags = 0;


			if (addr && !(flags & IFF_LOOPBACK))
				addServer(network->allServers, MAX_SERVERS, addr);

			if (addr && mask && !(flags & IFF_POINTOPOINT) && !(flags & IFF_LOOPBACK) && !(flags & IFF_DYNAMIC))
			{
				if ((flags & IFF_RUNNING) && (flags & IFF_UP))
				{
					for (MYBYTE m = 0; m < MAX_SERVERS; m++)
					{
						if (network->staticServers[m] == addr)
							break;
						else if (!network->staticServers[m])
						{
							network->staticServers[m] = addr;
							network->staticMasks[m] = mask;
							//memcpy(network->staticNames[m], pIfr.ifr_name, IF_NAMESIZE);
							break;
						}
					}
				}
			}
		}
    }

    MYDWORD dservers[MAX_SERVERS];

    for (int i = 0; i < MAX_SERVERS; i++)
        dservers[i] = 0;

	if (FILE *f = openSection("FORWARDING_SERVERS", 1))
	{
		char raw[512];

		while (readSection(raw, f))
		{
        	int i = 0;

        	if (i < MAX_SERVERS)
			{
				MYDWORD addr = inet_addr(raw);

				if (addr && addr != INADDR_NONE)
				{
					if (addServer(dservers, MAX_SERVERS, addr))
						i++;
				}
				else
				{
					sprintf(logBuff, "Warning Section [FORWARDING_SERVERS], Invalid DNS Server %s", raw);
					logDNSMess(logBuff, 1);
				}
			}
		}
    }

	if (!cfig.zone[0])
	{
		getdomainname(cfig.zone, sizeof(cfig.zone));
		cfig.zLen = strlen(cfig.zone);
	}

    if (!dservers[0])
    {
        FILE *f = fopen("/etc/resolv.conf", "rt");
        char buff[256];
        MYDWORD addr;

        while (f && fgets(buff, 255, f))
        {
			myTokenize(buff, buff, NULL, true);

            if (!strcasecmp(myGetToken(buff, 0), "nameserver"))
            {
                MYDWORD addr = inet_addr(myGetToken(buff, 1));
                addServer(dservers, MAX_SERVERS, addr);
            }
            else if (!strcasecmp(myGetToken(buff, 0), "search"))
            {
				if (!strncmp(cfig.zone, "(none)", 6) || !cfig.zone[0])
				{
					strcpy(cfig.zone, myGetToken(buff, 1));
					cfig.zLen = strlen(cfig.zone);
				}
			}
        }

        if (f)
            fclose(f);
    }

    gethostname(cfig.servername, sizeof(cfig.servername));
	char *ptr = strchr(cfig.servername, '.');

	if (ptr)
	{
		*ptr = 0;

		if (!strncmp(cfig.zone, "(none)", 6) || !cfig.zone[0])
		{
			ptr++;
			strcpy(cfig.zone, ptr);
			cfig.zLen = strlen(cfig.zone);
		}
	}

	if (!strncmp(cfig.zone, "(none)", 6) || !cfig.zone[0])
	{
		strcpy(cfig.zone, "workgroup");
		cfig.zLen = strlen(cfig.zone);
	}

    for (int i = 0; i < MAX_SERVERS && dservers[i]; i++)
    {
        if (dnsService)
        {
            if (findServer(network->staticServers, MAX_SERVERS, dservers[i]))
                continue;

            addServer(network->dns, MAX_SERVERS, dservers[i]);
        }
        else
            addServer(network->dns, MAX_SERVERS, dservers[i]);
    }
    return;
}

void *updateStateFile(void *lparam)
{
	data8 *dhcpData = (data8*)lparam;

	pthread_mutex_lock( &mutStateFile );

	if (dhcpData->dhcpInd)
	{
		FILE *f = fopen(leaFile, "rb+");
		if (f)
		{
			if (fseek(f, (dhcpData->dhcpInd - 1)*sizeof(data8), SEEK_SET) >= 0)
			{
				fwrite(dhcpData, sizeof(data8), 1, f);
			}
			fclose(f);
		}
	}
	else
	{
		dhcpData->dhcpInd = cfig.dhcpInd;

		FILE *f = fopen(leaFile, "ab");
		if (f)
		{
			fwrite(dhcpData, sizeof(data8), 1, f);
			fclose(f);
		}
	}

	free(dhcpData);
	pthread_mutex_unlock( &mutStateFile );
	pthread_exit(NULL);
}

MYWORD gdmess(data9 *req, MYBYTE sockInd)
{
    //sprintf(logBuff, "Socket=%u", sockInd);
	//logMess(logBuff, 1);
    memset(req, 0, sizeof(data9));
    errno = 0;

    if (sockInd == 255)
    {
        int msgflags = 0;
        req->iov[0].iov_base = req->raw;
        req->iov[0].iov_len = sizeof(dhcp_packet);
        req->msg.msg_iov = req->iov;
        req->msg.msg_iovlen = 1;
        req->msg.msg_name = &req->remote;
        req->msg.msg_namelen = sizeof(sockaddr_in);
        req->msg.msg_control = &req->msgcontrol;
        req->msg.msg_controllen = sizeof(msg_control);
        req->msg.msg_flags = msgflags;

        int flags = 0;
        req->bytes = recvmsg(network.dhcpListener.sock, &req->msg, flags);

        if (errno || req->bytes <= 0)
            return 0;

        //printf("%u\n", req->msg.msg_controllen);
        //msgcontrol = (msg_control*)msg.msg_control;

        //struct in_addr local_addr;
        //struct in_addr rem_addr;

        //local_addr = msgcontrol->pktinfo.ipi_addr;
        //rem_addr = msgcontrol->pktinfo.ipi_spec_dst;

        //printf("IF = %u\n", req->msgcontrol.pktinfo.ipi_ifindex);
        //printf("LADDR = %s\n", inet_ntoa(req->msgcontrol.pktinfo.ipi_addr));
        //printf("RADDR = %s\n", inet_ntoa(req->msgcontrol.   pktinfo.ipi_spec_dst));


        MYDWORD addr = req->msgcontrol.pktinfo.ipi_spec_dst.s_addr;

        //printf("%s\n",IP2String(tempbuff, addr));

        if (!addr)
            return 0;

        for (int i = 0; ; i++)
        {
            if (i == MAX_SERVERS || !network.dhcpConn[i].server)
                return 0;
            else if (addr == network.dhcpConn[i].server)
            {
                req->sockInd = i;
                break;
            }
        }
    }
    else
    {
        req->sockInd = sockInd;
        req->sockLen = sizeof(req->remote);
        errno = 0;

        req->bytes = recvfrom(network.dhcpConn[sockInd].sock,
                              req->raw,
                              sizeof(dhcp_packet),
                              0,
                              (sockaddr*)&req->remote,
                              &req->sockLen);

        if (errno || req->bytes <= 0)
            return 0;
    }

	if (req->dhcpp.header.bp_op != BOOTP_REQUEST)
		return 0;

	hex2String(req->chaddr, req->dhcpp.header.bp_chaddr, req->dhcpp.header.bp_hlen);

	data3 *op;
	MYBYTE *raw = req->dhcpp.vend_data;
	MYBYTE *rawEnd = raw + (req->bytes - sizeof(dhcp_header));

	for (; raw < rawEnd && *raw != DHCP_OPTION_END;)
	{
		op = (data3*)raw;
		//printf("OpCode=%u,MessType=%u\n", op->opt_code, op->value[0]);

		switch (op->opt_code)
		{
			case DHCP_OPTION_PAD:
				raw++;
				continue;

			case DHCP_OPTION_PARAMREQLIST:
				for (int ix = 0; ix < op->size; ix++)
					req->paramreqlist[op->value[ix]] = 1;
				break;

			case DHCP_OPTION_MESSAGETYPE:
				req->req_type = op->value[0];
				break;

			case DHCP_OPTION_SERVERID:
				req->server = fIP(op->value);
				break;

			case DHCP_OPTION_IPADDRLEASE:
				req->lease = fULong(op->value);
				break;

			case DHCP_OPTION_MAXDHCPMSGSIZE:
				req->messsize = fUShort(op->value);
				break;

			case DHCP_OPTION_REQUESTEDIPADDR:
				req->reqIP = fIP(op->value);
				break;

			case DHCP_OPTION_HOSTNAME:
				if (op->size && strcasecmp((char*)op->value, "(none)") && strcasecmp((char*)op->value, cfig.servername))
				{
					memcpy(req->hostname, op->value, op->size);
					req->hostname[op->size] = 0;

					if (char *ptr = strchr(req->hostname, '.'))
						*ptr = 0;
				}
				break;

			case DHCP_OPTION_VENDORCLASSID:
				memcpy(&req->vendClass, op, op->size + 2);
				break;

			case DHCP_OPTION_USERCLASS:
				memcpy(&req->userClass, op, op->size + 2);
				break;

			case DHCP_OPTION_RELAYAGENTINFO:
				memcpy(&req->agentOption, op, op->size + 2);
				break;

			case DHCP_OPTION_CLIENTID:
				memcpy(&req->clientId, op, op->size + 2);
				break;

			case DHCP_OPTION_SUBNETSELECTION:
				memcpy(&req->subnet, op, op->size + 2);
				req->subnetIP = fULong(op->value);
				break;

			case DHCP_OPTION_DNS:
				req->dns = fULong(op->value);
				break;

			case DHCP_OPTION_REBINDINGTIME:
				req->rebind = fULong(op->value);
				break;
		}
		raw += 2;
		raw += op->size;
	}

	if (!req->subnetIP)
	{
		if (req->dhcpp.header.bp_giaddr)
			req->subnetIP = req->dhcpp.header.bp_giaddr;
		else
			req->subnetIP = network.dhcpConn[req->sockInd].server;
	}

	if (!req->messsize)
	{
		if (req->req_type == DHCP_MESS_NONE)
			req->messsize = req->bytes;
		else
			req->messsize = sizeof(dhcp_packet);
	}

	if (verbatim || cfig.dhcpLogLevel >= 2)
	{
		if (req->req_type == DHCP_MESS_NONE)
		{
			if (req->dhcpp.header.bp_giaddr)
				sprintf(logBuff, "BOOTPREQUEST for %s (%s) from RelayAgent %s received", req->chaddr, req->hostname, IP2String(tempbuff, req->dhcpp.header.bp_giaddr));
			else
				sprintf(logBuff, "BOOTPREQUEST for %s (%s) from interface %s received", req->chaddr, req->hostname, IP2String(tempbuff, network.dhcpConn[req->sockInd].server));

			logMess(logBuff, 2);
		}
		else if (req->req_type == DHCP_MESS_DISCOVER)
		{
			if (req->dhcpp.header.bp_giaddr)
				sprintf(logBuff, "DHCPDISCOVER for %s (%s) from RelayAgent %s received", req->chaddr, req->hostname, IP2String(tempbuff, req->dhcpp.header.bp_giaddr));
			else
				sprintf(logBuff, "DHCPDISCOVER for %s (%s) from interface %s received", req->chaddr, req->hostname, IP2String(tempbuff, network.dhcpConn[req->sockInd].server));

			logMess(logBuff, 2);
		}
		else if (req->req_type == DHCP_MESS_REQUEST)
		{
			if (req->dhcpp.header.bp_giaddr)
				sprintf(logBuff, "DHCPREQUEST for %s (%s) from RelayAgent %s received", req->chaddr, req->hostname, IP2String(tempbuff, req->dhcpp.header.bp_giaddr));
			else
				sprintf(logBuff, "DHCPREQUEST for %s (%s) from interface %s received", req->chaddr, req->hostname, IP2String(tempbuff, network.dhcpConn[req->sockInd].server));

			logMess(logBuff, 2);
		}
	}

	req->vp = req->dhcpp.vend_data;
	memset(req->vp, 0, sizeof(dhcp_packet) - sizeof(dhcp_header));
	//printf("end bytes=%u\n", req->bytes);
	return 1;
}

void debug(const char *mess)
{
	char t[254];
	strcpy(t, mess);
	logMess(t, 1);
}

void *logThread(void *lpParam)
{
	char *mess = (char*)lpParam;
	pthread_mutex_lock( &mutLogFile );
	tm *ttm = localtime(&t);
	char buffer[256];
	strftime(buffer, sizeof(buffer), logFile, ttm);

	if (strcmp(cfig.logFileName, buffer))
	{
		if (cfig.logFileName[0])
		{
			FILE *f = fopen(cfig.logFileName, "at");

			if (f)
			{
				fprintf(f, "Logging Continued on file %s\n", buffer);
				fclose(f);
			}

			strcpy(cfig.logFileName, buffer);
			f = fopen(cfig.logFileName, "at");

			if (f)
			{
				fprintf(f, "%s\n\n", sVersion);
				fclose(f);
			}
		}

		strcpy(cfig.logFileName, buffer);
	}

	FILE *f = fopen(cfig.logFileName, "at");

	if (f)
	{
		strftime(buffer, sizeof(buffer), "%d-%b-%y %X", ttm);
		fprintf(f, "[%s] %s\n", buffer, mess);
		fclose(f);
	}
	else if (verbatim)
	{
		printf("Failed top open log file %s", cfig.logFileName);
		cfig.dhcpLogLevel = 0;
	}
	else
	{
		syslog(LOG_MAKEPRI(LOG_LOCAL1, LOG_CRIT), "Failed top open log file %s", cfig.logFileName);
		cfig.dhcpLogLevel = 0;
	}

	free(mess);
	pthread_mutex_unlock( &mutLogFile );
	pthread_exit(NULL);

}

void logMess(char *logBuff, MYBYTE logLevel)
{
	if (verbatim)
		printf("%s\n", logBuff);

	if (logFile[0] && (logLevel <= cfig.dnsLogLevel || logLevel <= cfig.dhcpLogLevel))
	{
		char *mess = cloneString(logBuff);
		pthread_t threadId;
		pthread_attr_t attr;
		pthread_attr_init(&attr);
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		int errcode = pthread_create(&threadId, &attr, logThread, mess);
		pthread_attr_destroy(&attr);
	}
}

void logDNSMess(char *logBuff, MYBYTE logLevel)
{
	if (verbatim)
		printf("%s\n", logBuff);

	if (logFile[0] && logLevel <= cfig.dnsLogLevel)
	{
		char *mess = cloneString(logBuff);
		pthread_t threadId;
		pthread_attr_t attr;
		pthread_attr_init(&attr);
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		int errcode = pthread_create(&threadId, &attr, logThread, mess);
		pthread_attr_destroy(&attr);
	}
}

void logDNSMess(data5 *req, char *logBuff, MYBYTE logLevel)
{
	if (verbatim)
		printf("%s\n", logBuff);

	if (logFile[0] && logLevel <= cfig.dnsLogLevel)
	{
		char *mess = (char*)calloc(1, 512);
		sprintf(mess, "Client %s, %s", inet_ntoa(req->remote.sin_addr), logBuff);
		pthread_t threadId;
		pthread_attr_t attr;
		pthread_attr_init(&attr);
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		int errcode = pthread_create(&threadId, &attr, logThread, mess);
		pthread_attr_destroy(&attr);
	}
}

void logTCPMess(data5 *req, char *logBuff, MYBYTE logLevel)
{
	if (verbatim)
		printf("%s\n", logBuff);

	if (logFile[0] && logLevel <= cfig.dnsLogLevel)
	{
		char *mess = (char*)calloc(1, 512);
		sprintf(mess, "TCP Client %s, %s", inet_ntoa(req->remote.sin_addr), logBuff);
		pthread_t threadId;
		pthread_attr_t attr;
		pthread_attr_init(&attr);
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		int errcode = pthread_create(&threadId, &attr, logThread, mess);
		pthread_attr_destroy(&attr);
	}
}
